var require = meteorInstall({"server":{"lib":{"constants.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/lib/constants.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                           // 18
SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                             // 19
SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function setMaintenanceMessage(params) {                                                      // 12
    checkAuth(undefined);                                                                                              // 13
    check(params, maintenanceMessageShape);                                                                            // 14
    var db = this.connection.sandstormDb;                                                                              // 15
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                                 // 17
    db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                   // 18
    db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                     // 19
  }                                                                                                                    // 20
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String                                                                                             // 10
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 13
  setPersonalizationSettings: function setPersonalizationSettings(params) {                                            // 14
    checkAuth(undefined);                                                                                              // 15
    check(params, personalizationMessageShape);                                                                        // 16
    var db = this.connection.sandstormDb;                                                                              // 17
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                             // 19
    db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                                 // 20
    db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                           // 21
    db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                          // 22
    db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                         // 23
  }                                                                                                                    // 24
});                                                                                                                    // 13
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 7
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 8
};                                                                                                                     // 9
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 13
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 14
                                                                                                                       //
Meteor.methods({                                                                                                       // 16
  adminGetServerLogDownloadToken: function adminGetServerLogDownloadToken() {                                          // 17
    var db = this.connection.sandstormDb;                                                                              // 18
    if (!db.isAdminById(this.userId)) {                                                                                // 19
      throw new Meteor.Error(403, "User must be admin to download system log.");                                       // 20
    }                                                                                                                  // 21
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 23
    SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                    // 24
    setTimeout(function () {                                                                                           // 25
      if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                         // 26
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                      // 27
      }                                                                                                                // 28
    }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                               // 29
    return token;                                                                                                      // 30
  }                                                                                                                    // 31
});                                                                                                                    // 16
                                                                                                                       //
Router.map(function () {                                                                                               // 34
  this.route("adminDownloadServerLog", {                                                                               // 35
    where: "server",                                                                                                   // 36
    path: "/admin/status/server-log/:tokenId",                                                                         // 37
    action: function action() {                                                                                        // 38
      var token = this.params.tokenId;                                                                                 // 39
      var response = this.response;                                                                                    // 40
      var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                               // 41
      delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                             // 42
      if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {           // 43
        // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                           //
        // method being called.                                                                                        //
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 47
        return response.end("Invalid server log download token.");                                                     // 48
      }                                                                                                                // 49
                                                                                                                       //
      var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                           // 51
      var fd = Fs.openSync(logFilePath, "r");                                                                          // 52
      var stats = Fs.fstatSync(fd);                                                                                    // 53
      var initialSize = stats.size;                                                                                    // 54
      var readStream = Fs.createReadStream(undefined, {                                                                // 55
        fd: fd,                                                                                                        // 56
        start: 0,                                                                                                      // 57
        end: initialSize                                                                                               // 58
      });                                                                                                              // 55
                                                                                                                       //
      response.writeHead(200, {                                                                                        // 61
        "Content-Length": initialSize,                                                                                 // 62
        "Content-Type": "text/plain",                                                                                  // 63
        "content-Disposition": "attachment;filename=\"sandstorm.log\""                                                 // 64
      });                                                                                                              // 61
      readStream.pipe(response);                                                                                       // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 35
});                                                                                                                    // 69
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 71
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 74
  if (!db.isAdminById(this.userId)) {                                                                                  // 75
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 76
  }                                                                                                                    // 77
                                                                                                                       //
  var _this = this;                                                                                                    // 79
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 80
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 81
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 83
  var grainIdCount = 0;                                                                                                // 84
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 86
    activeUsers: userIdCount,                                                                                          // 87
    activeGrains: grainIdCount                                                                                         // 88
  });                                                                                                                  // 86
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 91
  var handle = query.observe({                                                                                         // 92
    added: function added(session) {                                                                                   // 93
      var hashedSessionId = hashSessionId(session._id);                                                                // 94
      var changed = {};                                                                                                // 95
                                                                                                                       //
      // Update userId cache.                                                                                          //
      if (session.userId) {                                                                                            // 98
        if (userIdToSessionHashes[session.userId] === undefined) {                                                     // 99
          userIdToSessionHashes[session.userId] = [];                                                                  // 100
          userIdCount = userIdCount + 1;                                                                               // 101
          changed.activeUsers = userIdCount;                                                                           // 102
        }                                                                                                              // 103
                                                                                                                       //
        userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);     // 105
      }                                                                                                                // 107
                                                                                                                       //
      // Update grainId cache.                                                                                         //
      if (grainIdToSessionHashes[session.grainId] === undefined) {                                                     // 110
        grainIdToSessionHashes[session.grainId] = [];                                                                  // 111
        grainIdCount = grainIdCount + 1;                                                                               // 112
        changed.activeGrains = grainIdCount;                                                                           // 113
      }                                                                                                                // 114
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);   // 116
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 119
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 120
      }                                                                                                                // 121
    },                                                                                                                 // 122
    removed: function removed(session) {                                                                               // 124
      var hashedSessionId = hashSessionId(session._id);                                                                // 125
      var changed = {};                                                                                                // 126
                                                                                                                       //
      if (session.userId) {                                                                                            // 128
        userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);     // 129
                                                                                                                       //
        if (userIdToSessionHashes[session.userId].length === 0) {                                                      // 132
          delete userIdToSessionHashes[session.userId];                                                                // 133
          userIdCount = userIdCount - 1;                                                                               // 134
          changed.activeUsers = userIdCount;                                                                           // 135
        }                                                                                                              // 136
      }                                                                                                                // 137
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);   // 139
                                                                                                                       //
      if (grainIdToSessionHashes[session.grainId].length === 0) {                                                      // 142
        delete grainIdToSessionHashes[session.grainId];                                                                // 143
        grainIdCount = grainIdCount - 1;                                                                               // 144
        changed.activeGrains = grainIdCount;                                                                           // 145
      }                                                                                                                // 146
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 148
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 149
      }                                                                                                                // 150
    }                                                                                                                  // 151
  });                                                                                                                  // 92
                                                                                                                       //
  this.onStop(function () {                                                                                            // 154
    handle.stop();                                                                                                     // 155
  });                                                                                                                  // 156
  this.ready();                                                                                                        // 157
});                                                                                                                    // 158
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 160
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 163
  if (!db.isAdminById(this.userId)) {                                                                                  // 164
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 165
  }                                                                                                                    // 166
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 168
    expires: {                                                                                                         // 169
      $gt: new Date()                                                                                                  // 170
    },                                                                                                                 // 169
    loginIdentities: {                                                                                                 // 172
      $exists: true                                                                                                    // 173
    }                                                                                                                  // 172
  }, {                                                                                                                 // 168
    expires: 1,                                                                                                        // 176
    loginIdentities: 1                                                                                                 // 177
  });                                                                                                                  // 175
});                                                                                                                    // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Promise = Npm.require("es6-promise").Promise;                                                                      // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Url = Npm.require("url");                                                                                          // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 23
                                                                                                                       //
WrappedUiView = function () {                                                                                          // 25
  function WrappedUiView(token, proxy) {                                                                               // 26
    _classCallCheck(this, WrappedUiView);                                                                              // 26
                                                                                                                       //
    // TODO(someday): handle the fact that these proxies will be garbage collected every 2 minutes,                    //
    // even if it's in use.                                                                                            //
    this.token = token;                                                                                                // 29
    this.proxy = proxy;                                                                                                // 30
  }                                                                                                                    // 31
                                                                                                                       //
  WrappedUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams, retryCount) {
    if (sessionType !== ApiSession.typeId) {                                                                           // 34
      throw new Error("SessionType must be ApiSession.");                                                              // 35
    }                                                                                                                  // 36
                                                                                                                       //
    retryCount = retryCount || 0;                                                                                      // 38
    var _this = this;                                                                                                  // 39
                                                                                                                       //
    return this.proxy.keepAlive().then(function () {                                                                   // 41
      // ignore the passed userInfo and instead use the one associated with this                                       //
      // token TODO(someday): Merge / intersect the two userInfo objects                                               //
      // (especially permissions) rather than only taking the token's user info.                                       //
      // This will allow the caller to request only a subset of the permissions                                        //
      // granted by the token, which is useful to protect against bugs.                                                //
      var session = _this.proxy.uiView.newSession(_this.proxy.userInfo, context, sessionType, sessionParams).session;  // 47
      return { session: session };                                                                                     // 49
    })["catch"](function (error) {                                                                                     // 50
      return _this.proxy.maybeRetryAfterError(error, retryCount).then(function () {                                    // 51
        return _this.newSession(userInfo, context, sessionType, sessionParams, retryCount + 1);                        // 52
      });                                                                                                              // 53
    });                                                                                                                // 54
  };                                                                                                                   // 55
                                                                                                                       //
  return WrappedUiView;                                                                                                // 25
}();                                                                                                                   // 25
                                                                                                                       //
getWrappedUiViewForToken = function getWrappedUiViewForToken(token) {                                                  // 58
  var proxyPromise = getProxyForApiToken(token);                                                                       // 59
                                                                                                                       //
  return proxyPromise.then(function (proxy) {                                                                          // 61
    return { view: new WrappedUiView(token, proxy) };                                                                  // 62
  });                                                                                                                  // 63
};                                                                                                                     // 64
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 66
  function ExternalUiView(url, grainId, token) {                                                                       // 67
    _classCallCheck(this, ExternalUiView);                                                                             // 67
                                                                                                                       //
    this.url = url;                                                                                                    // 68
    this.grainId = grainId;                                                                                            // 69
    this.token = token;                                                                                                // 70
  }                                                                                                                    // 71
                                                                                                                       //
  ExternalUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams) {           // 66
    if (sessionType !== ApiSession.typeId) {                                                                           // 74
      throw new Error("SessionType must be ApiSession.");                                                              // 75
    }                                                                                                                  // 76
                                                                                                                       //
    var options = {};                                                                                                  // 78
                                                                                                                       //
    if (this.token) {                                                                                                  // 80
      options.headers = {                                                                                              // 81
        authorization: "Bearer " + this.token                                                                          // 82
      };                                                                                                               // 81
    }                                                                                                                  // 84
                                                                                                                       //
    return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };     // 86
  };                                                                                                                   // 87
                                                                                                                       //
  return ExternalUiView;                                                                                               // 66
}();                                                                                                                   // 66
                                                                                                                       //
var responseCodes = {                                                                                                  // 90
  200: { type: "content", code: "ok" },                                                                                // 91
  201: { type: "content", code: "created" },                                                                           // 92
  202: { type: "content", code: "accepted" },                                                                          // 93
  204: { type: "noContent", shouldResetForm: false },                                                                  // 94
  205: { type: "noContent", shouldResetForm: true },                                                                   // 95
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 100
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 101
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 102
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 107
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 108
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 109
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 110
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 111
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 112
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 113
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 114
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 115
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 117
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 118
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 119
  500: { type: "serverError" },                                                                                        // 120
  501: { type: "serverError" },                                                                                        // 121
  502: { type: "serverError" },                                                                                        // 122
  503: { type: "serverError" },                                                                                        // 123
  504: { type: "serverError" },                                                                                        // 124
  505: { type: "serverError" }                                                                                         // 125
};                                                                                                                     // 90
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 128
  function ExternalWebSession(url, grainId, options) {                                                                 // 129
    _classCallCheck(this, ExternalWebSession);                                                                         // 129
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 130
    this.host = parsedUrl.hostname;                                                                                    // 131
    this.port = parsedUrl.port;                                                                                        // 132
    this.protocol = parsedUrl.protocol;                                                                                // 133
    this.grainId = grainId;                                                                                            // 134
    this.options = options || {};                                                                                      // 135
  }                                                                                                                    // 136
                                                                                                                       //
  ExternalWebSession.prototype.get = function get(path, context) {                                                     // 128
    return this._requestHelper("GET", path, context);                                                                  // 139
  };                                                                                                                   // 140
                                                                                                                       //
  ExternalWebSession.prototype.post = function post(path, content, context) {                                          // 128
    return this._requestHelper("POST", path, context, content.content, content.mimeType);                              // 143
  };                                                                                                                   // 144
                                                                                                                       //
  ExternalWebSession.prototype.put = function put(path, content, context) {                                            // 128
    return this._requestHelper("PUT", path, context, content.content, content.mimeType);                               // 147
  };                                                                                                                   // 148
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function _delete(path, context) {                                           // 128
    return this._requestHelper("DELETE", path, context);                                                               // 151
  };                                                                                                                   // 152
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function _requestHelper(method, path, context, content, contentType) {
    var _this = this;                                                                                                  // 165
    var session = _this;                                                                                               // 166
    return new Promise(function (resolve, reject) {                                                                    // 167
      var options = _.clone(session.options);                                                                          // 168
      options.headers = options.headers || {};                                                                         // 169
      options.path = path;                                                                                             // 170
      options.method = method;                                                                                         // 171
      if (contentType) {                                                                                               // 172
        options.headers["content-type"] = contentType;                                                                 // 173
      }                                                                                                                // 174
                                                                                                                       //
      // set accept header                                                                                             //
      if ("accept" in context) {                                                                                       // 177
        options.headers.accept = context.accept.map(function (acceptedType) {                                          // 178
          return acceptedType.mimeType + "; " + acceptedType.qValue;                                                   // 179
        }).join(", ");                                                                                                 // 180
      } else if (!("accept" in options.headers)) {                                                                     // 181
        options.headers.accept = "*/*";                                                                                // 182
      }                                                                                                                // 183
                                                                                                                       //
      // set cookies                                                                                                   //
      if (context.cookies && context.cookies.length > 0) {                                                             // 186
        options.headers.cookies = options.headers.cookies || "";                                                       // 187
        context.cookies.forEach(function (keyVal) {                                                                    // 188
          options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                              // 189
        });                                                                                                            // 190
        options.headers.cookies = options.headers.cookies.slice(0, -1);                                                // 191
      }                                                                                                                // 192
                                                                                                                       //
      options.host = session.host;                                                                                     // 194
      options.port = session.port;                                                                                     // 195
                                                                                                                       //
      var requestMethod = Http.request;                                                                                // 197
      if (session.protocol === "https:") {                                                                             // 198
        requestMethod = Https.request;                                                                                 // 199
      }                                                                                                                // 200
                                                                                                                       //
      req = requestMethod(options, function (resp) {                                                                   // 202
        var buffers = [];                                                                                              // 203
        var statusInfo = responseCodes[resp.statusCode];                                                               // 204
                                                                                                                       //
        var rpcResponse = {};                                                                                          // 206
                                                                                                                       //
        switch (statusInfo.type) {                                                                                     // 208
          case "content":                                                                                              // 209
            resp.on("data", function (buf) {                                                                           // 210
              buffers.push(buf);                                                                                       // 211
            });                                                                                                        // 212
                                                                                                                       //
            resp.on("end", function () {                                                                               // 214
              var content = {};                                                                                        // 215
              rpcResponse.content = content;                                                                           // 216
                                                                                                                       //
              content.statusCode = statusInfo.code;                                                                    // 218
              if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];             // 219
              if ("content-language" in resp.headers) content.language = resp.headers["content-language"];             // 220
              if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                     // 221
              if ("content-disposition" in resp.headers) {                                                             // 222
                var disposition = resp.headers["content-disposition"];                                                 // 223
                var parts = disposition.split(";");                                                                    // 224
                if (parts[0].toLowerCase().trim() === "attachment") {                                                  // 225
                  parts.forEach(function (part) {                                                                      // 226
                    var splitPart = part.split("=");                                                                   // 227
                    if (splitPart[0].toLowerCase().trim() === "filename") {                                            // 228
                      content.disposition = { download: splitPart[1].trim() };                                         // 229
                    }                                                                                                  // 230
                  });                                                                                                  // 231
                }                                                                                                      // 232
              }                                                                                                        // 233
                                                                                                                       //
              content.body = {};                                                                                       // 235
              content.body.bytes = Buffer.concat(buffers);                                                             // 236
                                                                                                                       //
              resolve(rpcResponse);                                                                                    // 238
            });                                                                                                        // 239
            break;                                                                                                     // 240
          case "noContent":                                                                                            // 241
            var noContent = {};                                                                                        // 242
            rpcResponse.noContent = noContent;                                                                         // 243
            noContent.setShouldResetForm = statusInfo.shouldResetForm;                                                 // 244
            resolve(rpcResponse);                                                                                      // 245
            break;                                                                                                     // 246
          case "redirect":                                                                                             // 247
            var redirect = {};                                                                                         // 248
            rpcResponse.redirect = redirect;                                                                           // 249
            redirect.isPermanent = statusInfo.isPermanent;                                                             // 250
            redirect.switchToGet = statusInfo.switchToGet;                                                             // 251
            if ("location" in resp.headers) redirect.location = resp.headers.location;                                 // 252
            resolve(rpcResponse);                                                                                      // 253
            break;                                                                                                     // 254
          case "clientError":                                                                                          // 255
            var clientError = {};                                                                                      // 256
            rpcResponse.clientError = clientError;                                                                     // 257
            clientError.statusCode = statusInfo.clientErrorCode;                                                       // 258
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 259
            resolve(rpcResponse);                                                                                      // 260
            break;                                                                                                     // 261
          case "serverError":                                                                                          // 262
            var serverError = {};                                                                                      // 263
            rpcResponse.serverError = serverError;                                                                     // 264
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 265
            resolve(rpcResponse);                                                                                      // 266
            break;                                                                                                     // 267
          default:                                                                                                     // 268
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 269
            reject(err);                                                                                               // 270
            break;                                                                                                     // 271
        }                                                                                                              // 208
      });                                                                                                              // 273
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 275
        reject(e);                                                                                                     // 276
      });                                                                                                              // 277
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 279
        req.abort();                                                                                                   // 280
        err = new Error("Request timed out.");                                                                         // 281
        err.kjType = "overloaded";                                                                                     // 282
        reject(err);                                                                                                   // 283
      });                                                                                                              // 284
                                                                                                                       //
      if (content) {                                                                                                   // 286
        req.end(content);                                                                                              // 287
      } else {                                                                                                         // 288
        req.end();                                                                                                     // 289
      }                                                                                                                // 290
    });                                                                                                                // 291
  };                                                                                                                   // 292
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 128
}();                                                                                                                   // 128
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/classCallCheck","bignum",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Net = Npm.require("net");                                                                                          // 19
var Dgram = Npm.require("dgram");                                                                                      // 20
var Promise = Npm.require("es6-promise").Promise;                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 24
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 26
  function ByteStreamConnection(connection) {                                                                          // 27
    _classCallCheck(this, ByteStreamConnection);                                                                       // 27
                                                                                                                       //
    this.connection = connection;                                                                                      // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ByteStreamConnection.prototype.done = function done() {                                                              // 26
    this.connection.end();                                                                                             // 32
  };                                                                                                                   // 33
                                                                                                                       //
  ByteStreamConnection.prototype.write = function write(data) {                                                        // 26
    this.connection.write(data);                                                                                       // 36
  };                                                                                                                   // 37
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 26
}();                                                                                                                   // 26
                                                                                                                       //
IpInterfaceImpl = function () {                                                                                        // 43
  function IpInterfaceImpl(persistentMethods) {                                                                        // 44
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 44
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 45
  }                                                                                                                    // 46
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function listenTcp(portNum, port) {                                            // 43
    return new Promise(function (resolve, reject) {                                                                    // 49
      var resolved = false;                                                                                            // 50
      var server = Net.createServer(function (connection) {                                                            // 51
        var wrappedConnection = new ByteStreamConnection(connection);                                                  // 52
        var upstream = port.connect(wrappedConnection).upstream;                                                       // 53
                                                                                                                       //
        connection.on("data", function (data) {                                                                        // 55
          upstream.write(data);                                                                                        // 56
        });                                                                                                            // 57
                                                                                                                       //
        connection.on("close", function (hadError) {                                                                   // 59
          upstream.done();                                                                                             // 60
        });                                                                                                            // 61
                                                                                                                       //
        connection.on("error", function (err) {                                                                        // 63
          if (resolved) {                                                                                              // 64
            connection.write = errorWrite;                                                                             // 65
          } else {                                                                                                     // 66
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 68
          }                                                                                                            // 69
        });                                                                                                            // 70
      });                                                                                                              // 71
                                                                                                                       //
      server.listen(portNum, function () {                                                                             // 73
        resolved = true;                                                                                               // 74
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 75
      });                                                                                                              // 76
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 78
        if (!resolved) {                                                                                               // 79
          reject(err);                                                                                                 // 80
        }                                                                                                              // 81
      });                                                                                                              // 82
    });                                                                                                                // 83
  };                                                                                                                   // 84
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function listenUdp(portNum, port) {                                            // 43
    return new Promise(function (resolve, reject) {                                                                    // 87
      var portMap = {};                                                                                                // 88
      var resolved = false;                                                                                            // 89
      var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                               // 90
      server.bind(portNum);                                                                                            // 91
                                                                                                                       //
      server.on("listening", function () {                                                                             // 93
        // Although UDP is connectionless, we don't resolve until here so that we can handle bind                      //
        // errors such as invalid host                                                                                 //
        resolved = true;                                                                                               // 96
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 97
      });                                                                                                              // 98
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 100
        // TODO(someday): do something about errors after the promise is resolved                                      //
        if (!resolved) {                                                                                               // 102
          reject(err);                                                                                                 // 103
        } else {                                                                                                       // 104
          console.error("error in listenUdp: " + err);                                                                 // 105
        }                                                                                                              // 106
      });                                                                                                              // 107
                                                                                                                       //
      var returnMap = {};                                                                                              // 109
      server.on("message", function (msg, rinfo) {                                                                     // 110
        var address = rinfo.address + "]:" + rinfo.port;                                                               // 111
        var returnPort = returnMap[address];                                                                           // 112
                                                                                                                       //
        if (!returnPort) {                                                                                             // 114
          returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                   // 115
        }                                                                                                              // 116
                                                                                                                       //
        port.send(msg, returnPort);                                                                                    // 118
      });                                                                                                              // 119
    });                                                                                                                // 120
  };                                                                                                                   // 121
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              // 43
}();                                                                                                                   // 43
                                                                                                                       //
makeIpInterface = function makeIpInterface(persistentMethods) {                                                        // 124
  return new Capnp.Capability(new IpInterfaceImpl(persistentMethods), IpRpc.PersistentIpInterface);                    // 125
};                                                                                                                     // 126
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 128
  function BoundUdpPortImpl(server, address, port) {                                                                   // 129
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 129
                                                                                                                       //
    this.server = server;                                                                                              // 130
    this.address = address;                                                                                            // 131
    this.port = port;                                                                                                  // 132
  }                                                                                                                    // 133
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function send(message, returnPort) {                                               // 128
    // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                           //
    // capabilities or build a map with them. What we should be doing is mapping all ports to                          //
    // their raw physical address/port, and using that here                                                            //
    this.server.send(message, 0, message.length, this.port, this.address);                                             // 139
  };                                                                                                                   // 140
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 128
}();                                                                                                                   // 128
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 143
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 144
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 146
  var part1 = num & 255;                                                                                               // 147
  var part2 = num >> 8 & 255;                                                                                          // 148
  var part3 = num >> 16 & 255;                                                                                         // 149
  var part4 = num >> 24 & 255;                                                                                         // 150
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 152
};                                                                                                                     // 153
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 155
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 156
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 158
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 160
    return intToIpv4(ipv4num);                                                                                         // 161
  }                                                                                                                    // 162
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 164
  var numColons = 0;                                                                                                   // 165
  var out = "";                                                                                                        // 166
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 168
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 171
    if ((i + 1) % 4 === 0) {                                                                                           // 172
      out += ":";                                                                                                      // 173
      ++numColons;                                                                                                     // 174
    }                                                                                                                  // 175
  }                                                                                                                    // 176
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 179
    out += "::";                                                                                                       // 180
  }                                                                                                                    // 181
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 183
};                                                                                                                     // 184
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 186
  var type = "udp4";                                                                                                   // 187
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 191
    type = "udp6";                                                                                                     // 192
  }                                                                                                                    // 193
                                                                                                                       //
  return type;                                                                                                         // 195
};                                                                                                                     // 196
                                                                                                                       //
IpNetworkImpl = function () {                                                                                          // 198
  function IpNetworkImpl(persistentMethods) {                                                                          // 199
    _classCallCheck(this, IpNetworkImpl);                                                                              // 199
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 200
  }                                                                                                                    // 201
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function getRemoteHost(address) {                                            // 198
    return { host: new IpRemoteHostImpl(address) };                                                                    // 204
  };                                                                                                                   // 205
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function getRemoteHostByName(address) {                                // 198
    return { host: new IpRemoteHostImpl(address) };                                                                    // 208
  };                                                                                                                   // 209
                                                                                                                       //
  return IpNetworkImpl;                                                                                                // 198
}();                                                                                                                   // 198
                                                                                                                       //
makeIpNetwork = function makeIpNetwork(persistentMethods) {                                                            // 212
  return new Capnp.Capability(new IpNetworkImpl(persistentMethods), IpRpc.PersistentIpNetwork);                        // 213
};                                                                                                                     // 214
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 216
  function IpRemoteHostImpl(address) {                                                                                 // 217
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 217
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 218
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 220
    } else {                                                                                                           // 221
      this.address = address;                                                                                          // 222
    }                                                                                                                  // 223
  }                                                                                                                    // 224
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function getTcpPort(portNum) {                                               // 216
    return { port: new TcpPortImpl(this.address, portNum) };                                                           // 227
  };                                                                                                                   // 228
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function getUdpPort(portNum) {                                               // 216
    return { port: new UdpPortImpl(this.address, portNum) };                                                           // 231
  };                                                                                                                   // 232
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             // 216
}();                                                                                                                   // 216
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 235
  function TcpPortImpl(address, portNum) {                                                                             // 236
    _classCallCheck(this, TcpPortImpl);                                                                                // 236
                                                                                                                       //
    this.address = address;                                                                                            // 237
    this.port = portNum;                                                                                               // 238
  }                                                                                                                    // 239
                                                                                                                       //
  TcpPortImpl.prototype.connect = function connect(downstream) {                                                       // 235
    var _this = this;                                                                                                  // 242
    var resolved = false;                                                                                              // 243
    return new Promise(function (resolve, reject) {                                                                    // 244
      var client = Net.connect({ host: _this.address, port: _this.port }, function () {                                // 245
        resolved = true;                                                                                               // 246
        resolve({ upstream: new ByteStreamConnection(client) });                                                       // 247
      });                                                                                                              // 248
                                                                                                                       //
      client.on("data", function (data) {                                                                              // 250
        downstream.write(data);                                                                                        // 251
      });                                                                                                              // 252
                                                                                                                       //
      client.on("close", function (hadError) {                                                                         // 254
        downstream.done();                                                                                             // 255
      });                                                                                                              // 256
                                                                                                                       //
      client.on("error", function (err) {                                                                              // 258
        if (resolved) {                                                                                                // 259
          client.write = errorWrite;                                                                                   // 260
        } else {                                                                                                       // 261
          // upstream hasn't been resolved yet, so it's safe to reject                                                 //
          reject(err);                                                                                                 // 263
        }                                                                                                              // 264
      });                                                                                                              // 265
    });                                                                                                                // 266
  };                                                                                                                   // 267
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 235
}();                                                                                                                   // 235
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 270
  throw new Error("error occurred in connection");                                                                     // 271
};                                                                                                                     // 272
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 274
  function UdpPortImpl(address, portNum) {                                                                             // 275
    _classCallCheck(this, UdpPortImpl);                                                                                // 275
                                                                                                                       //
    this.address = address;                                                                                            // 276
    this.port = portNum;                                                                                               // 277
                                                                                                                       //
    var type = addressType(address);                                                                                   // 279
    this.socket = Dgram.createSocket(type);                                                                            // 280
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 288
                                                                                                                       //
    var _this = this;                                                                                                  // 290
    this.socket.on("message", function (msg, rinfo) {                                                                  // 291
      if (_this.returnPort) {                                                                                          // 292
        _this.returnPort.send(msg, _this);                                                                             // 293
      }                                                                                                                // 294
    });                                                                                                                // 295
  }                                                                                                                    // 296
                                                                                                                       //
  UdpPortImpl.prototype.send = function send(message, returnPort) {                                                    // 274
    this.returnPort = returnPort;                                                                                      // 299
    this.socket.send(message, 0, message.length, this.port, this.address);                                             // 300
                                                                                                                       //
    // TODO(someday): use callback to catch errors and do something with them                                          //
  };                                                                                                                   // 303
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 274
}();                                                                                                                   // 274
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 22
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 23
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 24
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 25
var Supervisor = SupervisorCapnp.Supervisor;                                                                           // 26
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 27
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 28
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 35
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 37
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 43
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 44
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 48
}                                                                                                                      // 49
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 51
  var server = simplesmtp.createSimpleServer({ SMTPBanner: "Sandstorm Mail Server" }, function (req) {                 // 52
    var mailparser = new MailParser();                                                                                 // 53
    req.pipe(mailparser);                                                                                              // 54
                                                                                                                       //
    mailparser.on("end", function (mail) {                                                                             // 56
      // Wrap in outer promise for easier error handling.                                                              //
      Promise.resolve().then(function () {                                                                             // 58
        // Extract the 'from' address.                                                                                 //
        var from = void 0;                                                                                             // 60
        if (mail.from && mail.from.length > 0) {                                                                       // 61
          // It's theoretically possible for the message to have multiple 'from' headers, but this                     //
          // never really happens in legitimate practice so we'll just take the first one.                             //
          from = mail.from[0];                                                                                         // 64
        } else {                                                                                                       // 65
          // The mail body is missing a 'From:' header. We'll use req.from instead. Note that                          //
          // req.from is actually the bounce address, which is sometimes *not* the original sender                     //
          // but rather some intermediate agent (e.g. a mailing list daemon). See:                                     //
          //   http://en.wikipedia.org/wiki/Bounce_address                                                             //
          // TODO(someday): Is this really right, or should we report a blank address instead?                         //
          from = { address: req.from, name: false };                                                                   // 71
        }                                                                                                              // 72
                                                                                                                       //
        var attachments = [];                                                                                          // 74
        if (mail.attachments) {                                                                                        // 75
          attachments = mail.attachments.map(function (attachment) {                                                   // 76
            var disposition = attachment.contentDisposition || "attachment";                                           // 77
            disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';            // 78
            return {                                                                                                   // 79
              contentType: attachment.contentType,                                                                     // 80
              contentDisposition: disposition,                                                                         // 81
              contentId: attachment.contentId,                                                                         // 82
              content: attachment.content                                                                              // 83
            };                                                                                                         // 79
          });                                                                                                          // 85
        }                                                                                                              // 86
                                                                                                                       //
        if (mail.replyTo && mail.replyTo.length > 1) {                                                                 // 88
          console.error("More than one reply-to address address was received in an email.");                           // 89
        }                                                                                                              // 90
                                                                                                                       //
        var mailMessage = {                                                                                            // 92
          // Note that converting the date to nanoseconds actually goes outside the range of                           //
          // integers that Javascript can represent precisely. But this is OK because dates aren't                     //
          // precise anyway.                                                                                           //
          date: (mail.date || new Date()).getTime() * 1000000,                                                         // 96
          from: from,                                                                                                  // 97
          to: mail.to,                                                                                                 // 98
          cc: mail.cc || [],                                                                                           // 99
          bcc: mail.bcc || [],                                                                                         // 100
          replyTo: mail.replyTo && mail.replyTo[0] || {},                                                              // 101
          messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                     // 102
          references: mail.references || [],                                                                           // 103
          inReplyTo: mail.inReplyTo || [],                                                                             // 104
          subject: mail.subject || "",                                                                                 // 105
          text: mail.text || null,                                                                                     // 106
          html: mail.html || null,                                                                                     // 107
          attachments: attachments                                                                                     // 108
        };                                                                                                             // 92
                                                                                                                       //
        // Get list of grain IDs.                                                                                      //
        var grainPublicIds = _.uniq(req.to.map(function (deliverTo) {                                                  // 112
          // simplesmtp already validates that the address contains an @.                                              //
          // To simplify things, we ignore the hostname part of the address and assume that the                        //
          // message would not have been sent here if it weren't intended for our host. Usually                        //
          // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                          //
          // globally unique anyway, so an e-mail meant for another server presumably won't match                      //
          // any ID at this one anyway.                                                                                //
          return deliverTo.slice(0, deliverTo.indexOf("@"));                                                           // 119
        }));                                                                                                           // 120
                                                                                                                       //
        // Deliver to each grain in parallel.                                                                          //
        return Promise.all(grainPublicIds.map(function (publicId) {                                                    // 123
          // Wrap in a function so that we can call it recursively to retry.                                           //
          var tryDeliver = function tryDeliver(retryCount) {                                                           // 125
            var grainId = void 0;                                                                                      // 126
            return inMeteor(function () {                                                                              // 127
              var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                      // 128
              if (grain) {                                                                                             // 129
                grainId = grain._id;                                                                                   // 130
                return globalBackend.continueGrain(grainId, retryCount > 0);                                           // 131
              } else {                                                                                                 // 132
                // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                  //
                //   fails in this case, but simplesmtp doesn't appear to support that.                                //
                throw new Error("No such grain: " + publicId);                                                         // 135
              }                                                                                                        // 136
            }).then(function (grainInfo) {                                                                             // 137
              var supervisor = grainInfo.supervisor;                                                                   // 138
              var uiView = supervisor.getMainView().view;                                                              // 139
                                                                                                                       //
              // Create an arbitrary struct to use as the session params. E-mail sessions actually                     //
              // require no params, but node-capnp won't let us pass null and we don't have an                         //
              // EmptyStruct type available, so we just use EmailAddress, but any struct type would                    //
              // work.                                                                                                 //
              // TODO(cleanup): Fix node-capnp to accept null.                                                         //
              var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                            // 146
                                                                                                                       //
              // Create a new session of type HackEmailSession. This is a short-term hack until                        //
              // persistent capabilities and the Powerbox are implemented. We need to pass along a                     //
              // HackSessionContext because old versions of sandstorm-http-bridge always use                           //
              // the context of the most recent session; if an old RoundCube grain has a                               //
              // WebSession open, receives an email, and then tries to send an email, the request                      //
              // will go out on the SessionContext associated with the HackEmailSession that                           //
              // delivered the email.                                                                                  //
              var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
              return session.send(mailMessage);                                                                        // 159
            })["catch"](function (err) {                                                                               // 160
              if (SandstormBackend.shouldRestartGrain(err, retryCount)) {                                              // 161
                return tryDeliver(retryCount + 1);                                                                     // 162
              } else {                                                                                                 // 163
                throw err;                                                                                             // 164
              }                                                                                                        // 165
            });                                                                                                        // 166
          };                                                                                                           // 167
                                                                                                                       //
          return tryDeliver(0);                                                                                        // 169
        }));                                                                                                           // 170
      }).then(function () {                                                                                            // 171
        req.accept();                                                                                                  // 172
      }, function (err) {                                                                                              // 173
        console.error("E-mail delivery failure:", err.stack);                                                          // 174
        req.reject(err.message);                                                                                       // 175
      });                                                                                                              // 176
    });                                                                                                                // 177
  });                                                                                                                  // 178
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 180
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 181
  } else {                                                                                                             // 182
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 184
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 185
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 186
  }                                                                                                                    // 187
});                                                                                                                    // 188
                                                                                                                       //
function formatAddress(field) {                                                                                        // 190
  if (!field) {                                                                                                        // 191
    return null;                                                                                                       // 192
  }                                                                                                                    // 193
                                                                                                                       //
  if (Array.isArray(field)) {                                                                                          // 195
    return field.map(formatAddress);                                                                                   // 196
  }                                                                                                                    // 197
                                                                                                                       //
  if (field.name) {                                                                                                    // 199
    return field.name + " <" + field.address + ">";                                                                    // 200
  }                                                                                                                    // 201
                                                                                                                       //
  return field.address;                                                                                                // 203
}                                                                                                                      // 204
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 206
  return inMeteor(function () {                                                                                        // 207
    var recipientCount = 0;                                                                                            // 208
    recipientCount += email.to ? email.to.length : 0;                                                                  // 209
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 210
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 211
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 212
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 217
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 219
    var userAddress = session._getUserAddress();                                                                       // 220
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 223
      email.from = {                                                                                                   // 224
        address: grainAddress                                                                                          // 225
      };                                                                                                               // 224
    }                                                                                                                  // 227
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 229
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 233
                                                                                                                       //
    var mc = new MailComposer();                                                                                       // 235
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 237
      from: formatAddress(email.from),                                                                                 // 238
      to: formatAddress(email.to),                                                                                     // 239
      cc: formatAddress(email.cc),                                                                                     // 240
      bcc: formatAddress(email.bcc),                                                                                   // 241
      replyTo: formatAddress(email.replyTo),                                                                           // 242
      subject: email.subject,                                                                                          // 243
      text: email.text,                                                                                                // 244
      html: email.html                                                                                                 // 245
    });                                                                                                                // 237
                                                                                                                       //
    var envelope = mc.getEnvelope();                                                                                   // 248
    envelope.from = grainAddress;                                                                                      // 249
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 251
      envelope: envelope                                                                                               // 252
    });                                                                                                                // 251
                                                                                                                       //
    var headers = {};                                                                                                  // 255
    if (email.messageId) {                                                                                             // 256
      mc.addHeader("message-id", email.messageId);                                                                     // 257
    }                                                                                                                  // 258
                                                                                                                       //
    if (email.references) {                                                                                            // 260
      mc.addHeader("references", email.references);                                                                    // 261
    }                                                                                                                  // 262
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 264
      mc.addHeader("in-reply-to", email.inReplyTo);                                                                    // 265
    }                                                                                                                  // 266
                                                                                                                       //
    if (email.date) {                                                                                                  // 268
      var date = new Date(email.date / 1000000);                                                                       // 269
      if (!isNaN(date.getTime())) {                                                                                    // 270
        // Check to make sure date is valid                                                                            //
        mc.addHeader("date", date.toUTCString());                                                                      // 271
      }                                                                                                                // 272
    }                                                                                                                  // 273
                                                                                                                       //
    if (email.attachments) {                                                                                           // 275
      email.attachments.forEach(function (attachment) {                                                                // 276
        mc.addAttachment({                                                                                             // 277
          cid: attachment.contentId,                                                                                   // 278
          contentType: attachment.contentType,                                                                         // 279
          contentDisposition: attachment.contentDisposition,                                                           // 280
          contents: attachment.content                                                                                 // 281
        });                                                                                                            // 277
      });                                                                                                              // 283
    }                                                                                                                  // 284
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 286
    if (!grain) throw new Error("Grain does not exist.");                                                              // 287
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 288
                                                                                                                       //
    SandstormEmail.rawSend(mc);                                                                                        // 290
  }.bind(_this))["catch"](function (err) {                                                                             // 291
    console.error("Error sending e-mail:", err.stack);                                                                 // 292
    throw err;                                                                                                         // 293
  });                                                                                                                  // 294
};                                                                                                                     // 295
                                                                                                                       //
var EmailVerifierImpl = function () {                                                                                  //
  function EmailVerifierImpl(persistentMethods, id, params) {                                                          // 298
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 298
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 299
    this._id = id;                                                                                                     // 300
    this._services = params.services;                                                                                  // 301
  }                                                                                                                    // 302
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function getId() {                                                               //
    return { id: new Buffer(this._id, "base64") };                                                                     // 305
  };                                                                                                                   // 306
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function verifyEmail(tabId, verification) {                                //
    var _this2 = this;                                                                                                 // 308
                                                                                                                       //
    // For now, we save() the verification and then dig through ApiTokens to find where it leads.                      //
    // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                       //
    //   not available in Javascript yet and even if it were, it wouldn't work in the case where                       //
    //   there are multiple front-end replicas, since the verification could be on a different                         //
    //   replica.                                                                                                      //
    return verification.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                 // 314
      return inMeteor(function () {                                                                                    // 315
        var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                             // 316
        var tokenInfo = ApiTokens.findOne(tokenId);                                                                    // 317
                                                                                                                       //
        // Delete the token now since it's not needed.                                                                 //
        ApiTokens.remove(tokenId);                                                                                     // 320
                                                                                                                       //
        for (;;) {                                                                                                     // 322
          if (!tokenInfo) throw new Error("missing token?");                                                           // 323
          if (!tokenInfo.parentToken) break;                                                                           // 324
          tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                        // 325
        }                                                                                                              // 326
                                                                                                                       //
        if (!tokenInfo.frontendRef || !tokenInfo.frontendRef.verifiedEmail) {                                          // 328
          throw new Error("not a VerifiedEmail capability");                                                           // 329
        }                                                                                                              // 330
                                                                                                                       //
        var verification = tokenInfo.frontendRef.verifiedEmail;                                                        // 332
        if (verification.tabId !== tabId.toString("hex")) {                                                            // 333
          throw new Error("VerifiedEmail is from a different tab");                                                    // 334
        }                                                                                                              // 335
                                                                                                                       //
        if (_this2._services) {                                                                                        // 337
          // Since this verifier is restricted to specific services, only indicate a match if the                      //
          // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                         //
          // match all services, and therefore all VerifiedEmails.)                                                    //
          if (verification.verifierId !== _this2._id) {                                                                // 341
            throw new Error("VerifierEmail is for a different EmailVerifier.");                                        // 342
          }                                                                                                            // 343
        }                                                                                                              // 344
                                                                                                                       //
        return verification.address;                                                                                   // 346
      });                                                                                                              // 347
    });                                                                                                                // 348
  };                                                                                                                   // 349
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 350
                                                                                                                       //
var VerifiedEmailImpl = function VerifiedEmailImpl(persistentMethods, id) {                                            //
  _classCallCheck(this, VerifiedEmailImpl);                                                                            // 353
                                                                                                                       //
  _.extend(this, persistentMethods);                                                                                   // 354
};                                                                                                                     // 355
                                                                                                                       //
makeEmailVerifier = function makeEmailVerifier(persistentMethods, id, params) {                                        // 358
  return new Capnp.Capability(new EmailVerifierImpl(persistentMethods, id, params), EmailImpl.PersistentEmailVerifier);
};                                                                                                                     // 361
                                                                                                                       //
makeVerifiedEmail = function makeVerifiedEmail(persistentMethods) {                                                    // 363
  return new Capnp.Capability(new VerifiedEmailImpl(persistentMethods), EmailImpl.PersistentVerifiedEmail);            // 364
};                                                                                                                     // 366
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","/imports/server/auth.js","heapdump",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 35
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 39
  hostname: String,                                                                                                    // 40
  port: Number,                                                                                                        // 41
  auth: {                                                                                                              // 42
    user: String,                                                                                                      // 43
    pass: String                                                                                                       // 44
  },                                                                                                                   // 42
  returnAddress: String                                                                                                // 46
};                                                                                                                     // 39
                                                                                                                       //
Meteor.methods({                                                                                                       // 49
  setAccountSetting: function setAccountSetting(token, serviceName, value) {                                           // 50
    checkAuth(token);                                                                                                  // 51
    check(serviceName, String);                                                                                        // 52
    check(value, Boolean);                                                                                             // 53
                                                                                                                       //
    // TODO(someday): currently this relies on the fact that an account is tied to a single                            //
    // identity, and thus has only that entry in "services". This will need to be looked at when                       //
    // multiple login methods/identities are allowed for a single account.                                             //
    if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {      // 58
      throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                    // 59
    }                                                                                                                  // 61
                                                                                                                       //
    // Only check configurations for OAuth services.                                                                   //
    var oauthServices = ["google", "github"];                                                                          // 64
    if (value && oauthServices.indexOf(serviceName) != -1) {                                                           // 65
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 66
      var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                              // 67
      if (!config) {                                                                                                   // 68
        throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 71
                                                                                                                       //
      if (!config.clientId || !config.secret) {                                                                        // 73
        throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 76
    }                                                                                                                  // 77
                                                                                                                       //
    Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                                 // 79
    if (value) {                                                                                                       // 80
      Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                    // 81
    }                                                                                                                  // 82
  },                                                                                                                   // 83
                                                                                                                       //
  setSmtpConfig: function setSmtpConfig(token, config) {                                                               // 85
    checkAuth(token);                                                                                                  // 86
    check(config, smtpConfigShape);                                                                                    // 87
                                                                                                                       //
    Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                               // 89
  },                                                                                                                   // 90
                                                                                                                       //
  setSetting: function setSetting(token, name, value) {                                                                // 92
    checkAuth(token);                                                                                                  // 93
    check(name, String);                                                                                               // 94
    check(value, Match.OneOf(null, String, Date, Boolean));                                                            // 95
                                                                                                                       //
    Settings.upsert({ _id: name }, { $set: { value: value } });                                                        // 97
  },                                                                                                                   // 98
                                                                                                                       //
  submitFeatureKey: function submitFeatureKey(token, textBlock) {                                                      // 100
    checkAuth(token);                                                                                                  // 101
    check(textBlock, Match.OneOf(null, String));                                                                       // 102
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 104
                                                                                                                       //
    if (!textBlock) {                                                                                                  // 106
      // Delete the feature key.                                                                                       //
      db.collections.featureKey.remove("currentFeatureKey");                                                           // 108
      return;                                                                                                          // 109
    }                                                                                                                  // 110
                                                                                                                       //
    // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                      //
    var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                     // 113
      return line.length > 0 && line[0] !== "-";                                                                       // 114
    }).value().join("");                                                                                               // 114
                                                                                                                       //
    var buf = new Buffer(featureKeyBase64, "base64");                                                                  // 118
    if (buf.length < 64) {                                                                                             // 119
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 120
    }                                                                                                                  // 121
                                                                                                                       //
    // loadSignedFeatureKey is provided in feature-key.js                                                              //
    var featureKey = loadSignedFeatureKey(buf);                                                                        // 124
    if (!featureKey) {                                                                                                 // 125
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 126
    }                                                                                                                  // 127
                                                                                                                       //
    // Persist the feature key in the database.                                                                        //
    db.collections.featureKey.upsert("currentFeatureKey", {                                                            // 130
      _id: "currentFeatureKey",                                                                                        // 133
      value: buf                                                                                                       // 134
    });                                                                                                                // 132
  },                                                                                                                   // 137
                                                                                                                       //
  saveOrganizationSettings: function saveOrganizationSettings(token, params) {                                         // 139
    checkAuth(token);                                                                                                  // 140
    check(params, {                                                                                                    // 141
      membership: {                                                                                                    // 142
        emailToken: {                                                                                                  // 143
          enabled: Boolean,                                                                                            // 144
          domain: String                                                                                               // 145
        },                                                                                                             // 143
        google: {                                                                                                      // 147
          enabled: Boolean,                                                                                            // 148
          domain: String                                                                                               // 149
        },                                                                                                             // 147
        ldap: {                                                                                                        // 151
          enabled: Boolean                                                                                             // 152
        },                                                                                                             // 151
        saml: {                                                                                                        // 154
          enabled: Boolean                                                                                             // 155
        }                                                                                                              // 154
      },                                                                                                               // 142
      settings: {                                                                                                      // 158
        disallowGuests: Boolean,                                                                                       // 159
        shareContacts: Boolean                                                                                         // 160
      }                                                                                                                // 158
    });                                                                                                                // 141
                                                                                                                       //
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
  },                                                                                                                   // 166
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function adminConfigureLoginService(token, options) {                                    // 168
    checkAuth(token);                                                                                                  // 169
    check(options, Match.ObjectIncluding({ service: String }));                                                        // 170
                                                                                                                       //
    var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                  // 172
                                                                                                                       //
    ServiceConfiguration.configurations.upsert({ service: options.service }, options);                                 // 174
  },                                                                                                                   // 175
                                                                                                                       //
  clearResumeTokensForService: function clearResumeTokensForService(token, serviceName) {                              // 177
    checkAuth(token);                                                                                                  // 178
    check(serviceName, String);                                                                                        // 179
                                                                                                                       //
    var query = {};                                                                                                    // 181
    query["services." + serviceName] = { $exists: true };                                                              // 182
    Meteor.users.find(query).forEach(function (identity) {                                                             // 183
      if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
        Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                   // 186
      }                                                                                                                // 187
                                                                                                                       //
      Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });    // 189
    });                                                                                                                // 191
  },                                                                                                                   // 192
                                                                                                                       //
  adminUpdateUser: function adminUpdateUser(token, userInfo) {                                                         // 194
    checkAuth(token);                                                                                                  // 195
    check(userInfo, {                                                                                                  // 196
      userId: String,                                                                                                  // 197
      signupKey: Boolean,                                                                                              // 198
      isAdmin: Boolean                                                                                                 // 199
    });                                                                                                                // 196
                                                                                                                       //
    var userId = userInfo.userId;                                                                                      // 202
    if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                             // 203
      throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                                // 204
    }                                                                                                                  // 205
                                                                                                                       //
    Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                               // 207
  },                                                                                                                   // 208
                                                                                                                       //
  testSend: function testSend(token, smtpConfig, to) {                                                                 // 210
    checkAuth(token);                                                                                                  // 211
    check(smtpConfig, smtpConfigShape);                                                                                // 212
    check(to, String);                                                                                                 // 213
    var returnAddress = smtpConfig.returnAddress;                                                                      // 210
                                                                                                                       //
    var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                          // 210
                                                                                                                       //
    try {                                                                                                              // 216
      SandstormEmail.send({                                                                                            // 217
        to: to,                                                                                                        // 218
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 219
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 220
        text: "Success! Your outgoing SMTP is working.",                                                               // 221
        smtpConfig: restConfig                                                                                         // 222
      });                                                                                                              // 217
    } catch (e) {                                                                                                      // 224
      // Attempt to give more accurate error messages for a variety of known failure modes,                            //
      // and the actual exception data in the event a user hits a new failure mode.                                    //
      if (e.syscall === "getaddrinfo") {                                                                               // 227
        if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                              // 228
          throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
        }                                                                                                              // 230
      } else if (e.syscall === "connect") {                                                                            // 231
        if (e.code === "ECONNREFUSED") {                                                                               // 232
          throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
        }                                                                                                              // 234
      } else if (e.name === "AuthError") {                                                                             // 235
        throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
      }                                                                                                                // 238
                                                                                                                       //
      throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
    }                                                                                                                  // 241
  },                                                                                                                   // 242
                                                                                                                       //
  createSignupKey: function createSignupKey(token, note, quota) {                                                      // 244
    checkAuth(token);                                                                                                  // 245
    check(note, String);                                                                                               // 246
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 247
                                                                                                                       //
    var key = Random.id();                                                                                             // 249
    var content = { _id: key, used: false, note: note };                                                               // 250
    if (typeof quota === "number") content.quota = quota;                                                              // 251
    SignupKeys.insert(content);                                                                                        // 252
    return key;                                                                                                        // 253
  },                                                                                                                   // 254
                                                                                                                       //
  sendInvites: function sendInvites(token, origin, from, list, subject, message, quota) {                              // 256
    checkAuth(token);                                                                                                  // 257
    check([origin, from, list, subject, message], [String]);                                                           // 258
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 259
                                                                                                                       //
    if (!from.trim()) {                                                                                                // 261
      throw new Meteor.Error(403, "Must enter 'from' address.");                                                       // 262
    }                                                                                                                  // 263
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 265
      throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                       // 266
    }                                                                                                                  // 267
                                                                                                                       //
    this.unblock();                                                                                                    // 269
                                                                                                                       //
    list = list.split("\n");                                                                                           // 271
    for (var i in list) {                                                                                              // 272
      var email = list[i].trim();                                                                                      // 273
                                                                                                                       //
      if (email) {                                                                                                     // 275
        var key = Random.id();                                                                                         // 276
                                                                                                                       //
        var content = {                                                                                                // 278
          _id: key,                                                                                                    // 279
          used: false,                                                                                                 // 280
          note: "E-mail invite to " + email,                                                                           // 281
          email: email,                                                                                                // 282
          definitelySent: false                                                                                        // 283
        };                                                                                                             // 278
        if (typeof quota === "number") content.quota = quota;                                                          // 285
        SignupKeys.insert(content);                                                                                    // 286
        SandstormEmail.send({                                                                                          // 287
          to: email,                                                                                                   // 288
          from: from,                                                                                                  // 289
          envelopeFrom: globalDb.getReturnAddress(),                                                                   // 290
          subject: subject,                                                                                            // 291
          text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                   // 292
        });                                                                                                            // 287
        SignupKeys.update(key, { $set: { definitelySent: true } });                                                    // 294
      }                                                                                                                // 295
    }                                                                                                                  // 296
                                                                                                                       //
    return { sent: true };                                                                                             // 298
  },                                                                                                                   // 299
                                                                                                                       //
  offerIpNetwork: function offerIpNetwork(token) {                                                                     // 301
    checkAuth(token);                                                                                                  // 302
    if (!isAdmin()) {                                                                                                  // 303
      throw new Meteor.Error(403, "Offering IpNetwork is only allowed for logged in users " + "(a token is not sufficient). Please sign in with an admin account");
    }                                                                                                                  // 306
                                                                                                                       //
    var requirements = [{ userIsAdmin: Meteor.userId() }];                                                             // 308
    var sturdyRef = waitPromise(saveFrontendRef({ ipNetwork: true }, { webkey: null }, requirements)).sturdyRef;       // 311
    return ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef;                               // 314
  },                                                                                                                   // 315
                                                                                                                       //
  offerIpInterface: function offerIpInterface(token) {                                                                 // 317
    checkAuth(token);                                                                                                  // 318
    if (!isAdmin()) {                                                                                                  // 319
      throw new Meteor.Error(403, "Offering IpInterface is only allowed for logged in users " + "(a token is not sufficient). Please sign in with an admin account");
    }                                                                                                                  // 322
                                                                                                                       //
    var requirements = [{ userIsAdmin: Meteor.userId() }];                                                             // 324
    var sturdyRef = waitPromise(saveFrontendRef({ ipInterface: true }, { webkey: null }, requirements)).sturdyRef;     // 327
    return ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef;                               // 330
  },                                                                                                                   // 331
                                                                                                                       //
  adminToggleDisableCap: function adminToggleDisableCap(token, capId, value) {                                         // 333
    checkAuth(token);                                                                                                  // 334
    check(capId, String);                                                                                              // 335
    check(value, Boolean);                                                                                             // 336
                                                                                                                       //
    if (value) {                                                                                                       // 338
      ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                   // 339
    } else {                                                                                                           // 340
      ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                  // 341
    }                                                                                                                  // 342
  },                                                                                                                   // 343
                                                                                                                       //
  updateQuotas: function updateQuotas(token, list, quota) {                                                            // 345
    checkAuth(token);                                                                                                  // 346
    check(list, String);                                                                                               // 347
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 348
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 350
      throw new Meteor.Error(400, "Must enter addresses.");                                                            // 351
    }                                                                                                                  // 352
                                                                                                                       //
    var items = list.split("\n");                                                                                      // 354
    var invalid = [];                                                                                                  // 355
    for (var i in items) {                                                                                             // 356
      var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };               // 357
      var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                       // 359
      n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                  // 360
                                                                                                                       //
      if (n < 1) invalid.push(items[i]);                                                                               // 362
    }                                                                                                                  // 363
                                                                                                                       //
    if (invalid.length > 0) {                                                                                          // 365
      throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));        // 366
    }                                                                                                                  // 368
  },                                                                                                                   // 369
                                                                                                                       //
  dismissAdminStatsNotifications: function dismissAdminStatsNotifications(token) {                                     // 371
    checkAuth(token);                                                                                                  // 372
    globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                        // 373
  },                                                                                                                   // 374
                                                                                                                       //
  signUpAsAdmin: function signUpAsAdmin(token) {                                                                       // 376
    check(token, String);                                                                                              // 377
    checkAuth(token);                                                                                                  // 378
    if (!this.userId) {                                                                                                // 379
      throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                           // 380
    }                                                                                                                  // 381
                                                                                                                       //
    if (!Meteor.user().loginIdentities) {                                                                              // 383
      throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                              // 384
    }                                                                                                                  // 385
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                        // 387
    clearAdminToken(token);                                                                                            // 388
  },                                                                                                                   // 389
                                                                                                                       //
  redeemSetupToken: function redeemSetupToken(token) {                                                                 // 391
    // Redeem an admin token into a setup session.                                                                     //
    check(token, String);                                                                                              // 393
    if (tokenIsValid(token)) {                                                                                         // 394
      var sessId = Random.secret();                                                                                    // 395
      var creationDate = new Date();                                                                                   // 396
      var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                               // 397
      this.connection.sandstormDb.collections.setupSession.upsert({                                                    // 398
        _id: "current-session"                                                                                         // 399
      }, {                                                                                                             // 398
        creationDate: creationDate,                                                                                    // 401
        hashedSessionId: hashedSessionId                                                                               // 402
      });                                                                                                              // 400
      // Then, invalidate the token, so one one else can use it.                                                       //
      clearAdminToken(token);                                                                                          // 405
      return sessId;                                                                                                   // 406
    } else {                                                                                                           // 407
      throw new Meteor.Error(401, "Invalid setup token");                                                              // 408
    }                                                                                                                  // 409
  },                                                                                                                   // 410
  heapdump: function heapdump() {                                                                                      // 412
    // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                                 //
    //                                                                                                                 //
    // Call this from the JS console like:                                                                             //
    //   Meteor.call("heapdump");                                                                                      //
                                                                                                                       //
    checkAuth();                                                                                                       // 418
                                                                                                                       //
    // We use /var/log because it's a location in the container to which the front-end is allowed                      //
    // to write.                                                                                                       //
    var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                             // 422
    Heapdump.writeSnapshot(name);                                                                                      // 423
    console.log("Wrote heapdump: /opt/sandstorm" + name);                                                              // 424
    return name;                                                                                                       // 425
  }                                                                                                                    // 426
});                                                                                                                    // 49
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 429
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 432
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 434
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 435
  return Settings.find();                                                                                              // 436
});                                                                                                                    // 437
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 439
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 440
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 441
});                                                                                                                    // 442
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 444
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 445
});                                                                                                                    // 446
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 448
  check(token, String);                                                                                                // 449
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 450
  this.ready();                                                                                                        // 451
});                                                                                                                    // 452
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 454
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 455
  return Meteor.users.find();                                                                                          // 456
});                                                                                                                    // 457
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 459
  var _this2 = this;                                                                                                   // 459
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 460
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 464
  var accountId = userId;                                                                                              // 465
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 467
    if (!identitySubs[identityId]) {                                                                                   // 468
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 471
      return;                                                                                                          // 472
    }                                                                                                                  // 473
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 475
    delete identitySubs[identityId];                                                                                   // 476
    observeHandle.stop();                                                                                              // 477
    _this2.removed("users", identityId);                                                                               // 478
  };                                                                                                                   // 479
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 481
    if (identitySubs[identityId]) {                                                                                    // 482
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 485
      return;                                                                                                          // 486
    }                                                                                                                  // 487
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 489
    var observeHandle = cursor.observe({                                                                               // 490
      added: function added(doc) {                                                                                     // 491
        _this2.added("users", doc._id, doc);                                                                           // 492
      },                                                                                                               // 493
                                                                                                                       //
      changed: function changed(newDoc, oldDoc) {                                                                      // 495
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 496
      },                                                                                                               // 497
                                                                                                                       //
      removed: function removed(oldDoc) {                                                                              // 499
        _this2.removed("users", oldDoc._id);                                                                           // 500
      }                                                                                                                // 501
    });                                                                                                                // 490
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 504
  };                                                                                                                   // 505
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 507
  var accountSubHandle = accountCursor.observe({                                                                       // 508
    added: function added(newDoc) {                                                                                    // 509
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 510
      newIdentities.forEach(function (identityId) {                                                                    // 511
        refIdentity(identityId);                                                                                       // 512
      });                                                                                                              // 513
                                                                                                                       //
      _this2.added("users", newDoc._id, newDoc);                                                                       // 515
    },                                                                                                                 // 516
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 518
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 519
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 520
                                                                                                                       //
      // Those in newDoc - oldDoc, ref.                                                                                //
      var identitiesAdded = _.difference(newIdentities, oldIdentities);                                                // 523
      identitiesAdded.forEach(function (identityId) {                                                                  // 524
        refIdentity(identityId);                                                                                       // 525
      });                                                                                                              // 526
                                                                                                                       //
      // Those in oldDoc - newDoc, unref.                                                                              //
      var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                              // 529
      identitiesRemoved.forEach(function (identityId) {                                                                // 530
        unrefIdentity(identityId);                                                                                     // 531
      });                                                                                                              // 532
                                                                                                                       //
      _this2.changed("users", newDoc._id, newDoc);                                                                     // 534
    },                                                                                                                 // 535
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 537
      _this2.removed("users", oldDoc._id);                                                                             // 538
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 539
      oldIdentities.forEach(function (identityId) {                                                                    // 540
        unrefIdentity(identityId);                                                                                     // 541
      });                                                                                                              // 542
    }                                                                                                                  // 543
  });                                                                                                                  // 508
                                                                                                                       //
  this.onStop(function () {                                                                                            // 546
    accountSubHandle.stop();                                                                                           // 547
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 549
    subs.forEach(function (sub) {                                                                                      // 550
      sub.stop();                                                                                                      // 551
    });                                                                                                                // 552
  });                                                                                                                  // 553
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 557
});                                                                                                                    // 558
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 560
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 561
  return ActivityStats.find();                                                                                         // 562
});                                                                                                                    // 563
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 565
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 566
  return StatsTokens.find();                                                                                           // 567
});                                                                                                                    // 568
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 570
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 571
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 572
      "manifest.actions": 1, "manifest.appTitle": 1 } });                                                              // 574
});                                                                                                                    // 575
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 577
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 578
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 581
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 584
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 585
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 586
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 590
});                                                                                                                    // 591
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 593
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 594
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 596
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 598
  var startSize = Fs.fstatSync(fd).size;                                                                               // 599
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 602
                                                                                                                       //
  var _this = this;                                                                                                    // 604
  function doTail() {                                                                                                  // 605
    for (;;) {                                                                                                         // 606
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 607
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 608
      if (n <= 0) break;                                                                                               // 609
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 610
      offset += n;                                                                                                     // 611
    }                                                                                                                  // 612
  }                                                                                                                    // 613
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 616
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 619
    watcher.close();                                                                                                   // 620
    Fs.closeSync(fd);                                                                                                  // 621
  });                                                                                                                  // 622
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 625
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 628
});                                                                                                                    // 629
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 631
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 632
  return ApiTokens.find({                                                                                              // 633
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 634
  }, {                                                                                                                 // 633
    fields: {                                                                                                          // 639
      frontendRef: 1,                                                                                                  // 640
      created: 1,                                                                                                      // 641
      requirements: 1,                                                                                                 // 642
      revoked: 1,                                                                                                      // 643
      owner: 1                                                                                                         // 644
    }                                                                                                                  // 639
  });                                                                                                                  // 638
});                                                                                                                    // 647
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 649
  var _this3 = this;                                                                                                   // 649
                                                                                                                       //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 650
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 652
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 655
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 656
  var observeHandle = featureKeyQuery.observe({                                                                        // 657
    added: function added(doc) {                                                                                       // 658
      // Load and verify the signed feature key.                                                                       //
      var buf = new Buffer(doc.value);                                                                                 // 660
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 661
                                                                                                                       //
      if (featureKey) {                                                                                                // 663
        var _ref;                                                                                                      // 663
                                                                                                                       //
        // If the signature is valid, publish the feature key information.                                             //
        var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                             // 665
        _this3.added("featureKey", doc._id, filteredFeatureKey);                                                       // 666
      }                                                                                                                // 667
    },                                                                                                                 // 668
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 670
      // Load and reverify the new signed feature key.                                                                 //
      var buf = new Buffer(newDoc.value);                                                                              // 672
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 673
                                                                                                                       //
      if (featureKey) {                                                                                                // 675
        var _ref2;                                                                                                     // 675
                                                                                                                       //
        // If the signature is valid, call this.changed() with the interesting fields.                                 //
        var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                           // 677
        _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                  // 678
      } else {                                                                                                         // 679
        // Otherwise, call this.removed(), since the new feature key is invalid.                                       //
        _this3.removed("featureKey", oldDoc._id);                                                                      // 681
      }                                                                                                                // 682
    },                                                                                                                 // 683
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 685
      _this3.removed("featureKey", oldDoc._id);                                                                        // 686
    }                                                                                                                  // 687
  });                                                                                                                  // 657
                                                                                                                       //
  this.onStop(function () {                                                                                            // 690
    observeHandle.stop();                                                                                              // 691
  });                                                                                                                  // 692
                                                                                                                       //
  this.ready();                                                                                                        // 694
});                                                                                                                    // 695
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 697
  var _this4 = this;                                                                                                   // 697
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 699
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 702
  if (cursor.count() > 0) {                                                                                            // 703
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 704
  } else {                                                                                                             // 705
    (function () {                                                                                                     // 705
      var handle = cursor.observeChanges({                                                                             // 706
        added: function added(id) {                                                                                    // 707
          _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                    // 708
          handle.stop();                                                                                               // 709
          handle = null;                                                                                               // 710
        }                                                                                                              // 711
      });                                                                                                              // 706
      _this4.onStop(function () {                                                                                      // 713
        if (handle) handle.stop();                                                                                     // 714
      });                                                                                                              // 715
    })();                                                                                                              // 705
  }                                                                                                                    // 716
                                                                                                                       //
  this.ready();                                                                                                        // 718
});                                                                                                                    // 719
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 721
  Settings.find({ _id: name, value: true }).observe({                                                                  // 722
    added: function added() {                                                                                          // 723
      // Tell the oauth library it should accept login attempts from this service.                                     //
      Accounts.oauth.registerService(name);                                                                            // 725
    },                                                                                                                 // 726
                                                                                                                       //
    removed: function removed() {                                                                                      // 728
      // Tell the oauth library it should deny login attempts from this service.                                       //
      Accounts.oauth.unregisterService(name);                                                                          // 730
    }                                                                                                                  // 731
  });                                                                                                                  // 722
}                                                                                                                      // 733
                                                                                                                       //
observeOauthService("github");                                                                                         // 735
observeOauthService("google");                                                                                         // 736
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 22
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 15;                                                                                        // 24
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 25
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 27
  check(tokenId, String);                                                                                              // 28
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 29
  FileTokens.remove({ _id: tokenId });                                                                                 // 30
}                                                                                                                      // 31
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 33
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 35
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 36
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 38
      cleanupToken(token._id);                                                                                         // 39
    });                                                                                                                // 40
  });                                                                                                                  // 41
});                                                                                                                    // 42
                                                                                                                       //
Meteor.methods({                                                                                                       // 44
  backupGrain: function backupGrain(grainId) {                                                                         // 45
    check(grainId, String);                                                                                            // 46
    var grain = Grains.findOne(grainId);                                                                               // 47
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 48
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 49
    }                                                                                                                  // 50
                                                                                                                       //
    this.unblock();                                                                                                    // 52
                                                                                                                       //
    var token = {                                                                                                      // 54
      _id: Random.id(),                                                                                                // 55
      timestamp: new Date(),                                                                                           // 56
      name: grain.title                                                                                                // 57
    };                                                                                                                 // 54
                                                                                                                       //
    // TODO(soon): does the grain need to be offline?                                                                  //
                                                                                                                       //
    var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                     // 62
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 64
    waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                          // 65
                                                                                                                       //
    return token._id;                                                                                                  // 67
  },                                                                                                                   // 68
  restoreGrain: function restoreGrain(tokenId, identityId) {                                                           // 70
    check(tokenId, String);                                                                                            // 71
    check(identityId, String);                                                                                         // 72
    var token = FileTokens.findOne(tokenId);                                                                           // 73
    if (!token || !isSignedUpOrDemo()) {                                                                               // 74
      throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");                // 75
    }                                                                                                                  // 77
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 79
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 80
    }                                                                                                                  // 82
                                                                                                                       //
    this.unblock();                                                                                                    // 84
                                                                                                                       //
    var grainId = Random.id(22);                                                                                       // 86
                                                                                                                       //
    try {                                                                                                              // 88
      var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
        console.error("Unzip failure:", err.message);                                                                  // 91
        throw new Meteor.Error(500, "Invalid backup file.");                                                           // 92
      })).info;                                                                                                        // 93
      if (!grainInfo.appId) {                                                                                          // 94
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 95
        throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                                // 96
      }                                                                                                                // 97
                                                                                                                       //
      var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                               // 99
                                                                                                                       //
      // Create variables we'll use for later Mongo query.                                                             //
      var packageId = void 0;                                                                                          // 102
      var appVersion = void 0;                                                                                         // 103
                                                                                                                       //
      // DevPackages are system-wide, so we do not check the user ID.                                                  //
      var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                                // 106
      if (devPackage) {                                                                                                // 107
        // If the dev app package exists, it should override the user action.                                          //
        packageId = devPackage.packageId;                                                                              // 109
        appVersion = devPackage.manifest.appVersion;                                                                   // 110
      } else if (action) {                                                                                             // 111
        // The app is installed, so we can continue restoring this                                                     //
        // grain.                                                                                                      //
        packageId = action.packageId;                                                                                  // 114
        appVersion = action.appVersion;                                                                                // 115
      } else {                                                                                                         // 116
        // If the package isn't installed at all, bail out.                                                            //
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 118
        throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);          // 119
      }                                                                                                                // 122
                                                                                                                       //
      if (appVersion < grainInfo.appVersion) {                                                                         // 124
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 125
        throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
      }                                                                                                                // 131
                                                                                                                       //
      Grains.insert({                                                                                                  // 133
        _id: grainId,                                                                                                  // 134
        packageId: packageId,                                                                                          // 135
        appId: grainInfo.appId,                                                                                        // 136
        appVersion: appVersion,                                                                                        // 137
        userId: this.userId,                                                                                           // 138
        identityId: identityId,                                                                                        // 139
        title: grainInfo.title,                                                                                        // 140
        "private": true                                                                                                // 141
      });                                                                                                              // 133
    } finally {                                                                                                        // 143
      cleanupToken(tokenId);                                                                                           // 144
    }                                                                                                                  // 145
                                                                                                                       //
    return grainId;                                                                                                    // 147
  }                                                                                                                    // 148
});                                                                                                                    // 44
                                                                                                                       //
Router.map(function () {                                                                                               // 151
  this.route("downloadBackup", {                                                                                       // 152
    where: "server",                                                                                                   // 153
    path: "/downloadBackup/:tokenId",                                                                                  // 154
    action: function action() {                                                                                        // 155
      var token = FileTokens.findOne(this.params.tokenId);                                                             // 156
      var response = this.response;                                                                                    // 157
      if (!token) {                                                                                                    // 158
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 159
        return response.end("File does not exist");                                                                    // 160
      }                                                                                                                // 161
                                                                                                                       //
      var started = false;                                                                                             // 163
      var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                          // 164
      var sawEnd = false;                                                                                              // 165
                                                                                                                       //
      var stream = {                                                                                                   // 167
        expectSize: function expectSize(size) {                                                                        // 168
          if (!started) {                                                                                              // 169
            started = true;                                                                                            // 170
            response.writeHead(200, {                                                                                  // 171
              "Content-Length": size,                                                                                  // 172
              "Content-Type": "application/zip",                                                                       // 173
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 174
            });                                                                                                        // 171
          }                                                                                                            // 176
        },                                                                                                             // 177
        write: function write(data) {                                                                                  // 179
          if (!started) {                                                                                              // 180
            started = true;                                                                                            // 181
            response.writeHead(200, {                                                                                  // 182
              "Content-Type": "application/zip",                                                                       // 183
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 184
            });                                                                                                        // 182
          }                                                                                                            // 186
                                                                                                                       //
          response.write(data);                                                                                        // 188
        },                                                                                                             // 189
        done: function done(data) {                                                                                    // 191
          if (!started) {                                                                                              // 192
            started = true;                                                                                            // 193
            response.writeHead(200, {                                                                                  // 194
              "Content-Length": 0,                                                                                     // 195
              "Content-Type": "application/zip",                                                                       // 196
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 197
            });                                                                                                        // 194
          }                                                                                                            // 199
                                                                                                                       //
          sawEnd = true;                                                                                               // 201
          response.end();                                                                                              // 202
        }                                                                                                              // 203
      };                                                                                                               // 167
                                                                                                                       //
      waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                    // 206
                                                                                                                       //
      if (!sawEnd) {                                                                                                   // 208
        console.error("backend failed to call done() when downloading backup");                                        // 209
        if (!started) {                                                                                                // 210
          throw new Meteor.Error(500, "backend failed to produce data");                                               // 211
        }                                                                                                              // 212
                                                                                                                       //
        response.end();                                                                                                // 214
      }                                                                                                                // 215
                                                                                                                       //
      cleanupToken(this.params.tokenId);                                                                               // 217
    }                                                                                                                  // 218
  });                                                                                                                  // 152
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 221
    where: "server",                                                                                                   // 222
    path: "/uploadBackup",                                                                                             // 223
    action: function action() {                                                                                        // 224
      var _this = this;                                                                                                // 224
                                                                                                                       //
      if (this.request.method === "POST") {                                                                            // 225
        (function () {                                                                                                 // 225
          var request = _this.request;                                                                                 // 226
          try {                                                                                                        // 227
            (function () {                                                                                             // 227
              var token = {                                                                                            // 228
                _id: Random.id(),                                                                                      // 229
                timestamp: new Date()                                                                                  // 230
              };                                                                                                       // 228
              var stream = globalBackend.cap().uploadBackup(token._id).stream;                                         // 232
                                                                                                                       //
              FileTokens.insert(token);                                                                                // 234
                                                                                                                       //
              waitPromise(new Promise(function (resolve, reject) {                                                     // 236
                request.on("data", function (data) {                                                                   // 237
                  stream.write(data);                                                                                  // 238
                });                                                                                                    // 239
                request.on("end", function () {                                                                        // 240
                  resolve(stream.done());                                                                              // 241
                });                                                                                                    // 242
                request.on("error", function (err) {                                                                   // 243
                  stream.close();                                                                                      // 244
                });                                                                                                    // 245
              }));                                                                                                     // 246
                                                                                                                       //
              _this.response.writeHead(200, {                                                                          // 248
                "Content-Length": token._id.length,                                                                    // 249
                "Content-Type": "text/plain"                                                                           // 250
              });                                                                                                      // 248
              _this.response.write(token._id);                                                                         // 252
              _this.response.end();                                                                                    // 253
            })();                                                                                                      // 227
          } catch (error) {                                                                                            // 254
            console.error(error.stack);                                                                                // 255
            _this.response.writeHead(500, {                                                                            // 256
              "Content-Type": "text/plain"                                                                             // 257
            });                                                                                                        // 256
            _this.response.write(error.stack);                                                                         // 259
            _this.response.end();                                                                                      // 260
          }                                                                                                            // 261
        })();                                                                                                          // 225
      } else {                                                                                                         // 262
        this.response.writeHead(405, {                                                                                 // 263
          "Content-Type": "text/plain"                                                                                 // 264
        });                                                                                                            // 263
        this.response.write("You can only POST here.");                                                                // 266
        this.response.end();                                                                                           // 267
      }                                                                                                                // 268
    }                                                                                                                  // 269
  });                                                                                                                  // 221
});                                                                                                                    // 271
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 20
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 21
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 22
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 23
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 24
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(grainId) {                                                                                // 27
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 27
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 28
  }                                                                                                                    // 29
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function restore(sturdyRef, requiredPermissions) {                             //
    var _this2 = this;                                                                                                 // 31
                                                                                                                       //
    var _this = this;                                                                                                  // 32
    return inMeteor(function () {                                                                                      // 33
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 34
      var token = ApiTokens.findOne({                                                                                  // 35
        _id: hashedSturdyRef,                                                                                          // 36
        "owner.grain.grainId": _this2.grainId                                                                          // 37
      });                                                                                                              // 35
                                                                                                                       //
      if (!token) {                                                                                                    // 40
        throw new Error("no such token");                                                                              // 41
      }                                                                                                                // 42
                                                                                                                       //
      // Honor `requiredPermissions`.                                                                                  //
      var requirements = [];                                                                                           // 45
      if (requiredPermissions && token.owner.grain.introducerIdentity) {                                               // 46
        requirements.push({                                                                                            // 47
          permissionsHeld: {                                                                                           // 48
            permissions: requiredPermissions,                                                                          // 49
            identityId: token.owner.grain.introducerIdentity,                                                          // 50
            grainId: _this.grainId                                                                                     // 51
          }                                                                                                            // 48
        });                                                                                                            // 47
      }                                                                                                                // 54
                                                                                                                       //
      return restoreInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) }, requirements, hashedSturdyRef);
    });                                                                                                                // 59
  };                                                                                                                   // 60
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function drop(sturdyRef) {                                                        //
    var _this = this;                                                                                                  // 63
    return inMeteor(function () {                                                                                      // 64
      return dropInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) });                    // 65
    });                                                                                                                // 66
  };                                                                                                                   // 67
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function makeToken(ref, owner, requirements) {                               //
    var _this = this;                                                                                                  // 70
    return inMeteor(function () {                                                                                      // 71
      var sturdyRef = new Buffer(generateSturdyRef());                                                                 // 72
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 73
      ApiTokens.insert({                                                                                               // 74
        _id: hashedSturdyRef,                                                                                          // 75
        grainId: _this.grainId,                                                                                        // 76
        objectId: ref,                                                                                                 // 77
        owner: owner,                                                                                                  // 78
        created: new Date(),                                                                                           // 79
        requirements: requirements                                                                                     // 80
      });                                                                                                              // 74
                                                                                                                       //
      return {                                                                                                         // 83
        token: sturdyRef                                                                                               // 84
      };                                                                                                               // 83
    });                                                                                                                // 86
  };                                                                                                                   // 87
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function makeChildToken(parent, owner, requirements) {                  //
    var _this = this;                                                                                                  // 90
    return inMeteor(function () {                                                                                      // 91
      return {                                                                                                         // 92
        token: new Buffer(makeChildTokenInternal(parent, owner, requirements))                                         // 93
      };                                                                                                               // 92
    });                                                                                                                // 95
  };                                                                                                                   // 96
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function getOwnerNotificationTarget() {                     //
    var grainId = this.grainId;                                                                                        // 99
    return {                                                                                                           // 100
      owner: {                                                                                                         // 101
        addOngoing: function addOngoing(displayInfo, notification) {                                                   // 102
          return inMeteor(function () {                                                                                // 103
            var grain = Grains.findOne({ _id: grainId });                                                              // 104
            if (!grain) {                                                                                              // 105
              throw new Error("Grain not found.");                                                                     // 106
            }                                                                                                          // 107
                                                                                                                       //
            var castedNotification = notification.castAs(PersistentOngoingNotification);                               // 109
            var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                      // 110
                                                                                                                       //
            // We have to close both the casted cap and the original. Perhaps this should be fixed in                  //
            // node-capnp?                                                                                             //
            castedNotification.close();                                                                                // 114
            notification.close();                                                                                      // 115
            var notificationId = Notifications.insert({                                                                // 116
              ongoing: wakelockToken,                                                                                  // 117
              grainId: grainId,                                                                                        // 118
              userId: grain.userId,                                                                                    // 119
              text: displayInfo.caption,                                                                               // 120
              timestamp: new Date(),                                                                                   // 121
              isUnread: true                                                                                           // 122
            });                                                                                                        // 116
                                                                                                                       //
            var persistentMethods = {                                                                                  // 125
              save: function save(params) {                                                                            // 126
                return saveFrontendRef({ notificationHandle: notificationId }, params.sealFor);                        // 127
              }                                                                                                        // 128
            };                                                                                                         // 125
                                                                                                                       //
            return { handle: makeNotificationHandle(notificationId, false, persistentMethods) };                       // 131
          });                                                                                                          // 132
        }                                                                                                              // 133
      }                                                                                                                // 101
    };                                                                                                                 // 100
  };                                                                                                                   // 136
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(grainId) {                                                          // 139
  return new Capnp.Capability(new SandstormCoreImpl(grainId), SandstormCore);                                          // 140
};                                                                                                                     // 141
                                                                                                                       //
var NotificationHandle = function () {                                                                                 //
  function NotificationHandle(notificationId, saved, persistentMethods) {                                              // 144
    _classCallCheck(this, NotificationHandle);                                                                         // 144
                                                                                                                       //
    this.notificationId = notificationId;                                                                              // 145
    this.saved = saved;                                                                                                // 146
    _.extend(this, persistentMethods);                                                                                 // 147
  }                                                                                                                    // 148
                                                                                                                       //
  NotificationHandle.prototype.close = function close() {                                                              //
    var _this = this;                                                                                                  // 151
    return inMeteor(function () {                                                                                      // 152
      if (!_this.saved) {                                                                                              // 153
        _dismissNotification(_this.notificationId);                                                                    // 154
      }                                                                                                                // 155
    });                                                                                                                // 156
  };                                                                                                                   // 157
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}();                                                                                                                   //
                                                                                                                       //
var PersistentUiViewImpl = function PersistentUiViewImpl(persistentMethods) {                                          //
  _classCallCheck(this, PersistentUiViewImpl);                                                                         // 161
                                                                                                                       //
  _.extend(this, persistentMethods);                                                                                   // 162
}                                                                                                                      // 163
                                                                                                                       //
// All other UiView methods are currently unimplemented, which, while not strictly correct,                            //
// results in the same overall behavior, since users can't call restore() on a PersistentUiView,                       //
// and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                         //
;                                                                                                                      //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(persistentMethods) {                                          // 170
  return new Capnp.Capability(new PersistentUiViewImpl(persistentMethods), PersistentUiView);                          // 171
};                                                                                                                     // 172
                                                                                                                       //
function makeNotificationHandle(notificationId, saved, persistentMethods) {                                            // 174
  return new Capnp.Capability(new NotificationHandle(notificationId, saved, persistentMethods), PersistentHandle);     // 175
}                                                                                                                      // 177
                                                                                                                       //
function dropWakelock(grainId, wakeLockNotificationId) {                                                               // 179
  waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                                  // 180
    return supervisor.drop({ wakeLockNotification: wakeLockNotificationId });                                          // 181
  }));                                                                                                                 // 182
}                                                                                                                      // 183
                                                                                                                       //
function _dismissNotification(notificationId, callCancel) {                                                            // 185
  var notification = Notifications.findOne({ _id: notificationId });                                                   // 186
  if (notification) {                                                                                                  // 187
    Notifications.remove({ _id: notificationId });                                                                     // 188
    if (notification.ongoing) {                                                                                        // 189
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 192
                                                                                                                       //
      if (!callCancel) {                                                                                               // 194
        dropInternal(id, { frontend: null });                                                                          // 195
      } else {                                                                                                         // 196
        var notificationCap = restoreInternal(id, { frontend: null }, []).cap;                                         // 197
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 198
        dropInternal(id, { frontend: null });                                                                          // 199
        try {                                                                                                          // 200
          waitPromise(castedNotification.cancel());                                                                    // 201
          castedNotification.close();                                                                                  // 202
          notificationCap.close();                                                                                     // 203
        } catch (err) {                                                                                                // 204
          if (err.kjType !== "disconnected") {                                                                         // 205
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 208
          }                                                                                                            // 209
        }                                                                                                              // 210
      }                                                                                                                // 211
    } else if (notification.appUpdates) {                                                                              // 212
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 213
        deletePackage(app.packageId);                                                                                  // 214
      });                                                                                                              // 215
    }                                                                                                                  // 216
  }                                                                                                                    // 217
}                                                                                                                      // 218
                                                                                                                       //
hashSturdyRef = function hashSturdyRef(sturdyRef) {                                                                    // 220
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 221
};                                                                                                                     // 222
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 224
  return Random.secret();                                                                                              // 225
}                                                                                                                      // 226
                                                                                                                       //
Meteor.methods({                                                                                                       // 228
  dismissNotification: function dismissNotification(notificationId) {                                                  // 229
    // This will remove notifications from the database and from view of the user.                                     //
    // For ongoing notifications, it will begin the process of cancelling and dropping them from                       //
    // the app.                                                                                                        //
                                                                                                                       //
    check(notificationId, String);                                                                                     // 234
                                                                                                                       //
    var notification = Notifications.findOne({ _id: notificationId });                                                 // 236
    if (!notification) {                                                                                               // 237
      throw new Meteor.Error(404, "Notification id not found.");                                                       // 238
    } else if (notification.userId !== Meteor.userId()) {                                                              // 239
      throw new Meteor.Error(403, "Notification does not belong to current user.");                                    // 240
    } else {                                                                                                           // 241
      _dismissNotification(notificationId, true);                                                                      // 242
    }                                                                                                                  // 243
  },                                                                                                                   // 244
  readAllNotifications: function readAllNotifications() {                                                              // 246
    // Marks all notifications as read for the current user.                                                           //
    if (!Meteor.userId()) {                                                                                            // 248
      throw new Meteor.Error(403, "User not logged in.");                                                              // 249
    }                                                                                                                  // 250
                                                                                                                       //
    Notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });                 // 252
  }                                                                                                                    // 253
});                                                                                                                    // 228
                                                                                                                       //
saveFrontendRef = function saveFrontendRef(frontendRef, owner, requirements) {                                         // 256
  return inMeteor(function () {                                                                                        // 257
    var sturdyRef = new Buffer(generateSturdyRef());                                                                   // 258
    var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                    // 259
    ApiTokens.insert({                                                                                                 // 260
      _id: hashedSturdyRef,                                                                                            // 261
      frontendRef: frontendRef,                                                                                        // 262
      owner: owner,                                                                                                    // 263
      created: new Date(),                                                                                             // 264
      requirements: requirements                                                                                       // 265
    });                                                                                                                // 260
    return { sturdyRef: sturdyRef };                                                                                   // 267
  });                                                                                                                  // 268
};                                                                                                                     // 269
                                                                                                                       //
checkRequirements = function (_checkRequirements) {                                                                    // 271
  function checkRequirements(_x) {                                                                                     // 271
    return _checkRequirements.apply(this, arguments);                                                                  // 271
  }                                                                                                                    // 271
                                                                                                                       //
  checkRequirements.toString = function () {                                                                           // 271
    return _checkRequirements.toString();                                                                              // 271
  };                                                                                                                   // 271
                                                                                                                       //
  return checkRequirements;                                                                                            // 271
}(function (requirements) {                                                                                            // 271
  if (!requirements) {                                                                                                 // 272
    return true;                                                                                                       // 273
  }                                                                                                                    // 274
                                                                                                                       //
  for (var i in requirements) {                                                                                        // 276
    var requirement = requirements[i];                                                                                 // 277
    if (requirement.tokenValid) {                                                                                      // 278
      var token = ApiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token || !checkRequirements(token.requirements)) {                                                          // 281
        return false;                                                                                                  // 282
      }                                                                                                                // 283
                                                                                                                       //
      if (token.parentToken && !checkRequirements([{ tokenValid: token.parentToken }])) {                              // 285
        return false;                                                                                                  // 286
      }                                                                                                                // 287
    } else if (requirement.permissionsHeld) {                                                                          // 288
      var p = requirement.permissionsHeld;                                                                             // 289
      var viewInfo = Grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;                      // 290
      var currentPermissions = SandstormPermissions.grainPermissions(globalDb, { grain: { _id: p.grainId, identityId: p.identityId } }, viewInfo || {}).permissions;
      if (!currentPermissions) {                                                                                       // 294
        return false;                                                                                                  // 295
      }                                                                                                                // 296
                                                                                                                       //
      for (var ii = 0; ii < p.permissions.length; ++ii) {                                                              // 298
        if (p.permissions[ii] && !currentPermissions[ii]) {                                                            // 299
          return false;                                                                                                // 300
        }                                                                                                              // 301
      }                                                                                                                // 302
    } else if (requirement.userIsAdmin) {                                                                              // 303
      if (!isAdminById(requirement.userIsAdmin)) {                                                                     // 304
        return false;                                                                                                  // 305
      }                                                                                                                // 306
    } else {                                                                                                           // 307
      throw new Meteor.Error(403, "Unknown requirement");                                                              // 308
    }                                                                                                                  // 309
  }                                                                                                                    // 310
                                                                                                                       //
  return true;                                                                                                         // 312
});                                                                                                                    // 313
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 315
  function restoreInternal(_x2, _x3, _x4, _x5) {                                                                       // 315
    return _restoreInternal.apply(this, arguments);                                                                    // 315
  }                                                                                                                    // 315
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 315
    return _restoreInternal.toString();                                                                                // 315
  };                                                                                                                   // 315
                                                                                                                       //
  return restoreInternal;                                                                                              // 315
}(function (originalToken, ownerPattern, requirements, tokenId) {                                                      // 315
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `tokenId` is optional. If specified, it should be hashSturdyRef(originalToken); only specify                      //
  // it if you happen to have computed this already.                                                                   //
  //                                                                                                                   //
  // (When the token turns out to have a parent, this function will call itself recursively. When                      //
  // it does, `originalToken` stays the same, but `tokenId` is replaced with the parent. This is                       //
  // because the capability we ultimately restore needs to become a child of the token that is                         //
  // being restored.)                                                                                                  //
                                                                                                                       //
  tokenId = tokenId || hashSturdyRef(originalToken);                                                                   // 332
  requirements = requirements || [];                                                                                   // 333
                                                                                                                       //
  var token = ApiTokens.findOne(tokenId);                                                                              // 335
  if (!token) {                                                                                                        // 336
    throw new Meteor.Error(403, "No token found to restore");                                                          // 337
  }                                                                                                                    // 338
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 340
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 341
  }                                                                                                                    // 342
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 345
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  if (!checkRequirements(token.requirements)) {                                                                        // 348
    throw new Meteor.Error(403, "Requirements not satisfied.");                                                        // 349
  }                                                                                                                    // 350
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 353
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 354
  }                                                                                                                    // 355
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 357
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 358
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 359
    } else {                                                                                                           // 360
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                                // 362
    }                                                                                                                  // 363
  }                                                                                                                    // 364
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 367
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(originalToken, Match.Any, requirements, token.parentToken);                                 // 370
  }                                                                                                                    // 371
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  if (!checkRequirements(requirements)) {                                                                              // 374
    throw new Meteor.Error(403, "Requirements not satisfied.");                                                        // 375
  }                                                                                                                    // 376
                                                                                                                       //
  // The capability we restore must implement SystemPersistent, and we already know what the                           //
  // implementation will look like. So, construct it here.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): It would probably be a lot cleaner to have a common base class that these                          //
  //   inherit, and to pass down some common parameters to the constructor.                                            //
  var persistentMethods = {                                                                                            // 383
    save: function save(params) {                                                                                      // 384
      return inMeteor(function () {                                                                                    // 385
        var sturdyRef = new Buffer(makeChildTokenInternal(originalToken, params.sealFor, requirements, token));        // 386
        return { sturdyRef: sturdyRef };                                                                               // 388
      });                                                                                                              // 389
    }                                                                                                                  // 390
  };                                                                                                                   // 383
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
  if (token.frontendRef) {                                                                                             // 395
    // A token which represents a capability implemented by a pseudo-driver.                                           //
                                                                                                                       //
    if (token.frontendRef.notificationHandle) {                                                                        // 398
      var notificationId = token.frontendRef.notificationHandle;                                                       // 399
      return { cap: makeNotificationHandle(notificationId, true, persistentMethods) };                                 // 400
    } else if (token.frontendRef.ipNetwork) {                                                                          // 401
      return { cap: makeIpNetwork(persistentMethods) };                                                                // 402
    } else if (token.frontendRef.ipInterface) {                                                                        // 403
      return { cap: makeIpInterface(persistentMethods) };                                                              // 404
    } else if (token.frontendRef.emailVerifier) {                                                                      // 405
      return { cap: makeEmailVerifier(persistentMethods, tokenId, token.frontendRef.emailVerifier) };                  // 406
    } else if (token.frontendRef.verifiedEmail) {                                                                      // 408
      return { cap: makeVerifiedEmail(persistentMethods) };                                                            // 409
    } else {                                                                                                           // 410
      throw new Meteor.Error(500, "Unknown frontend token type.");                                                     // 411
    }                                                                                                                  // 412
  } else if (token.objectId) {                                                                                         // 413
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 417
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 418
    }                                                                                                                  // 419
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 422
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // discard persistentMethods.                                                                                    //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 425
    }));                                                                                                               // 426
  } else if (token.grainId) {                                                                                          // 427
    // It's a UiView.                                                                                                  //
                                                                                                                       //
    // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                            //
    // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                    //
    // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                       //
    // do some transformation), which will return a different capability.                                              //
    return { cap: makePersistentUiView(persistentMethods) };                                                           // 434
  } else {                                                                                                             // 435
    throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                               // 436
  }                                                                                                                    // 437
});                                                                                                                    // 438
                                                                                                                       //
function dropInternal(sturdyRef, ownerPattern) {                                                                       // 440
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 443
  var token = ApiTokens.findOne({ _id: hashedSturdyRef });                                                             // 444
  if (!token) {                                                                                                        // 445
    return;                                                                                                            // 446
  }                                                                                                                    // 447
                                                                                                                       //
  check(token.owner, ownerPattern);                                                                                    // 449
                                                                                                                       //
  if (token.frontendRef) {                                                                                             // 451
    if (token.frontendRef.notificationHandle) {                                                                        // 452
      var notificationId = token.frontendRef.notificationHandle;                                                       // 453
      globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                              // 454
      var anyToken = ApiTokens.findOne({ "frontendRef.notificationHandle": notificationId });                          // 455
      if (!anyToken) {                                                                                                 // 456
        // No other tokens referencing this notification exist, so dismiss the notification                            //
        _dismissNotification(notificationId);                                                                          // 458
      }                                                                                                                // 459
    } else {                                                                                                           // 460
      throw new Error("Unknown frontend token type.");                                                                 // 461
    }                                                                                                                  // 462
  } else if (token.objectId) {                                                                                         // 463
    if (token.objectId.wakeLockNotification) {                                                                         // 464
      dropWakelock(token.grainId, token.objectId.wakeLockNotification);                                                // 465
    } else {                                                                                                           // 466
      throw new Error("Unknown objectId token type.");                                                                 // 467
    }                                                                                                                  // 468
  } else {                                                                                                             // 469
    throw new Error("Unknown token type.");                                                                            // 470
  }                                                                                                                    // 471
}                                                                                                                      // 472
                                                                                                                       //
function makeChildTokenInternal(rawParentToken, owner, requirements, tokenInfo) {                                      // 474
  var hashedParent = hashSturdyRef(rawParentToken);                                                                    // 475
                                                                                                                       //
  // If we don't have tokenInfo (we were called from SandstormCore.makeChildToken()), look up                          //
  // the parent token now and use that.                                                                                //
  // TODO(someday): I think this makeChildToken() will lose titles because of this.                                    //
  //   Option 1: Somehow pass info through the supervisor for it to pass back through                                  //
  //       makeChildToken().                                                                                           //
  //   Option 2: Follow the chain of parentTokens here.                                                                //
  //   Option 3: Maybe the title should actually be passed in a PowerboxDescriptor which the app                       //
  //       is expected to thread through to offer(). This is analogous to how file transfers                           //
  //       work: the file name is not normally stored in the content. Our petname system for                           //
  //       grains already matches that model better -- and if we decide to get rid of said petname                     //
  //       system and instead have everyone see the author's title, then we'd presumably stop                          //
  //       storing it in the token `owner` field altogether, so this becomes moot.                                     //
  tokenInfo = tokenInfo || ApiTokens.findOne(hashedParent);                                                            // 489
  if (!tokenInfo) {                                                                                                    // 490
    throw new Error("parent token doesn't exist");                                                                     // 491
  }                                                                                                                    // 492
                                                                                                                       //
  if (tokenInfo.identityId) {                                                                                          // 494
    // This is a UiView capability. We need to use SandstormPermissions to create it in order                          //
    // to properly denormalize fields.                                                                                 //
                                                                                                                       //
    if (owner.user) {                                                                                                  // 498
      // Initialize the grain's title to a copy of the title set by the human user closest in the                      //
      // sharing graph. It turns out that the "root token" is actually the token representing that                     //
      // user, not the grain owner, because user-to-user sharing relationships are not parent-child                    //
      // token relationships.                                                                                          //
      var rootTitle = (((tokenInfo.owner || {}).grain || {}).saveLabel || {}).defaultText;                             // 503
      if (!owner.user.title && rootTitle) {                                                                            // 504
        owner.user.title = rootTitle;                                                                                  // 505
      }                                                                                                                // 506
    }                                                                                                                  // 507
                                                                                                                       //
    return SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: rawParentToken }, tokenInfo.grainId, tokenInfo.petname, { allAccess: null }, owner).token;
  }                                                                                                                    // 511
                                                                                                                       //
  if (owner.user) {                                                                                                    // 513
    throw new Error("can't save non-UiView with user as owner");                                                       // 514
  }                                                                                                                    // 515
                                                                                                                       //
  var sturdyRef = generateSturdyRef();                                                                                 // 517
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 518
                                                                                                                       //
  var newTokenInfo = {                                                                                                 // 520
    _id: hashedSturdyRef,                                                                                              // 521
    parentToken: hashedParent,                                                                                         // 522
    owner: owner,                                                                                                      // 523
    created: new Date(),                                                                                               // 524
    requirements: requirements                                                                                         // 525
  };                                                                                                                   // 520
                                                                                                                       //
  // For non-UiView capabilities, we need not denormalize grainId, identityId, etc. into the child                     //
  // token.                                                                                                            //
                                                                                                                       //
  ApiTokens.insert(newTokenInfo);                                                                                      // 531
                                                                                                                       //
  return sturdyRef;                                                                                                    // 533
};                                                                                                                     // 534
                                                                                                                       //
function SandstormCoreFactoryImpl() {}                                                                                 // 536
                                                                                                                       //
SandstormCoreFactoryImpl.prototype.getSandstormCore = function (grainId) {                                             // 539
  return { core: makeSandstormCore(grainId) };                                                                         // 540
};                                                                                                                     // 541
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory() {                                                       // 543
  return new Capnp.Capability(new SandstormCoreFactoryImpl(), SandstormCoreFactory);                                   // 544
};                                                                                                                     // 545
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 17
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 18
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 20
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 23
    (function () {                                                                                                     // 23
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 24
      if (expireIn < 0) {                                                                                              // 25
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 26
      }                                                                                                                // 27
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 29
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 32
      }                                                                                                                // 33
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 37
      var handle = Meteor.setTimeout(function () {                                                                     // 38
        connection.close();                                                                                            // 38
      }, expireIn);                                                                                                    // 38
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 40
        Meteor.clearTimeout(handle);                                                                                   // 40
      });                                                                                                              // 40
    })();                                                                                                              // 23
  }                                                                                                                    // 41
                                                                                                                       //
  return true;                                                                                                         // 43
});                                                                                                                    // 44
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 46
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 49
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
    Grains.find({ userId: user._id }, { fields: { _id: 1, lastUsed: 1, appId: 1 } }).forEach(function (grain) {        // 53
      console.log("delete grain: " + grain._id);                                                                       // 55
      globalDb.removeApiTokens({ grainId: grain._id });                                                                // 56
      Grains.remove(grain._id);                                                                                        // 57
      if (grain.lastUsed) {                                                                                            // 58
        DeleteStats.insert({ type: "demoGrain", lastActive: grain.lastUsed, appId: grain.appId });                     // 59
      }                                                                                                                // 60
                                                                                                                       //
      globalBackend.deleteGrain(grain._id, user._id);                                                                  // 62
    });                                                                                                                // 63
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 65
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 68
    UserActions.remove({ userId: user._id });                                                                          // 69
    Notifications.remove({ userId: user._id });                                                                        // 70
    Meteor.users.remove(user._id);                                                                                     // 71
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 72
    if (user.loginIdentities && user.lastActive) {                                                                     // 73
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 77
      var isAppDemoUser = !!user.appDemoId;                                                                            // 78
      if (isAppDemoUser) {                                                                                             // 79
        deleteStatsType = "appDemoUser";                                                                               // 80
      }                                                                                                                // 81
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 85
    }                                                                                                                  // 86
  });                                                                                                                  // 87
}                                                                                                                      // 88
                                                                                                                       //
if (allowDemo) {                                                                                                       // 90
  Meteor.methods({                                                                                                     // 91
    createDemoUser: function createDemoUser(displayName, appDemoId) {                                                  // 92
      // This is a login method that creates a new temporary user                                                      //
      // every time it is used.                                                                                        //
      //                                                                                                               //
      // appDemoId is important for stats; see cleanupExpiredUsers().                                                  //
      check(displayName, String);                                                                                      // 97
      check(appDemoId, Match.OneOf(undefined, null, String));                                                          // 98
                                                                                                                       //
      // Create the new user.                                                                                          //
      var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                            // 101
      if (appDemoId) {                                                                                                 // 102
        newUser.appDemoId = appDemoId;                                                                                 // 103
      }                                                                                                                // 104
                                                                                                                       //
      var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                                // 106
                                                                                                                       //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                            // 109
        return { userId: userId };                                                                                     // 110
      });                                                                                                              // 110
    },                                                                                                                 // 111
                                                                                                                       //
    testExpireDemo: function testExpireDemo() {                                                                        // 113
      if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                               // 114
                                                                                                                       //
      var newExpires = new Date(Date.now() + 15000);                                                                   // 116
      if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                    // 117
        throw new Meteor.Error(403, "can't exend demo");                                                               // 118
      }                                                                                                                // 119
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                             // 121
    }                                                                                                                  // 122
  });                                                                                                                  // 91
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to                                                     //
  // information about an app by appId. If this were available in                                                      //
  // non-demo mode, then anonymous users could effectively ask the                                                     //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appInfo", function (appId) {                                                                         // 129
    // This publishes info about an app, including the latest                                                          //
    // version of it. Once you log in, it also publishes your                                                          //
    // list of UserActions.                                                                                            //
    check(appId, String);                                                                                              // 133
                                                                                                                       //
    var packageCursor = Packages.find({ appId: appId }, { sort: { "manifest.appVersion": -1 } });                      // 135
                                                                                                                       //
    var pkg = packageCursor.fetch()[0];                                                                                // 139
                                                                                                                       //
    // This allows us to avoid creating duplicate UserActions.                                                         //
    if (this.userId) {                                                                                                 // 142
      return [packageCursor, UserActions.find({ userId: this.userId, appId: appId })];                                 // 143
    }                                                                                                                  // 147
                                                                                                                       //
    return packageCursor;                                                                                              // 149
  });                                                                                                                  // 150
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 152
} else {                                                                                                               // 153
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 155
}                                                                                                                      // 156
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                        // 20
    // This is a login method that creates or logs in a dev account with the given displayName                         //
                                                                                                                       //
    check(displayName, String);                                                                                        // 23
    check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                             // 24
    check(profile, Match.OneOf(undefined, null, Object));                                                              // 25
    check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                      // 26
                                                                                                                       //
    if (!this.connection.sandstormDb.allowDevAccounts()) {                                                             // 28
      throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                      // 29
    }                                                                                                                  // 30
                                                                                                                       //
    isAdmin = isAdmin || false;                                                                                        // 32
                                                                                                                       //
    profile = profile || {};                                                                                           // 34
    profile.name = profile.name || displayName;                                                                        // 35
    var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                               // 36
                                                                                                                       //
    var user = Meteor.users.findOne({ "services.dev.name": displayName });                                             // 38
    var userId = void 0;                                                                                               // 39
                                                                                                                       //
    if (user) {                                                                                                        // 41
      userId = user._id;                                                                                               // 42
    } else {                                                                                                           // 43
      userId = Accounts.insertUserDoc({                                                                                // 44
        profile: profile,                                                                                              // 45
        unverifiedEmail: unverifiedEmail                                                                               // 46
      }, {                                                                                                             // 44
        services: {                                                                                                    // 48
          dev: {                                                                                                       // 49
            name: displayName,                                                                                         // 50
            isAdmin: isAdmin,                                                                                          // 51
            hasCompletedSignup: hasCompletedSignup                                                                     // 52
          }                                                                                                            // 49
        }                                                                                                              // 48
      });                                                                                                              // 47
    }                                                                                                                  // 56
    // Log them in on this connection.                                                                                 //
    return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                             // 58
      return { userId: userId };                                                                                       // 59
    });                                                                                                                // 59
  }                                                                                                                    // 60
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":["bignum","ed25519",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var ed25519;module.import("ed25519",{"default":function(v){ed25519=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 20
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 26
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 27
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 28
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 29
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 36
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 39
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 46
  var signedData = buf.slice(64);                                                                                      // 47
                                                                                                                       //
  if (!ed25519.Verify(signedData, signature, signingKey)) {                                                            // 49
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 50
    return undefined;                                                                                                  // 51
  } else {                                                                                                             // 52
    return signedData;                                                                                                 // 53
  }                                                                                                                    // 54
};                                                                                                                     // 55
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 58
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 62
  if (verifiedFeatureKeyBlob) {                                                                                        // 63
    var featureKey = Capnp.parse(FeatureKey, verifiedFeatureKeyBlob, { packed: true });                                // 64
    if (featureKey.isForTesting && !isTesting) {                                                                       // 65
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 68
    }                                                                                                                  // 69
                                                                                                                       //
    return featureKey;                                                                                                 // 71
  } else {                                                                                                             // 72
    return undefined;                                                                                                  // 73
  }                                                                                                                    // 74
};                                                                                                                     // 75
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"grain-server.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 19
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 24
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 26
  check(grainId, String);                                                                                              // 27
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 29
    _id: grainId,                                                                                                      // 31
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 32
  }, {                                                                                                                 // 30
    fields: {                                                                                                          // 37
      title: 1,                                                                                                        // 38
      userId: 1,                                                                                                       // 39
      identityId: 1,                                                                                                   // 40
      "private": 1                                                                                                     // 41
    }                                                                                                                  // 37
  })];                                                                                                                 // 36
  if (this.userId) {                                                                                                   // 45
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 46
    result.push(ApiTokens.find({                                                                                       // 47
      grainId: grainId,                                                                                                // 48
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 49
    }));                                                                                                               // 47
  }                                                                                                                    // 54
                                                                                                                       //
  return result;                                                                                                       // 56
});                                                                                                                    // 57
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 63
  check(grainId, String);                                                                                              // 64
  var publishThis = [];                                                                                                // 65
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 68
    _id: grainId,                                                                                                      // 69
    userId: this.userId                                                                                                // 70
  }, {                                                                                                                 // 68
    fields: { packageId: 1 }                                                                                           // 72
  });                                                                                                                  // 71
  publishThis.push(thisGrainCursor);                                                                                   // 74
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 76
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 77
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 78
    publishThis.push(thisPackageCursor);                                                                               // 79
  }                                                                                                                    // 80
                                                                                                                       //
  return publishThis;                                                                                                  // 82
});                                                                                                                    // 83
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 85
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 89
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 91
  var apiToken = ApiTokens.findOne({                                                                                   // 92
    _id: hashedToken                                                                                                   // 93
  }, {                                                                                                                 // 92
    fields: {                                                                                                          // 95
      grainId: 1,                                                                                                      // 96
      identityId: 1,                                                                                                   // 97
      owner: 1,                                                                                                        // 98
      revoked: 1                                                                                                       // 99
    }                                                                                                                  // 95
  });                                                                                                                  // 94
  if (!apiToken) {                                                                                                     // 102
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 103
  } else if (apiToken.revoked) {                                                                                       // 104
    this.added("tokenInfo", token, { revoked: true });                                                                 // 105
  } else {                                                                                                             // 106
    var grainId = apiToken.grainId;                                                                                    // 107
    var grain = Grains.findOne({                                                                                       // 108
      _id: grainId                                                                                                     // 109
    }, {                                                                                                               // 108
      fields: {                                                                                                        // 111
        packageId: 1,                                                                                                  // 112
        appId: 1,                                                                                                      // 113
        userId: 1                                                                                                      // 114
      }                                                                                                                // 111
    });                                                                                                                // 110
    if (!grain) {                                                                                                      // 117
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 118
    } else {                                                                                                           // 119
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 120
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 121
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 122
        if (identity && metadata) {                                                                                    // 123
          SandstormDb.fillInLoginId(identity);                                                                         // 124
          this.added("tokenInfo", token, {                                                                             // 125
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 126
            grainId: grainId,                                                                                          // 127
            grainMetadata: metadata                                                                                    // 128
          });                                                                                                          // 125
        } else {                                                                                                       // 130
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 131
        }                                                                                                              // 132
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 133
        if (this.userId) {                                                                                             // 134
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 135
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 136
          var childToken = ApiTokens.findOne({                                                                         // 137
            "owner.user.identityId": { $in: identityIds },                                                             // 138
            parentToken: apiToken._id                                                                                  // 139
          });                                                                                                          // 137
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 141
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 143
            this.ready();                                                                                              // 144
            return;                                                                                                    // 145
          }                                                                                                            // 146
        }                                                                                                              // 147
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 149
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 150
        var appIcon = undefined;                                                                                       // 151
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 152
          var icons = pkg.manifest.metadata.icons;                                                                     // 153
          appIcon = icons.grain || icons.appGrid;                                                                      // 154
        }                                                                                                              // 155
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 157
          appTitle: appTitle,                                                                                          // 158
          icon: appIcon,                                                                                               // 159
          appId: appIcon ? undefined : grain.appId                                                                     // 160
        };                                                                                                             // 157
        this.added("tokenInfo", token, {                                                                               // 162
          webkey: true,                                                                                                // 163
          grainId: grainId,                                                                                            // 164
          grainMetadata: denormalizedGrainMetadata                                                                     // 165
        });                                                                                                            // 162
      } else {                                                                                                         // 167
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 168
      }                                                                                                                // 169
    }                                                                                                                  // 170
  }                                                                                                                    // 171
                                                                                                                       //
  this.ready();                                                                                                        // 173
  return;                                                                                                              // 174
});                                                                                                                    // 175
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 177
  check(grainId, String);                                                                                              // 178
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 180
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 181
  }                                                                                                                    // 182
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 184
  if (!grain) {                                                                                                        // 185
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 186
  }                                                                                                                    // 187
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 189
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 190
  }                                                                                                                    // 192
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 194
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 195
                                                                                                                       //
  var _this = this;                                                                                                    // 198
  var query = ApiTokens.find({                                                                                         // 199
    grainId: grainId,                                                                                                  // 200
    identityId: { $in: ownerIdentityIds },                                                                             // 201
    parentToken: { $exists: false },                                                                                   // 202
    "owner.user.identityId": { $in: identityIds },                                                                     // 203
    revoked: { $ne: true }                                                                                             // 204
  });                                                                                                                  // 199
  var handle = query.observe({                                                                                         // 206
    added: function added(apiToken) {                                                                                  // 207
      _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
    }                                                                                                                  // 210
  });                                                                                                                  // 206
                                                                                                                       //
  this.onStop(function () {                                                                                            // 213
    return handle.stop();                                                                                              // 213
  });                                                                                                                  // 213
});                                                                                                                    // 214
                                                                                                                       //
Meteor.publish("grainSize", function (grainId) {                                                                       // 216
  // Publish pseudo-collection containing the size of the grain opened in the given session.                           //
  check(grainId, String);                                                                                              // 218
                                                                                                                       //
  var grain = Grains.findOne(grainId);                                                                                 // 220
  if (!grain || grain.userId !== this.userId) {                                                                        // 221
    return [];                                                                                                         // 222
  }                                                                                                                    // 223
                                                                                                                       //
  var supervisor = globalBackend.cap().getGrain(this.userId, grainId).supervisor;                                      // 225
                                                                                                                       //
  var _this = this;                                                                                                    // 227
  var stopped = false;                                                                                                 // 228
  var promise = getGrainSize(supervisor);                                                                              // 229
                                                                                                                       //
  function getNext(oldSize) {                                                                                          // 231
    promise = getGrainSize(supervisor, oldSize);                                                                       // 232
    promise.then(function (size) {                                                                                     // 233
      if (!stopped) {                                                                                                  // 234
        if (size !== oldSize) {                                                                                        // 235
          // sometimes there are false alarms                                                                          //
          _this.changed("grainSizes", grainId, { size: size });                                                        // 236
        }                                                                                                              // 237
                                                                                                                       //
        getNext(size);                                                                                                 // 239
      }                                                                                                                // 240
    }, function (err) {                                                                                                // 241
                                                                                                                       //
      if (!stopped) {                                                                                                  // 243
        if (err.kjType === "disconnected") {                                                                           // 244
          _this.stop();                                                                                                // 245
        } else {                                                                                                       // 246
          _this.error(err);                                                                                            // 247
        }                                                                                                              // 248
      }                                                                                                                // 249
    });                                                                                                                // 250
  }                                                                                                                    // 251
                                                                                                                       //
  promise.then(function (size) {                                                                                       // 253
    if (!stopped) {                                                                                                    // 254
      _this.added("grainSizes", grainId, { size: size });                                                              // 255
      _this.ready();                                                                                                   // 256
      getNext(size);                                                                                                   // 257
    }                                                                                                                  // 258
  }, function (err) {                                                                                                  // 259
                                                                                                                       //
    if (!stopped) {                                                                                                    // 261
      if (err.kjType === "disconnected") {                                                                             // 262
        _this.stop();                                                                                                  // 263
      } else {                                                                                                         // 264
        _this.error(err);                                                                                              // 265
      }                                                                                                                // 266
    }                                                                                                                  // 267
  });                                                                                                                  // 268
                                                                                                                       //
  _this.onStop(function () {                                                                                           // 270
    stopped = true;                                                                                                    // 271
    promise.cancel();                                                                                                  // 272
  });                                                                                                                  // 273
});                                                                                                                    // 274
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 276
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 277
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 278
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 279
  Grains.find({ trashed: { $lt: trashExpiration } }).forEach(function (grain) {                                        // 280
    waitPromise(globalBackend.deleteGrain(grain._id, grain.userId));                                                   // 281
    Grains.remove({ _id: grain._id });                                                                                 // 282
    globalDb.removeApiTokens({                                                                                         // 283
      grainId: grain._id,                                                                                              // 284
      $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                                // 285
    });                                                                                                                // 283
                                                                                                                       //
    if (grain.lastUsed) {                                                                                              // 291
      DeleteStats.insert({                                                                                             // 292
        type: "grain", // Demo grains can never never get here!                                                        // 293
        lastActive: grain.lastUsed,                                                                                    // 294
        appId: grain.appId                                                                                             // 295
      });                                                                                                              // 292
    }                                                                                                                  // 297
                                                                                                                       //
    Meteor.call("deleteUnusedPackages", grain.appId);                                                                  // 299
  });                                                                                                                  // 300
});                                                                                                                    // 301
                                                                                                                       //
Meteor.methods({                                                                                                       // 303
  moveGrainsToTrash: function moveGrainsToTrash(grainIds) {                                                            // 304
    check(grainIds, [String]);                                                                                         // 305
                                                                                                                       //
    if (this.userId) {                                                                                                 // 307
      Grains.update({ userId: { $eq: this.userId },                                                                    // 308
        _id: { $in: grainIds },                                                                                        // 309
        trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                            // 310
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 314
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 316
        "owner.user.identityId": { $in: identityIds },                                                                 // 317
        trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                          // 318
    }                                                                                                                  // 321
  },                                                                                                                   // 322
                                                                                                                       //
  moveGrainsOutOfTrash: function moveGrainsOutOfTrash(grainIds) {                                                      // 324
    check(grainIds, [String]);                                                                                         // 325
                                                                                                                       //
    if (this.userId) {                                                                                                 // 327
      Grains.update({ userId: { $eq: this.userId },                                                                    // 328
        _id: { $in: grainIds },                                                                                        // 329
        trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                    // 330
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 334
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 336
        "owner.user.identityId": { $in: identityIds },                                                                 // 337
        "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                                // 338
    }                                                                                                                  // 341
  },                                                                                                                   // 342
                                                                                                                       //
  deleteGrain: function deleteGrain(grainId) {                                                                         // 344
    check(grainId, String);                                                                                            // 345
                                                                                                                       //
    if (this.userId) {                                                                                                 // 347
      if (!this.isSimulation) {                                                                                        // 348
        waitPromise(globalBackend.deleteGrain(grainId, this.userId));                                                  // 349
      }                                                                                                                // 350
                                                                                                                       //
      var grain = Grains.findOne({                                                                                     // 352
        _id: grainId,                                                                                                  // 353
        userId: this.userId,                                                                                           // 354
        trashed: { $exists: true }                                                                                     // 355
      });                                                                                                              // 352
      if (grain) {                                                                                                     // 357
        Grains.remove(grainId);                                                                                        // 358
        globalDb.removeApiTokens({                                                                                     // 359
          grainId: grainId,                                                                                            // 360
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 361
        });                                                                                                            // 359
        if (grain.lastUsed) {                                                                                          // 366
          DeleteStats.insert({ type: isDemoUser() ? "demoGrain" : "grain",                                             // 367
            lastActive: grain.lastUsed, appId: grain.appId });                                                         // 368
        }                                                                                                              // 369
                                                                                                                       //
        if (!this.isSimulation) {                                                                                      // 371
          Meteor.call("deleteUnusedPackages", grain.appId);                                                            // 372
        }                                                                                                              // 373
      }                                                                                                                // 374
    }                                                                                                                  // 375
  },                                                                                                                   // 376
                                                                                                                       //
  forgetGrain: function forgetGrain(grainId, identityId) {                                                             // 378
    check(grainId, String);                                                                                            // 379
    check(identityId, String);                                                                                         // 380
                                                                                                                       //
    if (!this.userId) {                                                                                                // 382
      throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                             // 383
    }                                                                                                                  // 384
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 386
      throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                            // 387
    }                                                                                                                  // 388
                                                                                                                       //
    globalDb.removeApiTokens({ grainId: grainId,                                                                       // 390
      "owner.user.identityId": identityId,                                                                             // 391
      "trashed": { $exists: true }                                                                                     // 392
    });                                                                                                                // 390
  },                                                                                                                   // 394
                                                                                                                       //
  updateGrainPreferredIdentity: function updateGrainPreferredIdentity(grainId, identityId) {                           // 396
    check(grainId, String);                                                                                            // 397
    check(identityId, String);                                                                                         // 398
    if (!this.userId) {                                                                                                // 399
      throw new Meteor.Error(403, "Must be logged in.");                                                               // 400
    }                                                                                                                  // 401
                                                                                                                       //
    var grain = globalDb.getGrain(grainId) || {};                                                                      // 403
    if (!grain.userId === this.userId) {                                                                               // 404
      throw new Meteor.Error(403, "Grain not owned by current user.");                                                 // 405
    }                                                                                                                  // 406
                                                                                                                       //
    Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                             // 408
  },                                                                                                                   // 409
                                                                                                                       //
  updateGrainTitle: function updateGrainTitle(grainId, newTitle, identityId) {                                         // 411
    check(grainId, String);                                                                                            // 412
    check(newTitle, String);                                                                                           // 413
    check(identityId, String);                                                                                         // 414
    if (this.userId) {                                                                                                 // 415
      var grain = Grains.findOne(grainId);                                                                             // 416
      if (grain) {                                                                                                     // 417
        if (grain.userId === this.userId) {                                                                            // 418
          Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                         // 419
                                                                                                                       //
          // Denormalize new title out to all sharing tokens.                                                          //
          ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
        } else {                                                                                                       // 425
          if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                    // 426
            throw new Meteor.Error(403, "Current user does not have identity " + identityId);                          // 427
          }                                                                                                            // 428
                                                                                                                       //
          var token = ApiTokens.findOne({                                                                              // 430
            grainId: grainId,                                                                                          // 431
            objectId: { $exists: false },                                                                              // 432
            "owner.user.identityId": identityId                                                                        // 433
          }, {                                                                                                         // 430
            sort: { created: 1 } });                                                                                   // 435
          // The oldest token is our source of truth for the name.                                                     //
          if (token && token.owner.user.title !== newTitle) {                                                          // 437
            if (token.owner.user.upstreamTitle === newTitle) {                                                         // 438
              // User renamed grain to match upstream title. Act like they never renamed it at                         //
              // all.                                                                                                  //
              ApiTokens.update({                                                                                       // 441
                grainId: grainId,                                                                                      // 442
                "owner.user.identityId": identityId                                                                    // 443
              }, {                                                                                                     // 441
                $set: { "owner.user.title": newTitle },                                                                // 445
                $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                     // 446
              }, {                                                                                                     // 444
                multi: true                                                                                            // 448
              });                                                                                                      // 447
            } else {                                                                                                   // 450
              var modification = {                                                                                     // 451
                "owner.user.title": newTitle,                                                                          // 452
                "owner.user.renamed": true                                                                             // 453
              };                                                                                                       // 451
                                                                                                                       //
              if (!token.owner.user.upstreamTitle) {                                                                   // 456
                // If `upstreamTitle` isn't present then it is equal to the old title.                                 //
                modification["owner.user.upstreamTitle"] = token.owner.user.title;                                     // 458
              }                                                                                                        // 459
                                                                                                                       //
              ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
            }                                                                                                          // 464
          }                                                                                                            // 465
        }                                                                                                              // 466
      }                                                                                                                // 467
    }                                                                                                                  // 468
  },                                                                                                                   // 469
                                                                                                                       //
  privatizeGrain: function privatizeGrain(grainId) {                                                                   // 471
    check(grainId, String);                                                                                            // 472
    if (this.userId) {                                                                                                 // 473
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                             // 474
    }                                                                                                                  // 475
  },                                                                                                                   // 476
                                                                                                                       //
  inviteUsersToGrain: function inviteUsersToGrain(origin, identityId, grainId, title, roleAssignment, contacts, message) {
    var _this2 = this;                                                                                                 // 479
                                                                                                                       //
    if (!this.isSimulation) {                                                                                          // 480
      var _ret = function () {                                                                                         // 480
        check(origin, String);                                                                                         // 481
        check(identityId, String);                                                                                     // 482
        check(grainId, String);                                                                                        // 483
        check(title, String);                                                                                          // 484
        check(roleAssignment, roleAssignmentPattern);                                                                  // 485
        check(contacts, [{                                                                                             // 486
          _id: String,                                                                                                 // 488
          isDefault: Match.Optional(Boolean),                                                                          // 489
          profile: Match.ObjectIncluding({                                                                             // 490
            service: String,                                                                                           // 491
            name: String,                                                                                              // 492
            intrinsicName: String                                                                                      // 493
          })                                                                                                           // 490
        }]);                                                                                                           // 487
        check(message, { text: String, html: String });                                                                // 497
        if (!_this2.userId) {                                                                                          // 498
          throw new Meteor.Error(403, "Must be logged in to share by email.");                                         // 499
        }                                                                                                              // 500
                                                                                                                       //
        if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                    // 502
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 503
        }                                                                                                              // 504
                                                                                                                       //
        if (contacts.length === 0) {                                                                                   // 506
          throw new Meteor.Error(400, "No contacts were provided.");                                                   // 507
        }                                                                                                              // 508
                                                                                                                       //
        if (globalDb.isDemoUser()) {                                                                                   // 510
          throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                                // 511
        }                                                                                                              // 512
                                                                                                                       //
        var accountId = _this2.userId;                                                                                 // 514
        var outerResult = { successes: [], failures: [] };                                                             // 515
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 516
        var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                                 // 517
        contacts.forEach(function (contact) {                                                                          // 518
          if (contact.isDefault && contact.profile.service === "email") {                                              // 519
            var emailAddress = contact.profile.intrinsicName;                                                          // 520
            var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
            var url = origin + "/shared/" + result.token;                                                              // 525
            var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
            try {                                                                                                      // 531
              globalDb.incrementDailySentMailCount(accountId);                                                         // 532
              SandstormEmail.send({                                                                                    // 533
                to: emailAddress,                                                                                      // 534
                from: fromEmail,                                                                                       // 535
                replyTo: replyTo,                                                                                      // 536
                subject: title + " - Invitation to collaborate",                                                       // 537
                text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                html: html                                                                                             // 541
              });                                                                                                      // 533
            } catch (e) {                                                                                              // 543
              outerResult.failures.push({ contact: contact, error: e.toString() });                                    // 544
            }                                                                                                          // 545
          } else {                                                                                                     // 546
            var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
            var _url = origin + "/shared/" + _result.token;                                                            // 551
            try {                                                                                                      // 552
              var identity = Meteor.users.findOne({ _id: contact._id });                                               // 553
              var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                     // 554
              if (email) {                                                                                             // 556
                var intrinsicName = contact.profile.intrinsicName;                                                     // 557
                var loginNote = void 0;                                                                                // 558
                if (contact.profile.service === "google") {                                                            // 559
                  loginNote = "Google account with address " + email.email;                                            // 560
                } else if (contact.profile.service === "github") {                                                     // 561
                  loginNote = "Github account with username " + intrinsicName;                                         // 562
                } else if (contact.profile.service === "email") {                                                      // 563
                  loginNote = "email address " + intrinsicName;                                                        // 564
                } else if (contact.profile.service === "ldap") {                                                       // 565
                  loginNote = "LDAP username " + intrinsicName;                                                        // 566
                } else if (contact.profile.service === "saml") {                                                       // 567
                  loginNote = "SAML ID " + intrinsicName;                                                              // 568
                } else {                                                                                               // 569
                  throw new Meteor.Error(500, "Unknown service to email share link.");                                 // 570
                }                                                                                                      // 571
                                                                                                                       //
                var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                globalDb.incrementDailySentMailCount(accountId);                                                       // 578
                SandstormEmail.send({                                                                                  // 579
                  to: email.email,                                                                                     // 580
                  from: fromEmail,                                                                                     // 581
                  replyTo: replyTo,                                                                                    // 582
                  subject: title + " - Invitation to collaborate",                                                     // 583
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                  html: _html                                                                                          // 587
                });                                                                                                    // 579
              } else {                                                                                                 // 589
                outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 593
            } catch (e) {                                                                                              // 594
              outerResult.failures.push({ contact: contact, error: e.toString(),                                       // 595
                warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
            }                                                                                                          // 598
          }                                                                                                            // 599
        });                                                                                                            // 600
                                                                                                                       //
        return {                                                                                                       // 602
          v: outerResult                                                                                               // 602
        };                                                                                                             // 602
      }();                                                                                                             // 480
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 480
    }                                                                                                                  // 603
  },                                                                                                                   // 604
                                                                                                                       //
  requestAccess: function requestAccess(origin, grainId, identityId) {                                                 // 606
    check(origin, String);                                                                                             // 607
    check(grainId, String);                                                                                            // 608
    check(identityId, String);                                                                                         // 609
    if (!this.isSimulation) {                                                                                          // 610
      if (!this.userId) {                                                                                              // 611
        throw new Meteor.Error(403, "Must be logged in to request access.");                                           // 612
      }                                                                                                                // 613
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 615
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 616
      }                                                                                                                // 617
                                                                                                                       //
      var grain = Grains.findOne(grainId);                                                                             // 619
      if (!grain) {                                                                                                    // 620
        throw new Meteor.Error(404, "No such grain");                                                                  // 621
      }                                                                                                                // 622
                                                                                                                       //
      var grainOwner = globalDb.getUser(grain.userId);                                                                 // 624
      var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                               // 625
      if (!email) {                                                                                                    // 626
        throw new Meteor.Error("no email", "Grain owner has no email address.");                                       // 627
      }                                                                                                                // 628
                                                                                                                       //
      var emailAddress = email.email;                                                                                  // 630
                                                                                                                       //
      var identity = globalDb.getIdentity(identityId);                                                                 // 632
      globalDb.addContact(grainOwner._id, identityId);                                                                 // 633
                                                                                                                       //
      var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                            // 635
      var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                             // 636
                                                                                                                       //
      // TODO(soon): In the HTML version, we should display an identity card.                                          //
      var identityNote = "";                                                                                           // 639
      if (identity.profile.service === "google") {                                                                     // 640
        identityNote = " (" + identity.privateIntrinsicName + ")";                                                     // 641
      } else if (identity.profile.service === "github") {                                                              // 642
        identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                          // 643
      } else if (identity.profile.service === "email") {                                                               // 644
        identityNote = " (" + identity.profile.intrinsicName + ")";                                                    // 645
      } else if (identity.profile.service === "ldap") {                                                                // 646
        identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                            // 647
      } else if (identity.profile.service === "saml") {                                                                // 648
        identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                            // 649
      }                                                                                                                // 650
                                                                                                                       //
      var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
      var url = origin + "/share/" + grainId + "/" + identityId;                                                       // 655
                                                                                                                       //
      var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                            // 657
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 660
      var ACCESS_REQUEST_LIMIT = 10;                                                                                   // 661
      var resetCount = true;                                                                                           // 662
      if (user.accessRequests) {                                                                                       // 663
        if (user.accessRequests.resetOn < new Date()) {                                                                // 664
          Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                   // 665
        } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                                // 666
          throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
        } else {                                                                                                       // 670
          resetCount = false;                                                                                          // 671
        }                                                                                                              // 672
      }                                                                                                                // 673
                                                                                                                       //
      var modifier = { $inc: { "accessRequests.count": 1 } };                                                          // 675
      if (resetCount) {                                                                                                // 676
        var tomorrow = new Date(Date.now() + 86400000);                                                                // 677
        modifier.$set = { "accessRequests.resetOn": tomorrow };                                                        // 678
      }                                                                                                                // 679
                                                                                                                       //
      Meteor.users.update({ _id: user._id }, modifier);                                                                // 681
                                                                                                                       //
      SandstormEmail.send({                                                                                            // 683
        to: emailAddress,                                                                                              // 684
        from: fromEmail,                                                                                               // 685
        replyTo: replyTo,                                                                                              // 686
        subject: grain.title + " - Request for access",                                                                // 687
        text: message + "\n\nFollow this link to share access:\n\n" + url,                                             // 688
        html: html                                                                                                     // 689
      });                                                                                                              // 683
    }                                                                                                                  // 691
  }                                                                                                                    // 692
});                                                                                                                    // 303
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Net = Npm.require("net");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Capnp = Npm.require("capnp");                                                                                      // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 34
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 36
HOSTNAME = ROOT_URL.hostname;                                                                                          // 37
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 39
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 40
    _classCallCheck(this, SessionContextImpl);                                                                         // 40
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 41
    this.sessionId = sessionId;                                                                                        // 42
    this.identityId = identityId;                                                                                      // 43
    this.tabId = tabId;                                                                                                // 44
  }                                                                                                                    // 45
                                                                                                                       //
  SessionContextImpl.prototype.offer = function offer(cap, requiredPermissions, descriptor, displayInfo) {             // 39
    var _this2 = this;                                                                                                 // 47
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 48
      if (!_this2.identityId) {                                                                                        // 49
        // TODO(soon): allow non logged in users?                                                                      //
        throw new Meteor.Error(400, "Only logged in users can offer capabilities.");                                   // 51
      }                                                                                                                // 52
                                                                                                                       //
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 54
      var apiTokenOwner = { webkey: null };                                                                            // 55
      var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
      if (isUiView) {                                                                                                  // 59
        apiTokenOwner = {                                                                                              // 60
          user: {                                                                                                      // 61
            identityId: _this2.identityId                                                                              // 62
          }                                                                                                            // 61
        };                                                                                                             // 60
      }                                                                                                                // 69
                                                                                                                       //
      // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                          //
      // are fully implemented for supervisors.                                                                        //
      // The following fields will be overwritten by PersistentUiView.save(), so no need to                            //
      // pass them in:                                                                                                 //
      //title: "", // This will be replaced by the token's title                                                       //
      //denormalizedGrainMetadata: {}, // This will look up the package for the grain referenced.                      //
      var requirement = {                                                                                              // 73
        permissionsHeld: {                                                                                             // 74
          grainId: _this2.grainId,                                                                                     // 75
          identityId: _this2.identityId,                                                                               // 76
          permissions: requiredPermissions                                                                             // 77
        }                                                                                                              // 74
      };                                                                                                               // 73
                                                                                                                       //
      if (!checkRequirements([requirement])) {                                                                         // 81
        throw new Meteor.Error(403, "Permissions not satisfied.");                                                     // 82
      }                                                                                                                // 83
                                                                                                                       //
      var save = castedCap.save(apiTokenOwner);                                                                        // 85
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 86
      ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                   // 87
      var powerboxView = isUiView ? {                                                                                  // 88
        offer: {                                                                                                       // 89
          uiView: {                                                                                                    // 90
            token: sturdyRef.toString(),                                                                               // 91
            tokenId: hashSturdyRef(sturdyRef.toString())                                                               // 92
          }                                                                                                            // 90
        }                                                                                                              // 89
      } : {                                                                                                            // 88
        offer: {                                                                                                       // 96
          url: ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef                            // 97
        }                                                                                                              // 96
      };                                                                                                               // 95
      Sessions.update({ _id: _this2.sessionId }, {                                                                     // 100
        $set: {                                                                                                        // 102
          powerboxView: powerboxView                                                                                   // 103
        }                                                                                                              // 102
      });                                                                                                              // 101
    });                                                                                                                // 107
  };                                                                                                                   // 108
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 39
}();                                                                                                                   // 39
                                                                                                                       //
Meteor.methods({                                                                                                       // 111
  finishPowerboxRequest: function finishPowerboxRequest(webkeyUrl, saveLabel, identityId, grainId) {                   // 112
    check(webkeyUrl, String);                                                                                          // 113
    check(saveLabel, Match.OneOf(undefined, null, String));                                                            // 114
    check(identityId, String);                                                                                         // 115
    check(grainId, String);                                                                                            // 116
                                                                                                                       //
    var userId = Meteor.userId();                                                                                      // 118
    if (!userId || !globalDb.userHasIdentity(userId, identityId)) {                                                    // 119
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 120
    }                                                                                                                  // 121
                                                                                                                       //
    var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                    // 123
    var hostId = matchWildcardHost(parsedWebkey.host);                                                                 // 124
    if (!hostId || !globalDb.isApiHostId(hostId)) {                                                                    // 125
      throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
    }                                                                                                                  // 128
                                                                                                                       //
    var token = parsedWebkey.hash;                                                                                     // 130
    if (!token) {                                                                                                      // 131
      throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
    }                                                                                                                  // 134
                                                                                                                       //
    token = token.slice(1);                                                                                            // 136
    if (globalDb.isTokenSpecificHostId(hostId) && hostId !== globalDb.apiHostIdForToken(token)) {                      // 137
      // Note: This case is not security-sensitive. The client could easily compute the correct                        //
      //   host ID for this token. But since they've passed one that doesn't match, we assume                          //
      //   something is wrong and stop here.                                                                           //
      throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                    // 141
    }                                                                                                                  // 142
                                                                                                                       //
    var cap = restoreInternal(new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;       // 144
    var castedCap = cap.castAs(SystemPersistent);                                                                      // 146
    var grainOwner = {                                                                                                 // 147
      grainId: grainId,                                                                                                // 148
      introducerIdentity: identityId                                                                                   // 149
    };                                                                                                                 // 147
    if (saveLabel) {                                                                                                   // 151
      grainOwner.saveLabel = {                                                                                         // 152
        defaultText: saveLabel                                                                                         // 153
      };                                                                                                               // 152
    }                                                                                                                  // 155
                                                                                                                       //
    var save = castedCap.save({ grain: grainOwner });                                                                  // 157
    var sturdyRef = waitPromise(save).sturdyRef;                                                                       // 158
                                                                                                                       //
    return sturdyRef.toString();                                                                                       // 160
  },                                                                                                                   // 161
  finishPowerboxOffer: function finishPowerboxOffer(sessionId) {                                                       // 163
    check(sessionId, String);                                                                                          // 164
                                                                                                                       //
    Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                           // 166
  },                                                                                                                   // 167
  getViewInfoForApiToken: function getViewInfoForApiToken(apiTokenId) {                                                // 169
    check(apiTokenId, String);                                                                                         // 170
    var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                    // 171
    if (!token) {                                                                                                      // 172
      throw new Meteor.Error(400, "No such token.");                                                                   // 173
    }                                                                                                                  // 174
                                                                                                                       //
    var grain = globalDb.collections.grains.findOne(token.grainId);                                                    // 176
    if (!grain) {                                                                                                      // 177
      throw new Meteor.Error(500, "No grain found for token.");                                                        // 178
    }                                                                                                                  // 179
                                                                                                                       //
    return grain.cachedViewInfo;                                                                                       // 181
  }                                                                                                                    // 182
});                                                                                                                    // 111
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 185
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 185
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 186
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 186
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 186
  }                                                                                                                    // 188
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function _getPublicId() {                                            // 185
    // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                      //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    while (!this.publicId) {                                                                                           // 195
      // We haven't looked up the public ID yet.                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                           // 197
      if (!grain) throw new Error("Grain does not exist.");                                                            // 198
                                                                                                                       //
      if (grain.publicId) {                                                                                            // 200
        this.publicId = grain.publicId;                                                                                // 201
      } else {                                                                                                         // 202
        // The grain doesn't have a public ID yet. Generate one.                                                       //
        var candidate = generateRandomHostname(20);                                                                    // 204
                                                                                                                       //
        if (Grains.findOne({ publicId: candidate })) {                                                                 // 206
          // This should never ever happen.                                                                            //
          console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");     // 208
          continue;                                                                                                    // 210
        }                                                                                                              // 211
                                                                                                                       //
        // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                    //
        // simultaneously.                                                                                             //
        if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
          // We won the race.                                                                                          //
          this.publicId = candidate;                                                                                   // 218
        }                                                                                                              // 219
      }                                                                                                                // 220
    }                                                                                                                  // 221
                                                                                                                       //
    return this.publicId;                                                                                              // 223
  };                                                                                                                   // 224
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function _getAddress() {                                              // 185
    // Get the grain's outgoing e-mail address.                                                                        //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    return this._getPublicId() + "@" + HOSTNAME;                                                                       // 231
  };                                                                                                                   // 232
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function _getUserAddress() {                                      // 185
    // Get the user's e-mail address.                                                                                  //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                           // 239
                                                                                                                       //
    var identity = globalDb.getIdentity(grain.identityId);                                                             // 241
                                                                                                                       //
    var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                        // 243
    var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                        // 244
                                                                                                                       //
    var result = {};                                                                                                   // 246
    if (email) {                                                                                                       // 247
      result.address = email;                                                                                          // 248
    }                                                                                                                  // 249
                                                                                                                       //
    if (identity.profile.name) {                                                                                       // 251
      result.name = identity.profile.name;                                                                             // 252
    }                                                                                                                  // 253
                                                                                                                       //
    return result;                                                                                                     // 255
  };                                                                                                                   // 256
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function send(email) {                                                       // 185
    return hackSendEmail(this, email);                                                                                 // 259
  };                                                                                                                   // 260
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function getPublicId() {                                              // 185
    return inMeteor(function () {                                                                                      // 263
      var result = {};                                                                                                 // 264
                                                                                                                       //
      result.publicId = this._getPublicId();                                                                           // 266
      result.hostname = HOSTNAME;                                                                                      // 267
      result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                   // 268
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                             // 270
      result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                   // 271
                                                                                                                       //
      return result;                                                                                                   // 273
    }.bind(this));                                                                                                     // 274
  };                                                                                                                   // 275
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function httpGet(url) {                                                   // 185
    var _this = this;                                                                                                  // 278
    var session = _this;                                                                                               // 279
                                                                                                                       //
    return new Promise(function (resolve, reject) {                                                                    // 281
      var requestMethod = Http.request;                                                                                // 282
      if (url.indexOf("https://") === 0) {                                                                             // 283
        requestMethod = Https.request;                                                                                 // 284
      } else if (url.indexOf("http://") !== 0) {                                                                       // 285
        err = new Error("Protocol not recognized.");                                                                   // 286
        err.nature = "precondition";                                                                                   // 287
        reject(err);                                                                                                   // 288
      }                                                                                                                // 289
                                                                                                                       //
      req = requestMethod(url, function (resp) {                                                                       // 291
        var buffers = [];                                                                                              // 292
        var err = void 0;                                                                                              // 293
                                                                                                                       //
        switch (Math.floor(resp.statusCode / 100)) {                                                                   // 295
          case 2:                                                                                                      // 296
            // 2xx response -- OK.                                                                                     //
            resp.on("data", function (buf) {                                                                           // 297
              buffers.push(buf);                                                                                       // 298
            });                                                                                                        // 299
                                                                                                                       //
            resp.on("end", function () {                                                                               // 301
              resolve({                                                                                                // 302
                content: Buffer.concat(buffers),                                                                       // 303
                mimeType: resp.headers["content-type"] || null                                                         // 304
              });                                                                                                      // 302
            });                                                                                                        // 306
            break;                                                                                                     // 307
          case 3:                                                                                                      // 308
            // 3xx response -- redirect.                                                                               //
            resolve(session.httpGet(resp.headers.location));                                                           // 309
            break;                                                                                                     // 310
          case 4:                                                                                                      // 311
            // 4xx response -- client error.                                                                           //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 312
            err.nature = "precondition";                                                                               // 313
            reject(err);                                                                                               // 314
            break;                                                                                                     // 315
          case 5:                                                                                                      // 316
            // 5xx response -- internal server error.                                                                  //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 317
            err.nature = "localBug";                                                                                   // 318
            reject(err);                                                                                               // 319
            break;                                                                                                     // 320
          default:                                                                                                     // 321
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 322
            err.nature = "localBug";                                                                                   // 323
            reject(err);                                                                                               // 324
            break;                                                                                                     // 325
        }                                                                                                              // 295
      });                                                                                                              // 327
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 329
        e.nature = "networkFailure";                                                                                   // 330
        reject(e);                                                                                                     // 331
      });                                                                                                              // 332
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 334
        req.abort();                                                                                                   // 335
        err = new Error("Request timed out.");                                                                         // 336
        err.nature = "localBug";                                                                                       // 337
        err.durability = "overloaded";                                                                                 // 338
        reject(err);                                                                                                   // 339
      });                                                                                                              // 340
                                                                                                                       //
      req.end();                                                                                                       // 342
    });                                                                                                                // 343
  };                                                                                                                   // 344
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function getUserAddress() {                                        // 185
    return inMeteor(function () {                                                                                      // 347
      return this._getUserAddress();                                                                                   // 348
    }.bind(this));                                                                                                     // 349
  };                                                                                                                   // 350
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function obsoleteGenerateApiToken(petname, userInfo, expires) {
    throw new Error("generateApiToken() has been removed. Use offer templates instead.");                              // 353
  };                                                                                                                   // 354
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function obsoleteListApiTokens() {                          // 185
    throw new Error("listApiTokens() has been removed. Use offer templates instead.");                                 // 357
  };                                                                                                                   // 358
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function obsoleteRevokeApiToken(tokenId) {                 // 185
    throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                                // 361
  };                                                                                                                   // 362
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function getUiViewForEndpoint(url) {                         // 185
    var parsedUrl = Url.parse(url);                                                                                    // 365
                                                                                                                       //
    if (parsedUrl.hash) {                                                                                              // 367
      // Assume that anything with a fragment is a webkey                                                              //
      if (parsedUrl.pathname) {                                                                                        // 368
        throw new Error("Webkey urls cannot contain a path.");                                                         // 369
      }                                                                                                                // 370
                                                                                                                       //
      var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                         // 372
      var hostId = matchWildcardHost(parsedUrl.host);                                                                  // 373
      if (hostId && globalDb.isApiHostId(hostId)) {                                                                    // 374
        // Connecting to a local capability.                                                                           //
        return getWrappedUiViewForToken(token);                                                                        // 376
      } else {                                                                                                         // 377
        // Connecting to a remote server with a bearer token.                                                          //
        // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                           //
        return { view: new ExternalUiView(url, this.grainId, token) };                                                 // 380
      }                                                                                                                // 381
    } else {                                                                                                           // 382
      return { view: new ExternalUiView(url, this.grainId) };                                                          // 383
    }                                                                                                                  // 384
  };                                                                                                                   // 385
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 185
}(SessionContextImpl);                                                                                                 // 185
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 388
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 389
};                                                                                                                     // 391
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 393
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 395
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 398
  for (var i = 0; i < length; i++) {                                                                                   // 399
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 400
  }                                                                                                                    // 401
                                                                                                                       //
  return digits.join("");                                                                                              // 403
};                                                                                                                     // 404
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 17
  defaultText: String,                                                                                                 // 18
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 19
};                                                                                                                     // 17
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 22
                                                                                                                       //
UserActions.allow({                                                                                                    // 24
  insert: function insert(userId, action) {                                                                            // 25
    // TODO(cleanup): This check keeps breaking. Use a method instead that takes the package                           //
    //   ID as an argument.                                                                                            //
    check(action, {                                                                                                    // 28
      userId: String,                                                                                                  // 29
      packageId: String,                                                                                               // 30
      appId: String,                                                                                                   // 31
      appTitle: Match.Optional(localizedTextPattern),                                                                  // 32
      appMarketingVersion: Match.Optional(Object),                                                                     // 33
      appVersion: Match.Integer,                                                                                       // 34
      title: localizedTextPattern,                                                                                     // 35
      nounPhrase: Match.Optional(localizedTextPattern),                                                                // 36
      command: {                                                                                                       // 37
        executablePath: Match.Optional(String),                                                                        // 38
        deprecatedExecutablePath: Match.Optional(String),                                                              // 39
        args: Match.Optional([String]),                                                                                // 40
        argv: Match.Optional([String]),                                                                                // 41
        environ: Match.Optional([{ key: String, value: String }])                                                      // 42
      }                                                                                                                // 37
    });                                                                                                                // 28
    return userId && isSignedUpOrDemo() && action.userId === userId;                                                   // 45
  },                                                                                                                   // 46
                                                                                                                       //
  remove: function remove(userId, action) {                                                                            // 48
    return userId && action.userId === userId;                                                                         // 49
  }                                                                                                                    // 50
});                                                                                                                    // 24
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 56
  cancelDownload: function (_cancelDownload) {                                                                         // 57
    function cancelDownload(_x) {                                                                                      // 57
      return _cancelDownload.apply(this, arguments);                                                                   // 57
    }                                                                                                                  // 57
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 57
      return _cancelDownload.toString();                                                                               // 57
    };                                                                                                                 // 57
                                                                                                                       //
    return cancelDownload;                                                                                             // 57
  }(function (packageId) {                                                                                             // 57
    check(packageId, String);                                                                                          // 58
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 61
  }),                                                                                                                  // 62
                                                                                                                       //
  newUploadToken: function newUploadToken() {                                                                          // 64
    if (!isSignedUp()) {                                                                                               // 65
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                              // 66
    }                                                                                                                  // 67
                                                                                                                       //
    if (globalDb.isUninvitedFreeUser()) {                                                                              // 69
      throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                                 // 70
    }                                                                                                                  // 71
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 73
    uploadTokens[token] = setTimeout(function () {                                                                     // 74
      delete uploadTokens[token];                                                                                      // 75
    }, 20 * 60 * 1000);                                                                                                // 76
                                                                                                                       //
    return token;                                                                                                      // 78
  },                                                                                                                   // 79
                                                                                                                       //
  upgradeGrains: function upgradeGrains(appId, version, packageId) {                                                   // 81
    this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                               // 82
  },                                                                                                                   // 83
                                                                                                                       //
  ensureInstalled: function ensureInstalled(packageId, url, isRetry) {                                                 // 85
    check(packageId, String);                                                                                          // 86
    check(url, Match.OneOf(String, undefined, null));                                                                  // 87
    check(isRetry, Boolean);                                                                                           // 88
                                                                                                                       //
    if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                          // 90
      throw new Meteor.Error(400, "The package ID contains illegal characters.");                                      // 91
    }                                                                                                                  // 92
                                                                                                                       //
    if (!this.userId) {                                                                                                // 94
      if (allowDemo && isSafeDemoAppUrl(url)) {                                                                        // 95
        // continue on                                                                                                 //
      } else {                                                                                                         // 97
          // jscs:ignore disallowEmptyBlocks                                                                           //
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 98
        }                                                                                                              // 99
    } else if (!isSignedUp() && !isDemoUser()) {                                                                       // 100
      throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");      // 101
    } else if (isUserOverQuota(Meteor.user())) {                                                                       // 103
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 104
    }                                                                                                                  // 106
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 108
                                                                                                                       //
    if (!pkg || pkg.status !== "ready") {                                                                              // 110
      if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                            // 111
        if (!isSafeDemoAppUrl(url)) {                                                                                  // 112
          // TODO(someday): Billing prompt on client side.                                                             //
          throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
        }                                                                                                              // 116
      }                                                                                                                // 117
    }                                                                                                                  // 118
                                                                                                                       //
    if (!pkg || isRetry) {                                                                                             // 120
      globalDb.startInstall(packageId, url, isRetry);                                                                  // 121
    }                                                                                                                  // 122
  }                                                                                                                    // 123
});                                                                                                                    // 56
                                                                                                                       //
Router.map(function () {                                                                                               // 126
  this.route("upload", {                                                                                               // 127
    where: "server",                                                                                                   // 128
    path: "/upload/:token",                                                                                            // 129
                                                                                                                       //
    action: function action() {                                                                                        // 131
      if (!this.params.token || !uploadTokens[this.params.token]) {                                                    // 132
        this.response.writeHead(403, {                                                                                 // 133
          "Content-Type": "text/plain"                                                                                 // 134
        });                                                                                                            // 133
        this.response.write("Invalid upload token.");                                                                  // 136
        this.response.end();                                                                                           // 137
      } else if (this.request.method === "POST") {                                                                     // 138
        try {                                                                                                          // 139
          var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                        // 140
          this.response.writeHead(200, {                                                                               // 141
            "Content-Length": packageId.length,                                                                        // 142
            "Content-Type": "text/plain"                                                                               // 143
          });                                                                                                          // 141
          this.response.write(packageId);                                                                              // 145
          this.response.end();                                                                                         // 146
          clearTimeout(uploadTokens[this.params.token]);                                                               // 147
          delete uploadTokens[this.params.token];                                                                      // 148
        } catch (error) {                                                                                              // 149
          console.error(error.stack);                                                                                  // 150
          this.response.writeHead(500, {                                                                               // 151
            "Content-Type": "text/plain"                                                                               // 152
          });                                                                                                          // 151
          this.response.write("Unpacking SPK failed; is it valid?");                                                   // 154
          this.response.end();                                                                                         // 155
        };                                                                                                             // 156
      } else {                                                                                                         // 157
        this.response.writeHead(405, {                                                                                 // 158
          "Content-Type": "text/plain"                                                                                 // 159
        });                                                                                                            // 158
        this.response.write("You can only POST here.");                                                                // 161
        this.response.end();                                                                                           // 162
      }                                                                                                                // 163
    }                                                                                                                  // 164
  });                                                                                                                  // 127
});                                                                                                                    // 166
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
                                                                                                                       // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 28
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 30
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 37
  if (Meteor.settings.replicaNumber) {                                                                                 // 38
    throw new Error("This can only be called on the main front-end replica.");                                         // 39
  }                                                                                                                    // 40
};                                                                                                                     // 41
                                                                                                                       //
Meteor.methods({                                                                                                       // 43
  deleteUnusedPackages: function deleteUnusedPackages(appId) {                                                         // 44
    check(appId, String);                                                                                              // 45
    Packages.find({ appId: appId }).forEach(function (pkg) {                                                           // 46
      deletePackage(pkg._id);                                                                                          // 46
    });                                                                                                                // 46
  }                                                                                                                    // 47
});                                                                                                                    // 43
                                                                                                                       //
deletePackage = function deletePackage(packageId) {                                                                    // 50
  // Mark package for possible deletion;                                                                               //
  Packages.update({ _id: packageId, status: "ready" }, { $set: { shouldCleanup: true } });                             // 52
};                                                                                                                     // 53
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 55
  verifyIsMainReplica();                                                                                               // 56
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 58
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 60
    return;                                                                                                            // 61
  }                                                                                                                    // 62
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 64
                                                                                                                       //
  try {                                                                                                                // 66
    var action = UserActions.findOne({ packageId: packageId });                                                        // 67
    var grain = Grains.findOne({ packageId: packageId });                                                              // 68
    var notificationQuery = {};                                                                                        // 69
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 70
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery))) {                       // 71
      Packages.update({                                                                                                // 72
        _id: packageId                                                                                                 // 73
      }, {                                                                                                             // 72
        $set: { status: "delete" },                                                                                    // 75
        $unset: { shouldCleanup: "" }                                                                                  // 76
      });                                                                                                              // 74
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 78
      Packages.remove(packageId);                                                                                      // 79
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 82
        globalDb.unrefStaticAsset(assetId);                                                                            // 83
      });                                                                                                              // 84
    } else {                                                                                                           // 85
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 86
    }                                                                                                                  // 87
                                                                                                                       //
    delete installers[packageId];                                                                                      // 89
  } catch (error) {                                                                                                    // 90
    delete installers[packageId];                                                                                      // 91
    throw error;                                                                                                       // 92
  }                                                                                                                    // 93
};                                                                                                                     // 94
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 96
  verifyIsMainReplica();                                                                                               // 97
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 99
    return;                                                                                                            // 100
  }                                                                                                                    // 101
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 103
  installers[pkg._id] = installer;                                                                                     // 104
  installer.start();                                                                                                   // 105
};                                                                                                                     // 106
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 108
  Packages.remove({ _id: packageId, status: "download" });                                                             // 109
};                                                                                                                     // 110
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 112
  verifyIsMainReplica();                                                                                               // 113
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 115
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 118
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 120
      throw new Error("Canceled");                                                                                     // 121
    })();                                                                                                              // 122
  }                                                                                                                    // 123
};                                                                                                                     // 124
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 126
  installers = {};                                                                                                     // 127
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 129
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 131
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 134
      added: startInstallInternal,                                                                                     // 135
      removed: cancelDownloadInternal                                                                                  // 136
    });                                                                                                                // 134
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 140
      added: deletePackageInternal                                                                                     // 141
    });                                                                                                                // 140
  });                                                                                                                  // 143
}                                                                                                                      // 144
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 146
  return new Promise(function (resolve, reject) {                                                                      // 147
    var id = Random.id();                                                                                              // 148
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 150
    var hasher = Crypto.createHash("sha256");                                                                          // 151
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 153
      try {                                                                                                            // 154
        hasher.update(chunk);                                                                                          // 155
        backendStream.write(chunk);                                                                                    // 156
      } catch (err) {                                                                                                  // 157
        reject(err);                                                                                                   // 158
      }                                                                                                                // 159
    });                                                                                                                // 160
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 162
      try {                                                                                                            // 163
        (function () {                                                                                                 // 163
          backendStream.done();                                                                                        // 164
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 165
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 166
            return packageId;                                                                                          // 167
          }));                                                                                                         // 168
          backendStream.close();                                                                                       // 169
        })();                                                                                                          // 163
      } catch (err) {                                                                                                  // 170
        reject(err);                                                                                                   // 171
      }                                                                                                                // 172
    });                                                                                                                // 173
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 175
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 177
        backendStream.close();                                                                                         // 178
        reject(err);                                                                                                   // 179
      } catch (err2) {                                                                                                 // 180
        reject(err2);                                                                                                  // 181
      }                                                                                                                // 182
    });                                                                                                                // 183
  });                                                                                                                  // 184
};                                                                                                                     // 185
                                                                                                                       //
AppInstaller = function () {                                                                                           // 187
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 188
    _classCallCheck(this, AppInstaller);                                                                               // 188
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 189
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 191
    this.url = url;                                                                                                    // 192
    this.failed = false;                                                                                               // 193
    this.appId = appId;                                                                                                // 194
    this.isAutoUpdated = isAutoUpdated;                                                                                // 195
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 198
  }                                                                                                                    // 199
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function updateProgress(status, progress, error, manifest) {                 // 187
    // TODO(security):  On error, we should actually delete the package from the database and only                     //
    //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                       //
    //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                          //
    //   already-downloading package but specifies a different URL, we really should initiate an                       //
    //   entirely separate download...  but cancel it if the first download succeeds.)                                 //
                                                                                                                       //
    this.status = status;                                                                                              // 208
    this.progress = progress || -1;                                                                                    // 209
    this.error = error;                                                                                                // 210
    this.manifest = manifest || null;                                                                                  // 211
                                                                                                                       //
    var _this = this;                                                                                                  // 213
                                                                                                                       //
    // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                     //
    // occur in exactly the order in which we generate them, so we use a promise chain to serialize                    //
    // them.                                                                                                           //
    this.writeChain = this.writeChain.then(function () {                                                               // 218
      return inMeteor(function () {                                                                                    // 219
        if (manifest) extractManifestAssets(manifest);                                                                 // 220
                                                                                                                       //
        Packages.update(_this.packageId, {                                                                             // 222
          $set: {                                                                                                      // 223
            status: _this.status,                                                                                      // 224
            progress: _this.progress,                                                                                  // 225
            error: _this.error ? _this.error.message : null,                                                           // 226
            manifest: _this.manifest,                                                                                  // 227
            appId: _this.appId,                                                                                        // 228
            authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                     // 229
          }                                                                                                            // 223
        });                                                                                                            // 222
                                                                                                                       //
        if (_this.authorPgpKeyFingerprint) {                                                                           // 233
          globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                           // 234
        }                                                                                                              // 235
      })["catch"](function (err) {                                                                                     // 236
        console.error(err.stack);                                                                                      // 237
      });                                                                                                              // 238
    });                                                                                                                // 239
  };                                                                                                                   // 240
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function wrapCallback(method) {                                                // 187
    // Note that the function below must not be an arrow function, since arrow functions do not have                   //
    // access to the context's arguments array.                                                                        //
    var _this = this;                                                                                                  // 245
    return function () {                                                                                               // 246
      if (_this.failed) return;                                                                                        // 247
      try {                                                                                                            // 248
        return method.apply(_this, _.toArray(arguments));                                                              // 249
      } catch (err) {                                                                                                  // 250
        _this.failed = true;                                                                                           // 251
        _this.cleanup();                                                                                               // 252
        _this.updateProgress("failed", 0, err);                                                                        // 253
        _this.writeChain = _this.writeChain.then(function () {                                                         // 254
          delete installers[_this.packageId];                                                                          // 255
        });                                                                                                            // 256
        console.error("Failed to install app:", err.stack);                                                            // 257
      }                                                                                                                // 258
    };                                                                                                                 // 259
  };                                                                                                                   // 260
                                                                                                                       //
  AppInstaller.prototype.cleanup = function cleanup() {                                                                // 187
    if (this.uploadStream) {                                                                                           // 263
      try {                                                                                                            // 264
        this.uploadStream.close();                                                                                     // 265
      } catch (err) {}                                                                                                 // 266
                                                                                                                       //
      delete this.uploadStream;                                                                                        // 268
    }                                                                                                                  // 269
                                                                                                                       //
    if (this.downloadRequest) {                                                                                        // 271
      try {                                                                                                            // 272
        this.downloadRequest.abort();                                                                                  // 273
      } catch (err) {}                                                                                                 // 274
                                                                                                                       //
      delete this.downloadRequest;                                                                                     // 276
    }                                                                                                                  // 277
  };                                                                                                                   // 278
                                                                                                                       //
  AppInstaller.prototype.start = function start() {                                                                    // 187
    var _this2 = this;                                                                                                 // 280
                                                                                                                       //
    return this.wrapCallback(function () {                                                                             // 281
      _this2.cleanup();                                                                                                // 282
                                                                                                                       //
      globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                   // 284
        if (info.appId) {                                                                                              // 285
          _this2.appId = info.appId;                                                                                   // 286
          _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 287
          _this2.done(info.manifest);                                                                                  // 288
        } else {                                                                                                       // 289
          _this2.doDownload();                                                                                         // 290
        }                                                                                                              // 291
      }), _this2.wrapCallback(function (err) {                                                                         // 292
        throw err;                                                                                                     // 293
      }));                                                                                                             // 294
    })();                                                                                                              // 295
  };                                                                                                                   // 296
                                                                                                                       //
  AppInstaller.prototype.doDownload = function doDownload() {                                                          // 187
    if (!this.url) {                                                                                                   // 299
      throw new Error("Unknown package ID, and no URL was provided.");                                                 // 300
    }                                                                                                                  // 301
                                                                                                                       //
    console.log("Downloading app:", this.url);                                                                         // 303
    this.updateProgress("download");                                                                                   // 304
                                                                                                                       //
    this.uploadStream = globalBackend.cap().installPackage().stream;                                                   // 306
    return this.doDownloadTo(this.uploadStream);                                                                       // 307
  };                                                                                                                   // 308
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function doDownloadTo(out) {                                                   // 187
    var _this3 = this;                                                                                                 // 310
                                                                                                                       //
    var url = Url.parse(this.url);                                                                                     // 311
    var options = {                                                                                                    // 312
      hostname: url.hostname,                                                                                          // 313
      port: url.port,                                                                                                  // 314
      path: url.path                                                                                                   // 315
    };                                                                                                                 // 312
                                                                                                                       //
    var protocol = void 0;                                                                                             // 318
    if (url.protocol === "http:" || url.protocol === "https:") {                                                       // 319
      protocol = Request.defaults({                                                                                    // 320
        maxRedirects: 20,                                                                                              // 321
        // Since we will verify the download against a hash anyway, we don't need to verify the                        //
        // server's certificate. In fact, the only reason we support HTTPS at all here is because                      //
        // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                   //
        // certificate check here is helpful in that it means we don't have to worry about having a                    //
        // reasonable list of trusted CAs available to Sandstorm.                                                      //
        strictSSL: false                                                                                               // 327
      });                                                                                                              // 320
    } else {                                                                                                           // 329
      throw new Error("Protocol not supported: " + url.protocol);                                                      // 330
    }                                                                                                                  // 331
                                                                                                                       //
    // TODO(security):  It could arguably be a security problem that it's possible to probe the                        //
    //   server's local network (behind any firewalls) by presenting URLs here.                                        //
    var bytesExpected = undefined;                                                                                     // 335
    var bytesReceived = 0;                                                                                             // 336
    var hasher = Crypto.createHash("sha256");                                                                          // 337
    var done = false;                                                                                                  // 338
    var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                            // 339
      if (!done) {                                                                                                     // 340
        if (bytesExpected) {                                                                                           // 341
          _this3.updateProgress("download", bytesReceived / bytesExpected);                                            // 342
        } else {                                                                                                       // 343
          _this3.updateProgress("download", bytesReceived);                                                            // 344
        }                                                                                                              // 345
      }                                                                                                                // 346
    }), 500);                                                                                                          // 347
                                                                                                                       //
    var request = protocol.get(this.url);                                                                              // 349
                                                                                                                       //
    request.on("response", this.wrapCallback(function (response) {                                                     // 351
      if ("content-length" in response.headers) {                                                                      // 352
        bytesExpected = parseInt(response.headers["content-length"]);                                                  // 353
      }                                                                                                                // 354
    }));                                                                                                               // 355
                                                                                                                       //
    request.on("data", this.wrapCallback(function (chunk) {                                                            // 357
      hasher.update(chunk);                                                                                            // 358
      out.write(chunk);                                                                                                // 359
      bytesReceived += chunk.length;                                                                                   // 360
      updateDownloadProgress();                                                                                        // 361
    }));                                                                                                               // 362
                                                                                                                       //
    request.on("end", this.wrapCallback(function () {                                                                  // 364
      out.done();                                                                                                      // 365
                                                                                                                       //
      if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                    // 367
        throw new Error("Package hash did not match.");                                                                // 368
      }                                                                                                                // 369
                                                                                                                       //
      done = true;                                                                                                     // 371
      delete _this3.downloadRequest;                                                                                   // 372
                                                                                                                       //
      _this3.updateProgress("unpack");                                                                                 // 374
      out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                          // 375
        _this3.appId = info.appId;                                                                                     // 376
        _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                                 // 377
        _this3.done(info.manifest);                                                                                    // 378
      }), _this3.wrapCallback(function (err) {                                                                         // 379
        throw err;                                                                                                     // 380
      }));                                                                                                             // 381
    }));                                                                                                               // 382
                                                                                                                       //
    request.on("error", this.wrapCallback(function (err) {                                                             // 384
      throw err;                                                                                                       // 384
    }));                                                                                                               // 384
                                                                                                                       //
    this.downloadRequest = request;                                                                                    // 386
  };                                                                                                                   // 387
                                                                                                                       //
  AppInstaller.prototype.done = function done(manifest) {                                                              // 187
    console.log("App ready:", this.packageId);                                                                         // 390
    this.updateProgress("ready", 1, undefined, manifest);                                                              // 391
    var _this = this;                                                                                                  // 392
    _this.writeChain = _this.writeChain.then(function () {                                                             // 393
      return inMeteor(function () {                                                                                    // 394
        if (_this.isAutoUpdated) {                                                                                     // 395
          globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
        }                                                                                                              // 399
      });                                                                                                              // 400
    }).then(function () {                                                                                              // 401
      delete installers[_this.packageId];                                                                              // 402
    });                                                                                                                // 403
  };                                                                                                                   // 404
                                                                                                                       //
  return AppInstaller;                                                                                                 // 187
}();                                                                                                                   // 187
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 407
  var metadata = manifest.metadata;                                                                                    // 408
  if (!metadata) return;                                                                                               // 409
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 411
  if (icons) {                                                                                                         // 412
    var handleIcon = function handleIcon(icon) {                                                                       // 413
      if (icon.svg) {                                                                                                  // 414
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 415
        icon.format = "svg";                                                                                           // 416
        delete icon.svg;                                                                                               // 417
        return true;                                                                                                   // 418
      } else if (icon.png) {                                                                                           // 419
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 421
        if (!normalDpi) return false;                                                                                  // 422
        icon.format = "png";                                                                                           // 423
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 424
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 426
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 428
        }                                                                                                              // 429
                                                                                                                       //
        delete icon.png;                                                                                               // 431
        return true;                                                                                                   // 432
      } else {                                                                                                         // 433
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 435
      }                                                                                                                // 436
    };                                                                                                                 // 437
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 439
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 440
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 443
    if (icons.marketBig) delete icons.marketBig;                                                                       // 444
  }                                                                                                                    // 445
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 447
    if (text.defaultText) {                                                                                            // 448
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 449
      delete text.defaultText;                                                                                         // 450
    }                                                                                                                  // 451
                                                                                                                       //
    if (text.localizations) {                                                                                          // 453
      text.localizations.forEach(function (localization) {                                                             // 454
        if (localization.text) {                                                                                       // 455
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 456
          delete localization.text;                                                                                    // 458
        }                                                                                                              // 459
      });                                                                                                              // 460
    }                                                                                                                  // 461
  };                                                                                                                   // 462
                                                                                                                       //
  var license = metadata.license;                                                                                      // 464
  if (license) {                                                                                                       // 465
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 466
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 467
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 468
  }                                                                                                                    // 469
                                                                                                                       //
  var author = metadata.author;                                                                                        // 471
  if (author) {                                                                                                        // 472
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 474
  }                                                                                                                    // 475
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 478
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 481
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 484
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 487
};                                                                                                                     // 488
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 490
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 493
  if (!metadata) return [];                                                                                            // 494
                                                                                                                       //
  var result = [];                                                                                                     // 496
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 498
  if (icons) {                                                                                                         // 499
    var handleIcon = function handleIcon(icon) {                                                                       // 500
      if (icon.assetId) {                                                                                              // 501
        result.push(icon.assetId);                                                                                     // 502
      }                                                                                                                // 503
    };                                                                                                                 // 504
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 506
    if (icons.grain) handleIcon(icons.grain);                                                                          // 507
  }                                                                                                                    // 508
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 510
    if (text.defaultTextAssetId) {                                                                                     // 511
      result.push(defaultTextAssetId);                                                                                 // 512
    }                                                                                                                  // 513
                                                                                                                       //
    if (text.localizations) {                                                                                          // 515
      text.localizations.forEach(function (localization) {                                                             // 516
        if (localization.assetId) {                                                                                    // 517
          result.push(localization.assetId);                                                                           // 518
        }                                                                                                              // 519
      });                                                                                                              // 520
    }                                                                                                                  // 521
  };                                                                                                                   // 522
                                                                                                                       //
  var license = metadata.license;                                                                                      // 524
  if (license) {                                                                                                       // 525
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 526
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 527
    if (license.notices) handleLocalizedText(license.notices);                                                         // 528
  }                                                                                                                    // 529
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 531
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 532
                                                                                                                       //
  return result;                                                                                                       // 534
};                                                                                                                     // 535
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Dns = Npm.require("dns");                                                                                          // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 27
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 29
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 32
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 33
                                                                                                                       //
var staticHandlers = {};                                                                                               // 35
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 39
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 45
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 48
}                                                                                                                      // 49
                                                                                                                       //
var mime = Connect["static"].mime;                                                                                     // 51
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 53
  return function (request, response, cb) {                                                                            // 54
    var path = request.url;                                                                                            // 55
                                                                                                                       //
    // If a directory, open 'index.html'.                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 58
      path = path + "index.html";                                                                                      // 59
    }                                                                                                                  // 60
                                                                                                                       //
    // Strip leading '/'.                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 63
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 66
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 68
    var charset = mime.charsets.lookup(type);                                                                          // 69
    if (charset) {                                                                                                     // 70
      type = type + "; charset=" + charset;                                                                            // 71
    } else if (type === "application/json") {                                                                          // 72
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 74
    }                                                                                                                  // 75
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's 'compress' middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 80
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 81
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 93
    }                                                                                                                  // 94
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 96
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         //
    // logic to happen if the response has no data.                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): This is pretty ugly.                                                                             //
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 102
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 104
      return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                       // 105
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 107
        if (status === "file") {                                                                                       // 108
          // Nothing to do.                                                                                            //
        } else if (status === "directory") {                                                                           // 110
            stream.sendingDirectResponse();                                                                            // 111
            response.writeHead(303, {                                                                                  // 112
              "Content-Type": "text/plain",                                                                            // 113
              "Location": "/" + path + "/",                                                                            // 114
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 115
            });                                                                                                        // 112
            response.end("redirect: /" + path + "/");                                                                  // 117
          } else if (status === "notFound") {                                                                          // 118
            stream.sendingDirectResponse();                                                                            // 119
            response.writeHead(404, {                                                                                  // 120
              "Content-Type": "text/plain"                                                                             // 121
            });                                                                                                        // 120
            response.end("404 not found: /" + path);                                                                   // 123
          } else {                                                                                                     // 124
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 125
            stream.sendingDirectResponse();                                                                            // 126
            response.writeHead(500, {                                                                                  // 127
              "Content-Type": "text/plain"                                                                             // 128
            });                                                                                                        // 127
            response.end("Internal server error");                                                                     // 130
          }                                                                                                            // 131
                                                                                                                       //
        streamCap.close();                                                                                             // 133
      });                                                                                                              // 134
    })["catch"](function (err) {                                                                                       // 135
      console.error(err.stack);                                                                                        // 136
      streamCap.close();                                                                                               // 137
    });                                                                                                                // 138
  };                                                                                                                   // 139
}                                                                                                                      // 140
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 142
  var status = 500;                                                                                                    // 143
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 144
    status = err.error;                                                                                                // 146
  } else if (err.httpErrorCode) {                                                                                      // 147
    status = err.httpErrorCode;                                                                                        // 148
  }                                                                                                                    // 149
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 152
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 154
  res.end(err.htmlMessage || err.message);                                                                             // 155
}                                                                                                                      // 156
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 158
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 159
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 161
  if (buf.length < magic.length) return false;                                                                         // 162
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 164
    if (buf[i] != magic[i]) return false;                                                                              // 165
  }                                                                                                                    // 166
                                                                                                                       //
  return true;                                                                                                         // 168
}                                                                                                                      // 169
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 171
  try {                                                                                                                // 172
    if (req.method === "GET" && req.url === "/") {                                                                     // 173
      var content = new Buffer("Self-test OK.");                                                                       // 175
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 178
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 179
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 180
      }                                                                                                                // 181
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 183
        "Content-Type": "text/plain",                                                                                  // 184
        "Content-Length": content.length,                                                                              // 185
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 186
      });                                                                                                              // 183
      res.end(content);                                                                                                // 188
    } else {                                                                                                           // 189
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 190
      res.end("Bad request to self-test subdomain.");                                                                  // 191
      return;                                                                                                          // 192
    }                                                                                                                  // 193
  } catch (err) {                                                                                                      // 194
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 195
  }                                                                                                                    // 196
}                                                                                                                      // 197
                                                                                                                       //
function serveStaticAsset(req, res) {                                                                                  // 199
  inMeteor(function () {                                                                                               // 200
    if (req.method === "GET") {                                                                                        // 201
      // jscs:disable validateQuoteMarks                                                                               //
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 203
      if (req.headers['if-none-match'] === 'permanent') {                                                              // 204
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 206
          'Cache-Control': 'public, max-age=31536000',                                                                 // 207
          'ETag': 'permanent',                                                                                         // 208
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          'Content-Security-Policy': assetCspHeader,                                                                   // 211
          'Access-Control-Allow-Origin': '*',                                                                          // 212
          'X-Content-Type-Options': 'nosniff'                                                                          // 213
        });                                                                                                            // 206
        res.end();                                                                                                     // 215
        return;                                                                                                        // 216
      }                                                                                                                // 217
                                                                                                                       //
      var url = Url.parse(req.url);                                                                                    // 219
      var asset = globalDb.getStaticAsset(url.pathname.slice(1));                                                      // 220
                                                                                                                       //
      if (asset) {                                                                                                     // 222
        var headers = {                                                                                                // 223
          'Content-Type': asset.mimeType,                                                                              // 224
          'Content-Length': asset.content.length,                                                                      // 225
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          'Cache-Control': 'public, max-age=31536000',                                                                 // 228
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          'ETag': 'permanent',                                                                                         // 231
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          'Content-Security-Policy': assetCspHeader,                                                                   // 238
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          'Access-Control-Allow-Origin': '*',                                                                          // 243
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          'X-Content-Type-Options': 'nosniff'                                                                          // 246
        };                                                                                                             // 223
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 249
          headers['Content-Encoding'] = asset.encoding;                                                                // 250
        }                                                                                                              // 251
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 253
        res.end(asset.content);                                                                                        // 254
      } else {                                                                                                         // 255
        res.writeHead(404, { 'Content-Type': 'text/plain' });                                                          // 256
        res.end('not found');                                                                                          // 257
      }                                                                                                                // 258
    } else if (req.method === 'POST') {                                                                                // 259
      var _ret = function () {                                                                                         // 259
        res.setHeader('Access-Control-Allow-Origin', '*');                                                             // 260
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 262
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 263
        if (!purpose) {                                                                                                // 264
          res.writeHead(404, { 'Content-Type': 'text/plain' });                                                        // 265
          res.end('Upload token not found or expired.');                                                               // 266
          return {                                                                                                     // 267
            v: void 0                                                                                                  // 267
          };                                                                                                           // 267
        }                                                                                                              // 268
                                                                                                                       //
        var userId = purpose.profilePicture.userId;                                                                    // 270
        var identityId = purpose.profilePicture.identityId;                                                            // 271
        check(userId, String);                                                                                         // 272
        check(identityId, String);                                                                                     // 273
                                                                                                                       //
        var buffers = [];                                                                                              // 275
        var totalSize = 0;                                                                                             // 276
        var done = new Future();                                                                                       // 277
        req.on('data', function (buf) {                                                                                // 278
          totalSize += buf.length;                                                                                     // 279
          if (totalSize <= 64 * 1024) {                                                                                // 280
            buffers.push(buf);                                                                                         // 281
          }                                                                                                            // 282
        });                                                                                                            // 283
        req.on('end', done["return"].bind(done));                                                                      // 284
        req.on('error', done["throw"].bind(done));                                                                     // 285
        done.wait();                                                                                                   // 286
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 288
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { 'Content-Type': 'text/plain' });                                                        // 290
          res.end('Picture too large; please use an image under 64 KiB.');                                             // 291
          return {                                                                                                     // 292
            v: void 0                                                                                                  // 292
          };                                                                                                           // 292
        }                                                                                                              // 293
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 295
        var type = void 0;                                                                                             // 296
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 297
          type = 'image/png';                                                                                          // 298
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 299
          type = 'image/jpeg';                                                                                         // 300
        } else {                                                                                                       // 301
          res.writeHead(400, { 'Content-Type': 'text/plain' });                                                        // 302
          res.end('Image must be PNG or JPEG.');                                                                       // 303
          return {                                                                                                     // 304
            v: void 0                                                                                                  // 304
          };                                                                                                           // 304
        }                                                                                                              // 305
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 307
        var old = Meteor.users.findAndModify({                                                                         // 308
          query: { '_id': identityId },                                                                                // 309
          update: { $set: { 'profile.picture': assetId } },                                                            // 310
          fields: { 'profile.picture': 1 }                                                                             // 311
        });                                                                                                            // 308
                                                                                                                       //
        if (old && old.profile && old.profile.picture) {                                                               // 314
          globalDb.unrefStaticAsset(old.profile.picture);                                                              // 315
        }                                                                                                              // 316
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 318
        res.end();                                                                                                     // 319
      }();                                                                                                             // 259
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 259
    } else if (req.method === 'OPTIONS') {                                                                             // 320
      var requestedHeaders = req.headers['access-control-request-headers'];                                            // 321
      if (requestedHeaders) {                                                                                          // 322
        res.setHeader('Access-Control-Allow-Headers', requestedHeaders);                                               // 323
      }                                                                                                                // 324
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 326
        'Access-Control-Allow-Origin': '*',                                                                            // 327
        'Access-Control-Allow-Methods': 'GET, HEAD, POST, OPTIONS',                                                    // 328
        'Access-Control-Max-Age': '3600'                                                                               // 329
      });                                                                                                              // 326
      res.end();                                                                                                       // 331
    } else {                                                                                                           // 332
      res.writeHead(405, 'Method Not Allowed', {                                                                       // 333
        'Allow': 'GET, POST, OPTIONS',                                                                                 // 334
        'Content-Type': 'text/plain'                                                                                   // 335
      });                                                                                                              // 333
      res.end('405 Method Not Allowed: ' + req.method);                                                                // 337
    }                                                                                                                  // 338
  })["catch"](function (err) {                                                                                         // 339
    writeErrorResponse(res, err);                                                                                      // 340
  });                                                                                                                  // 341
}                                                                                                                      // 342
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 344
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners('upgrade');                                                 // 346
  WebApp.httpServer.removeAllListeners('upgrade');                                                                     // 347
                                                                                                                       //
  WebApp.httpServer.on('upgrade', function (req, socket, head) {                                                       // 349
    Promise.resolve(undefined).then(function () {                                                                      // 350
      if (!req.headers.host) {                                                                                         // 351
        throw new Meteor.Error(400, 'Missing Host header');                                                            // 352
      } else if (isSandstormShell(req.headers.host.split(':')[0])) {                                                   // 353
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 355
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 356
        }                                                                                                              // 357
                                                                                                                       //
        return true;                                                                                                   // 359
      } else {                                                                                                         // 360
        var id = matchWildcardHost(req.headers.host);                                                                  // 361
        if (id) {                                                                                                      // 362
          return tryProxyUpgrade(id, req, socket, head);                                                               // 363
        } else {                                                                                                       // 364
          return false;                                                                                                // 365
        }                                                                                                              // 366
      }                                                                                                                // 367
    }).then(function (handled) {                                                                                       // 368
      if (!handled) socket.destroy();                                                                                  // 369
    })["catch"](function (err) {                                                                                       // 370
      console.error('WebSocket event handler failed:', err.stack);                                                     // 371
      socket.destroy();                                                                                                // 372
    });                                                                                                                // 373
  });                                                                                                                  // 374
                                                                                                                       //
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 377
    // Have to check with global, because it could be undefined.                                                       //
    WebApp.rawConnectHandlers.use(BlackrockPayments.makeConnectHandler(globalDb));                                     // 378
  }                                                                                                                    // 379
                                                                                                                       //
  // This function serves responses on Sandstorm's main HTTP/HTTPS                                                     //
  // port.                                                                                                             //
  var serveMeteorOrStaticPublishing = function serveMeteorOrStaticPublishing(req, res, next) {                         // 383
    return dispatchToMeteorOrStaticPublishing(req, res, next, false);                                                  // 384
  };                                                                                                                   // 385
                                                                                                                       //
  // "Alternate ports" are ports other than the main HTTP or HTTPS                                                     //
  // port. For requests to the shell & grains, we redirect to the main                                                 //
  // port. For static publishing, we serve it.                                                                         //
  //                                                                                                                   //
  // They are bound to FD #5 and higher.                                                                               //
                                                                                                                       //
  function getNumberOfAlternatePorts() {                                                                               // 393
    var numPorts = process.env.PORT.split(',').length;                                                                 // 394
    var numAlternatePorts = numPorts - 1;                                                                              // 395
    return numAlternatePorts;                                                                                          // 396
  };                                                                                                                   // 397
                                                                                                                       //
  var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                        // 399
    // Start with ROOT_URL, apply host & path from inbound URL, then                                                   //
    // redirect.                                                                                                       //
    var targetUrl = Url.parse(process.env.ROOT_URL);                                                                   // 402
                                                                                                                       //
    // Retain the protocol & port from ROOT_URL but use the inbound                                                    //
    // hostname.                                                                                                       //
    targetUrl.host = hostname + ':' + targetUrl.port;                                                                  // 406
                                                                                                                       //
    // The following allows to avoid decoding + re-encoding query                                                      //
    // string parameters, if provided.                                                                                 //
    targetUrl = Url.resolve(Url.format(targetUrl), url);                                                               // 410
    return targetUrl;                                                                                                  // 411
  };                                                                                                                   // 412
                                                                                                                       //
  var redirectToMeteorOrServeStaticPublishing = function redirectToMeteorOrServeStaticPublishing(req, res, next) {     // 414
    return dispatchToMeteorOrStaticPublishing(req, res, next, true);                                                   // 415
  };                                                                                                                   // 416
                                                                                                                       //
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 418
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(redirectToMeteorOrServeStaticPublishing);                  // 420
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 421
  }                                                                                                                    // 422
                                                                                                                       //
  var dispatchToMeteorOrStaticPublishing = function dispatchToMeteorOrStaticPublishing(req, res, next, redirectRatherThanServeShell) {
    if (!req.headers.host) {                                                                                           // 425
      res.writeHead(400, { 'Content-Type': 'text/plain' });                                                            // 426
      res.end('Missing Host header');                                                                                  // 427
      return;                                                                                                          // 428
    }                                                                                                                  // 429
                                                                                                                       //
    var hostname = req.headers.host.split(':')[0];                                                                     // 431
    if (isSandstormShell(hostname)) {                                                                                  // 432
      // Go on to Meteor, or serve a redirect.                                                                         //
      if (redirectRatherThanServeShell) {                                                                              // 434
        res.writeHead(302, { 'Location': canonicalizeShellOrWildcardUrl(hostname, req.url) });                         // 435
        res.end();                                                                                                     // 436
        return;                                                                                                        // 437
      } else {                                                                                                         // 438
        return next();                                                                                                 // 439
      }                                                                                                                // 440
    }                                                                                                                  // 441
                                                                                                                       //
    // This is not our main host. See if it's a member of the wildcard.                                                //
    var publicIdPromise = void 0;                                                                                      // 444
                                                                                                                       //
    var id = matchWildcardHost(req.headers.host);                                                                      // 446
    if (id) {                                                                                                          // 447
      // Match!                                                                                                        //
      if (redirectRatherThanServeShell) {                                                                              // 449
        res.writeHead(302, { 'Location': canonicalizeShellOrWildcardUrl(hostname, req.url) });                         // 450
        res.end();                                                                                                     // 451
        return;                                                                                                        // 452
      }                                                                                                                // 453
                                                                                                                       //
      if (id === 'static') {                                                                                           // 455
        // Static assets domain.                                                                                       //
        serveStaticAsset(req, res);                                                                                    // 457
        return;                                                                                                        // 458
      }                                                                                                                // 459
                                                                                                                       //
      if (id.match(/^selftest-/)) {                                                                                    // 461
        // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                     //
        // publishing wildcard hosts.                                                                                  //
        serveSelfTest(req, res);                                                                                       // 464
        return;                                                                                                        // 465
      }                                                                                                                // 466
                                                                                                                       //
      // Try to route the request to a session.                                                                        //
      publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                        // 469
        if (handled) {                                                                                                 // 470
          return null;                                                                                                 // 471
        } else {                                                                                                       // 472
          return id;                                                                                                   // 473
        }                                                                                                              // 474
      });                                                                                                              // 475
    } else {                                                                                                           // 476
      // Not a wildcard host. Perhaps it is a custom host.                                                             //
      publicIdPromise = lookupPublicIdFromDns(hostname);                                                               // 478
    }                                                                                                                  // 479
                                                                                                                       //
    publicIdPromise.then(function (publicId) {                                                                         // 481
      if (publicId) {                                                                                                  // 482
        return Promise.resolve(undefined).then(function () {                                                           // 483
          var handler = staticHandlers[publicId];                                                                      // 484
          if (handler) {                                                                                               // 485
            return handler;                                                                                            // 486
          } else {                                                                                                     // 487
            // We don't have a handler for this publicId, so look it up in the grain DB.                               //
            return inMeteor(function () {                                                                              // 489
              var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                              // 490
              if (!grain) {                                                                                            // 491
                throw new Meteor.Error(404, 'No such grain for public ID: ' + publicId);                               // 492
              }                                                                                                        // 493
                                                                                                                       //
              var grainId = grain._id;                                                                                 // 495
              return staticHandlers[publicId] = wwwHandlerForGrain(grainId);                                           // 496
            });                                                                                                        // 497
          }                                                                                                            // 498
        }).then(function (handler) {                                                                                   // 499
          handler(req, res, function (err) {                                                                           // 500
            if (err) {                                                                                                 // 501
              next(err);                                                                                               // 502
            } else {                                                                                                   // 503
              res.writeHead(404, { 'Content-Type': 'text/plain' });                                                    // 504
              res.end('404 not found: ' + req.url);                                                                    // 505
            }                                                                                                          // 506
          });                                                                                                          // 507
        });                                                                                                            // 508
      } else {                                                                                                         // 509
        return Promise.resolve(undefined);                                                                             // 510
      }                                                                                                                // 511
    })["catch"](function (err) {                                                                                       // 512
      writeErrorResponse(res, err);                                                                                    // 513
    });                                                                                                                // 514
  };                                                                                                                   // 515
                                                                                                                       //
  WebApp.rawConnectHandlers.use(serveMeteorOrStaticPublishing);                                                        // 517
});                                                                                                                    // 518
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 520
errorTxtMapping[Dns.NOTFOUND] = '<p>' + 'If you were trying to configure static publishing for a blog or website, powered ' + 'by a Sandstorm app hosted at this server, you either have not added DNS TXT records ' + 'correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one ' + 'hour).</p>';
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 526
errorTxtMapping[Dns.TIMEOUT] = '<p>' + 'The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>';
errorTxtMapping[Dns.CONNREFUSED] = '<p>' + 'The DNS server refused the connection, which means either your DNS server is down/unreachable, ' + 'or the server has misconfigured their DNS.</p>';
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 533
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 547
  if (cache && Date.now() < cache.expiration) {                                                                        // 548
    return Promise.resolve(cache.value);                                                                               // 549
  }                                                                                                                    // 550
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 552
    Dns.resolveTxt('sandstorm-www.' + hostname, function (err, records) {                                              // 553
      if (err) {                                                                                                       // 554
        var errorMsg = errorTxtMapping[err.code] || '';                                                                // 555
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 556
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + '<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>' + errorMsg + '<p>To visit this Sandstorm server\'s main interface, go to: <a href=\'' + process.env.ROOT_URL + '\'>' + process.env.ROOT_URL + '</a></p>' + '<h3>DNS details</h3>' + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + '</p>' + '<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>' + '<p><tt>dig TXT sandstorm-www.' + hostname + '</tt></p>' + '<h3>Changing the server URL, or troubleshooting OAuth login</h3>' + '<p>If you are the server admin and want to use this address as the main interface, ' + 'edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart ' + 'Sandstorm.</p>' + '<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), ' + 'the problem is probably that the OAuth callback URL was set wrong. You need to ' + 'update it through the respective login provider\'s management console. The ' + 'easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then ' + 'reconfigure the OAuth provider.</p>';
        error.httpErrorCode = _.contains(['ENOTFOUND', 'ENODATA'], err.code) ? 404 : 500;                              // 577
        reject(error);                                                                                                 // 578
      } else if (records.length !== 1) {                                                                               // 579
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 580
      } else {                                                                                                         // 581
        var result = records[0];                                                                                       // 582
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 583
        resolve(result);                                                                                               // 584
      }                                                                                                                // 585
    });                                                                                                                // 586
  });                                                                                                                  // 587
}                                                                                                                      // 588
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
var Crypto = Npm.require("crypto");                                                                                    // 18
var ChildProcess = Npm.require("child_process");                                                                       // 19
var Fs = Npm.require("fs");                                                                                            // 20
var Path = Npm.require("path");                                                                                        // 21
var Future = Npm.require("fibers/future");                                                                             // 22
var Http = Npm.require("http");                                                                                        // 23
var Url = Npm.require("url");                                                                                          // 24
var Promise = Npm.require("es6-promise").Promise;                                                                      // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var Net = Npm.require("net");                                                                                          // 27
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 29
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 30
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 31
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 32
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 33
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 34
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 39
  check(identityId, String);                                                                                           // 40
  check(apiTokenAccountId, String);                                                                                    // 41
                                                                                                                       //
  // Bail out early if quota enforcement is disabled.                                                                  //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 44
    return;                                                                                                            // 45
  }                                                                                                                    // 46
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 48
  var bobAccountId = accountId;                                                                                        // 49
  var bobIdentityId = identityId;                                                                                      // 50
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 52
    _id: bobAccountId,                                                                                                 // 53
    referredByComplete: { $exists: true }                                                                              // 54
  }).count() > 0) {                                                                                                    // 52
    return;                                                                                                            // 56
  }                                                                                                                    // 57
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 63
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 65
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if quota support is not enabled.                                                                   //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 81
    return;                                                                                                            // 82
  }                                                                                                                    // 83
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 86
    return;                                                                                                            // 87
  }                                                                                                                    // 88
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 91
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 92
    _id: { $in: bobIdentityIds },                                                                                      // 93
    referredBy: { $exists: true }                                                                                      // 94
  });                                                                                                                  // 92
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 97
    return;                                                                                                            // 98
  }                                                                                                                    // 99
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 101
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 104
  Meteor.users.update({                                                                                                // 105
    _id: bobAccountId,                                                                                                 // 106
    referredByComplete: { $exists: false }                                                                             // 107
  }, {                                                                                                                 // 105
    $set: {                                                                                                            // 109
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 110
      referredCompleteDate: now                                                                                        // 111
    }                                                                                                                  // 109
  });                                                                                                                  // 108
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 116
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 117
  });                                                                                                                  // 116
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 121
    $unset: { referredBy: true }                                                                                       // 122
  });                                                                                                                  // 121
}                                                                                                                      // 124
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 139
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 141
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory();                                                                 // 143
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 144
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 145
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 146
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 150
Meteor.onConnection(function (connection) {                                                                            // 151
  connection.sandstormBackend = globalBackend;                                                                         // 152
});                                                                                                                    // 153
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 162
var disconnectCount = 0;                                                                                               // 163
Meteor.setInterval(function () {                                                                                       // 164
  if (!backendHealthy) {                                                                                               // 165
    if (disconnectCount++ > 2) process.abort();                                                                        // 166
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 167
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 168
    sandstormBackendConnection.close();                                                                                // 169
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 170
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 171
    globalBackend._backendCap = sandstormBackend;                                                                      // 172
  }                                                                                                                    // 173
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 175
  backendHealthy = false;                                                                                              // 176
  var promise = sandstormBackend.ping().then(function () {                                                             // 177
    backendHealthy = true;                                                                                             // 178
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 179
  }, function (err) {                                                                                                  // 180
    console.error("error: Backend ping threw error!", err.stack);                                                      // 181
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 185
                                                                                                                       //
  if (debugLog) {                                                                                                      // 187
    console.log("capnp.js: outer promise:", promise);                                                                  // 188
  }                                                                                                                    // 189
}, 30000);                                                                                                             // 190
                                                                                                                       //
// =======================================================================================                             //
// Meteor context <-> Async Node.js context adapters                                                                   //
// TODO(cleanup):  Move to a different file.                                                                           //
                                                                                                                       //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 196
  callback();                                                                                                          // 197
});                                                                                                                    // 198
                                                                                                                       //
inMeteor = function inMeteor(callback) {                                                                               // 200
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 202
    inMeteorInternal(function () {                                                                                     // 203
      try {                                                                                                            // 204
        resolve(callback());                                                                                           // 205
      } catch (err) {                                                                                                  // 206
        reject(err);                                                                                                   // 207
      }                                                                                                                // 208
    });                                                                                                                // 209
  });                                                                                                                  // 210
};                                                                                                                     // 211
                                                                                                                       //
promiseToFuture = function promiseToFuture(promise) {                                                                  // 213
  var result = new Future();                                                                                           // 214
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 215
  return result;                                                                                                       // 216
};                                                                                                                     // 217
                                                                                                                       //
waitPromise = function waitPromise(promise) {                                                                          // 219
  return promiseToFuture(promise).wait();                                                                              // 220
};                                                                                                                     // 221
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 226
                                                                                                                       //
Meteor.methods({                                                                                                       // 228
  newGrain: function newGrain(packageId, command, title, identityId) {                                                 // 229
    // Create and start a new grain.                                                                                   //
                                                                                                                       //
    check(packageId, String);                                                                                          // 232
    check(command, Object); // Manifest.Command from package.capnp.                                                    // 233
    check(title, String);                                                                                              // 234
    check(identityId, String);                                                                                         // 235
                                                                                                                       //
    if (!this.userId) {                                                                                                // 237
      throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                              // 238
    }                                                                                                                  // 239
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 241
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 242
    }                                                                                                                  // 243
                                                                                                                       //
    if (!isSignedUpOrDemo()) {                                                                                         // 245
      throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");              // 246
    }                                                                                                                  // 248
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 250
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 251
    }                                                                                                                  // 253
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 255
    var isDev = false;                                                                                                 // 256
    if (!pkg) {                                                                                                        // 257
      // Maybe they wanted a dev package.  Check there too.                                                            //
      pkg = DevPackages.findOne(packageId);                                                                            // 259
      isDev = true;                                                                                                    // 260
    }                                                                                                                  // 261
                                                                                                                       //
    if (!pkg) {                                                                                                        // 263
      throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                       // 264
    }                                                                                                                  // 265
                                                                                                                       //
    var appId = pkg.appId;                                                                                             // 267
    var manifest = pkg.manifest;                                                                                       // 268
    var grainId = Random.id(22); // 128 bits of entropy                                                                // 269
    Grains.insert({                                                                                                    // 270
      _id: grainId,                                                                                                    // 271
      packageId: packageId,                                                                                            // 272
      appId: appId,                                                                                                    // 273
      appVersion: manifest.appVersion,                                                                                 // 274
      userId: this.userId,                                                                                             // 275
      identityId: identityId,                                                                                          // 276
      title: title,                                                                                                    // 277
      "private": true                                                                                                  // 278
    });                                                                                                                // 270
                                                                                                                       //
    globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev);                           // 281
    globalBackend.updateLastActive(grainId, this.userId, identityId);                                                  // 282
    return grainId;                                                                                                    // 283
  },                                                                                                                   // 284
  openSession: function openSession(grainId, identityId, cachedSalt) {                                                 // 286
    // Open a new UI session on an existing grain.  Starts the grain if it is not already                              //
    // running.                                                                                                        //
                                                                                                                       //
    check(grainId, String);                                                                                            // 290
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 291
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 292
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 294
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 295
    }                                                                                                                  // 296
                                                                                                                       //
    var grain = Grains.findOne({ _id: grainId });                                                                      // 298
    if (!grain) {                                                                                                      // 299
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                          // 300
    } else if (grain.trashed) {                                                                                        // 301
      throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                        // 302
    }                                                                                                                  // 303
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 305
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 306
    if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {                 // 307
      throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                       // 309
    }                                                                                                                  // 310
                                                                                                                       //
    var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);          // 312
    var result = opened.methodResult;                                                                                  // 314
    var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
    proxiesByHostId[result.hostId] = proxy;                                                                            // 317
    return result;                                                                                                     // 318
  },                                                                                                                   // 319
  openSessionFromApiToken: function openSessionFromApiToken(params, identityId, cachedSalt) {                          // 321
    // Given an API token, either opens a new WebSession to the underlying grain or returns a                          //
    // path to which the client should redirect in order to open such a session.                                       //
                                                                                                                       //
    check(params, {                                                                                                    // 325
      token: String,                                                                                                   // 326
      incognito: Boolean                                                                                               // 327
    });                                                                                                                // 325
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 329
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 330
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 332
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 333
    }                                                                                                                  // 334
                                                                                                                       //
    if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                     // 336
      throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
    }                                                                                                                  // 339
                                                                                                                       //
    var token = params.token;                                                                                          // 341
    var incognito = params.incognito;                                                                                  // 342
    var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                      // 343
    var apiToken = ApiTokens.findOne(hashedToken);                                                                     // 344
    validateWebkey(apiToken);                                                                                          // 345
    var grain = Grains.findOne({ _id: apiToken.grainId });                                                             // 346
    if (!grain) {                                                                                                      // 347
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                                 // 348
    }                                                                                                                  // 349
                                                                                                                       //
    if (apiToken.accountId) {                                                                                          // 351
      referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                                 // 352
    }                                                                                                                  // 353
                                                                                                                       //
    var title = void 0;                                                                                                // 355
    if (grain.userId === apiToken.accountId) {                                                                         // 356
      title = grain.title;                                                                                             // 357
    } else {                                                                                                           // 358
      var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                     // 359
        grainId: apiToken.grainId,                                                                                     // 361
        "owner.user.identityId": apiToken.identityId                                                                   // 362
      }, {                                                                                                             // 360
        sort: {                                                                                                        // 364
          lastUsed: -1                                                                                                 // 365
        }                                                                                                              // 364
      });                                                                                                              // 363
      if (sharerToken) {                                                                                               // 368
        title = sharerToken.owner.user.title;                                                                          // 369
      } else {                                                                                                         // 370
        title = "shared grain";                                                                                        // 371
      }                                                                                                                // 372
    }                                                                                                                  // 373
                                                                                                                       //
    if (this.userId && !incognito) {                                                                                   // 375
      if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
        var owner = { user: { identityId: identityId, title: title } };                                                // 378
                                                                                                                       //
        // Create a new API token for the identity redeeming this token.                                               //
        var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname, { allAccess: null }, owner);
        globalDb.addContact(apiToken.accountId, identityId);                                                           // 383
                                                                                                                       //
        // If the parent API token is forSharing and it has an accountId, then the logged-in user (call                //
        // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference                //
        // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                        //
        // share-by-identity, this happens immediately.)                                                               //
        if (result.parentApiToken) {                                                                                   // 389
          var parentApiToken = result.parentApiToken;                                                                  // 390
          if (parentApiToken.forSharing && parentApiToken.accountId) {                                                 // 391
            storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
          }                                                                                                            // 394
        }                                                                                                              // 395
      }                                                                                                                // 396
                                                                                                                       //
      return { redirectToGrain: apiToken.grainId };                                                                    // 398
    } else {                                                                                                           // 399
      if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                         // 400
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 401
      }                                                                                                                // 403
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);       // 405
                                                                                                                       //
      var _result = opened.methodResult;                                                                               // 408
      var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false, opened.supervisor);
      proxy.apiToken = apiToken;                                                                                       // 412
      proxiesByHostId[_result.hostId] = proxy;                                                                         // 413
      return _result;                                                                                                  // 414
    }                                                                                                                  // 415
  },                                                                                                                   // 416
  keepSessionAlive: function keepSessionAlive(sessionId) {                                                             // 418
    // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                    //
    //   by them.                                                                                                      //
    check(sessionId, String);                                                                                          // 421
                                                                                                                       //
    var session = Sessions.findAndModify({                                                                             // 423
      query: { _id: sessionId },                                                                                       // 424
      update: { $set: { timestamp: new Date().getTime() } },                                                           // 425
      fields: { grainId: 1, identityId: 1, hostId: 1 }                                                                 // 426
    });                                                                                                                // 423
                                                                                                                       //
    if (session) {                                                                                                     // 429
      // Session still present in database, so send keep-alive to backend.                                             //
      try {                                                                                                            // 431
        var grainId = session.grainId;                                                                                 // 432
        var hostId = session.hostId;                                                                                   // 433
        var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                                // 434
        if (!supervisor) {                                                                                             // 435
          supervisor = globalBackend.continueGrain(grainId).supervisor;                                                // 436
        }                                                                                                              // 437
                                                                                                                       //
        waitPromise(supervisor.keepAlive());                                                                           // 439
        globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                      // 440
      } catch (err) {                                                                                                  // 441
        // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                    //
        // the next request, so whatever.                                                                              //
        if (err.kjType !== "disconnected") {                                                                           // 444
          throw err;                                                                                                   // 445
        }                                                                                                              // 446
      }                                                                                                                // 447
                                                                                                                       //
      return true;                                                                                                     // 449
    } else {                                                                                                           // 450
      return false;                                                                                                    // 451
    }                                                                                                                  // 452
  },                                                                                                                   // 453
  shutdownGrain: function shutdownGrain(grainId) {                                                                     // 455
    check(grainId, String);                                                                                            // 456
    var grain = Grains.findOne(grainId);                                                                               // 457
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 458
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 459
    }                                                                                                                  // 460
                                                                                                                       //
    waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                             // 462
  }                                                                                                                    // 463
});                                                                                                                    // 228
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 466
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 471
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 472
  }                                                                                                                    // 473
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 475
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 476
  }                                                                                                                    // 477
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 479
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 480
  }                                                                                                                    // 481
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 483
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 484
  }                                                                                                                    // 485
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 487
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 488
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 489
    } else if (refreshedExpiration) {                                                                                  // 490
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 491
    } else {                                                                                                           // 492
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 494
    }                                                                                                                  // 495
  }                                                                                                                    // 496
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 498
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 499
  }                                                                                                                    // 500
};                                                                                                                     // 501
                                                                                                                       //
// Used by shared/grain.js (which sounds like a broken dependency, since this code is only available                   //
// on the server)                                                                                                      //
getGrainSize = function getGrainSize(supervisor, oldSize) {                                                            // 505
  var promise = void 0;                                                                                                // 506
  if (oldSize === undefined) {                                                                                         // 507
    promise = supervisor.getGrainSize();                                                                               // 508
  } else {                                                                                                             // 509
    promise = supervisor.getGrainSizeWhenDifferent(oldSize);                                                           // 510
  }                                                                                                                    // 511
                                                                                                                       //
  var promise2 = promise.then(function (result) {                                                                      // 513
    return parseInt(result.size);                                                                                      // 513
  });                                                                                                                  // 513
  promise2.cancel = function () {                                                                                      // 514
    promise.cancel();                                                                                                  // 514
  };                                                                                                                   // 514
                                                                                                                       //
  return promise2;                                                                                                     // 516
};                                                                                                                     // 517
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 519
  var shutdownApp = function shutdownApp(appId) {                                                                      // 520
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 521
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 522
    });                                                                                                                // 523
  };                                                                                                                   // 524
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 526
    removed: function removed(devPackage) {                                                                            // 527
      shutdownApp(devPackage.appId);                                                                                   // 527
    },                                                                                                                 // 527
    changed: function changed(newDevPackage, oldDevPackage) {                                                          // 529
      shutdownApp(oldDevPackage.appId);                                                                                // 530
      if (oldDevPackage.appId !== newDevPackage.appId) {                                                               // 531
        shutdownApp(newDevPackage.appId);                                                                              // 532
      }                                                                                                                // 533
    },                                                                                                                 // 534
    added: function added(devPackage) {                                                                                // 536
      shutdownApp(devPackage.appId);                                                                                   // 536
    }                                                                                                                  // 536
  });                                                                                                                  // 526
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 539
    removed: function removed(session) {                                                                               // 540
      var proxy = proxiesByHostId[session.hostId];                                                                     // 541
      delete proxiesByHostId[session.hostId];                                                                          // 542
      if (proxy) {                                                                                                     // 543
        proxy.close();                                                                                                 // 544
      }                                                                                                                // 545
    }                                                                                                                  // 546
  });                                                                                                                  // 539
});                                                                                                                    // 548
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 551
var gcSessions = function gcSessions() {                                                                               // 552
  var now = new Date().getTime();                                                                                      // 553
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 554
};                                                                                                                     // 555
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 557
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 559
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 564
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 566
    var proxy = proxiesByHostId[hostId];                                                                               // 567
    if (proxy) {                                                                                                       // 568
      return proxy;                                                                                                    // 569
    } else {                                                                                                           // 570
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 572
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 574
        var session = Sessions.findOne({ hostId: hostId });                                                            // 575
        if (!session) {                                                                                                // 576
          if (isAlreadyOpened) {                                                                                       // 577
            return new Promise(function (resolve, reject) {                                                            // 578
              var observer = void 0;                                                                                   // 579
              var task = Meteor.setTimeout(function () {                                                               // 580
                observer.stop();                                                                                       // 581
                reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
              }, SESSION_PROXY_TIMEOUT);                                                                               // 587
              observer = Sessions.find({ hostId: hostId }).observe({                                                   // 588
                added: function added() {                                                                              // 589
                  observer.stop();                                                                                     // 590
                  Meteor.clearTimeout(task);                                                                           // 591
                  resolve(getProxyForHostId(hostId, false));                                                           // 592
                }                                                                                                      // 593
              });                                                                                                      // 588
            });                                                                                                        // 595
          } else {                                                                                                     // 596
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 598
          }                                                                                                            // 599
        }                                                                                                              // 600
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 602
        if (session.hashedToken) {                                                                                     // 603
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 604
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 607
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 608
          }                                                                                                            // 609
        }                                                                                                              // 610
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 612
        if (!grain) {                                                                                                  // 613
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 615
        }                                                                                                              // 616
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 623
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 627
          proxiesByHostId[hostId] = proxy;                                                                             // 628
        } else {                                                                                                       // 629
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 630
        }                                                                                                              // 631
                                                                                                                       //
        return proxy;                                                                                                  // 633
      });                                                                                                              // 634
    }                                                                                                                  // 635
  });                                                                                                                  // 636
};                                                                                                                     // 637
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 652
    var _this2 = this;                                                                                                 // 652
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 652
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 653
    this.newBucket = {};                                                                                               // 654
    this.oldBucket = {};                                                                                               // 655
    this.interval = Meteor.setInterval(function () {                                                                   // 656
      for (var oldHashedToken in _this2.oldBucket) {                                                                   // 657
        for (var oldHashedParams in _this2.oldBucket[oldHashedToken]) {                                                // 658
          var newProxy = _this2.newBucket[oldHashedToken] && _this2.newBucket[oldHashedToken][oldHashedParams];        // 659
          var oldProxy = _this2.oldBucket[oldHashedToken][oldHashedParams];                                            // 661
          if (oldProxy && !newProxy) {                                                                                 // 662
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 663
              // A client has an open websocket. Keep the proxy around.                                                //
              _this2.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 665
            } else {                                                                                                   // 666
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 668
            }                                                                                                          // 669
          }                                                                                                            // 670
        }                                                                                                              // 671
      }                                                                                                                // 672
                                                                                                                       //
      _this2.oldBucket = _this2.newBucket;                                                                             // 674
      _this2.newBucket = {};                                                                                           // 675
    }, intervalMillis);                                                                                                // 676
  }                                                                                                                    // 677
                                                                                                                       //
  ApiSessionProxies.prototype.get = function get(hashedToken, hashedParams) {                                          //
    if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                    // 680
      return this.newBucket[hashedToken][hashedParams];                                                                // 681
    } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                             // 682
      var proxy = this.oldBucket[hashedToken][hashedParams];                                                           // 683
      delete this.oldBucket[hashedToken][hashedParams];                                                                // 684
      this.put(hashedToken, hashedParams, proxy);                                                                      // 685
      return proxy;                                                                                                    // 686
    } else {                                                                                                           // 687
      return null;                                                                                                     // 688
    }                                                                                                                  // 689
  };                                                                                                                   // 690
                                                                                                                       //
  ApiSessionProxies.prototype.put = function put(hashedToken, hashedParams, proxy) {                                   //
    if (!this.newBucket[hashedToken]) {                                                                                // 693
      this.newBucket[hashedToken] = {};                                                                                // 694
    }                                                                                                                  // 695
                                                                                                                       //
    this.newBucket[hashedToken][hashedParams] = proxy;                                                                 // 697
  };                                                                                                                   // 698
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function removeProxiesOfToken(hashedToken) {                      //
    if (hashedToken in this.oldBucket) {                                                                               // 701
      for (var hashedParams in this.oldBucket[hashedToken]) {                                                          // 702
        this.oldBucket[hashedToken][hashedParams].close();                                                             // 703
      }                                                                                                                // 704
                                                                                                                       //
      delete this.oldBucket[hashedToken];                                                                              // 706
    }                                                                                                                  // 707
                                                                                                                       //
    if (hashedToken in this.newBucket) {                                                                               // 709
      for (var _hashedParams in this.newBucket[hashedToken]) {                                                         // 710
        this.newBucket[hashedToken][_hashedParams].close();                                                            // 711
      }                                                                                                                // 712
                                                                                                                       //
      delete this.newBucket[hashedToken];                                                                              // 714
    }                                                                                                                  // 715
  };                                                                                                                   // 716
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 719
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 721
  Grains.find().observe({                                                                                              // 722
    changed: function changed(newGrain, oldGrain) {                                                                    // 723
      if (oldGrain["private"] != newGrain["private"]) {                                                                // 724
        Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                          // 725
        ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                        // 726
          apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                        // 727
        });                                                                                                            // 728
      }                                                                                                                // 729
    }                                                                                                                  // 730
  });                                                                                                                  // 722
});                                                                                                                    // 732
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 734
  var params = {};                                                                                                     // 735
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 736
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 737
      return s.trim();                                                                                                 // 739
    });                                                                                                                // 739
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 743
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 747
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 748
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 751
      }                                                                                                                // 752
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 754
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 759
          return parseInt(x, 10);                                                                                      // 760
        }).reduce(function (a, b) {                                                                                    // 760
          return 256 * a + b;                                                                                          // 761
        });                                                                                                            // 761
        params.remoteAddress = {                                                                                       // 762
          lower64: v4Int,                                                                                              // 763
          upper64: 0                                                                                                   // 764
        };                                                                                                             // 762
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 766
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 770
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 773
          groups.shift();                                                                                              // 774
        }                                                                                                              // 775
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 777
          groups.pop();                                                                                                // 778
        }                                                                                                              // 779
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 781
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 784
          groups.pop();                                                                                                // 785
          var _quad = lastGroup.split(".").map(function (x) {                                                          // 786
            return parseInt(x, 10);                                                                                    // 786
          });                                                                                                          // 786
          groups.push((_quad[0] * 256 + _quad[1]).toString(16));                                                       // 787
          groups.push((_quad[2] * 256 + _quad[3]).toString(16));                                                       // 788
        }                                                                                                              // 789
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 791
        var emptyGroupIndex = groups.indexOf("");                                                                      // 792
        var cleanGroups = void 0;                                                                                      // 793
        if (emptyGroupIndex !== -1) {                                                                                  // 794
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 795
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 797
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 798
            mid[i] = "0";                                                                                              // 799
          }                                                                                                            // 800
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 802
          cleanGroups = [].concat(head, mid, tail);                                                                    // 803
        } else {                                                                                                       // 804
          cleanGroups = groups;                                                                                        // 805
        }                                                                                                              // 806
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 808
          return parseInt(x, 16);                                                                                      // 808
        });                                                                                                            // 808
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 811
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 812
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 813
        };                                                                                                             // 811
      }                                                                                                                // 815
    }                                                                                                                  // 816
  }                                                                                                                    // 817
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 819
}                                                                                                                      // 820
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 823
  check(token, String);                                                                                                // 824
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 825
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 826
  var serializedParams = getApiSessionParams(request);                                                                 // 828
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 829
  return Promise.resolve(undefined).then(function () {                                                                 // 830
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 831
    if (proxy) {                                                                                                       // 832
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 833
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 834
      }                                                                                                                // 835
                                                                                                                       //
      return proxy;                                                                                                    // 837
    } else {                                                                                                           // 838
      return inMeteor(function () {                                                                                    // 839
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 840
        validateWebkey(tokenInfo);                                                                                     // 841
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 843
        if (!grain) {                                                                                                  // 844
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 846
        }                                                                                                              // 847
                                                                                                                       //
        var proxy = void 0;                                                                                            // 849
        if (tokenInfo.userInfo) {                                                                                      // 850
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 851
        } else {                                                                                                       // 852
          var identityId = null;                                                                                       // 853
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 854
            identityId = tokenInfo.identityId;                                                                         // 855
          }                                                                                                            // 856
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 858
          proxy.apiToken = tokenInfo;                                                                                  // 859
          proxy.apiSessionParams = serializedParams;                                                                   // 860
        }                                                                                                              // 861
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 863
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 865
        }                                                                                                              // 866
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 868
          proxy.expires = tokenInfo.expires;                                                                           // 869
        }                                                                                                              // 870
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 872
                                                                                                                       //
        return proxy;                                                                                                  // 874
      });                                                                                                              // 875
    }                                                                                                                  // 876
  });                                                                                                                  // 877
};                                                                                                                     // 878
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 880
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 888
    return true;                                                                                                       // 889
  }                                                                                                                    // 890
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 901
  return agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                                    // 902
};                                                                                                                     // 903
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 905
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 908
  var token = void 0;                                                                                                  // 909
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 910
    token = auth.slice(7).trim();                                                                                      // 911
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 912
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 914
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 915
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 918
    if (parts.length < 2) {                                                                                            // 919
      token = undefined;                                                                                               // 920
    } else {                                                                                                           // 921
      token = parts[1];                                                                                                // 922
      req.url = "/" + parts.slice(2).join("/");                                                                        // 923
      // remove .sandstorm-api-token/$TOKEN from path                                                                  //
    }                                                                                                                  // 925
  } else {                                                                                                             // 926
      token = undefined;                                                                                               // 927
    }                                                                                                                  // 928
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 930
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 932
      token = undefined;                                                                                               // 933
    }                                                                                                                  // 934
  }                                                                                                                    // 935
                                                                                                                       //
  return token;                                                                                                        // 937
};                                                                                                                     // 938
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 945
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 951
    var token = apiTokenForRequest(req, hostId);                                                                       // 952
    if (token) {                                                                                                       // 953
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 954
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 957
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 959
        return true;                                                                                                   // 960
      });                                                                                                              // 961
    } else {                                                                                                           // 962
      return Promise.resolve(false);                                                                                   // 963
    }                                                                                                                  // 964
  } else {                                                                                                             // 965
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 966
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 967
      if (proxy) {                                                                                                     // 968
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 970
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 971
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 972
        }                                                                                                              // 973
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 977
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 979
        return true;                                                                                                   // 980
      } else {                                                                                                         // 981
        return false;                                                                                                  // 982
      }                                                                                                                // 983
    });                                                                                                                // 984
  }                                                                                                                    // 985
};                                                                                                                     // 986
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 989
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 995
  if (hostIdHash) {                                                                                                    // 996
    var _ret = function () {                                                                                           // 996
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 999
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1001
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1018
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1019
          "Access-Control-Max-Age": "3600"                                                                             // 1020
        };                                                                                                             // 1018
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1024
        if (requestedHeaders) {                                                                                        // 1025
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1026
        }                                                                                                              // 1027
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1030
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1031
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1033
        }                                                                                                              // 1034
                                                                                                                       //
        for (header in accessControlHeaders) {                                                                         // 1036
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1037
        }                                                                                                              // 1038
      }                                                                                                                // 1039
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1041
        if (err instanceof Meteor.Error) {                                                                             // 1042
          console.log("error: " + err);                                                                                // 1043
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1044
        } else {                                                                                                       // 1045
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1046
        }                                                                                                              // 1047
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1049
      };                                                                                                               // 1050
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1052
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1053
        inMeteor(function () {                                                                                         // 1054
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1055
          check(keepaliveDuration, Match.Integer);                                                                     // 1056
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1057
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1058
        }).then(function () {                                                                                          // 1059
          res.writeHead(200, {});                                                                                      // 1060
          res.end();                                                                                                   // 1061
        }, errorHandler);                                                                                              // 1062
      } else if (token) {                                                                                              // 1063
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1064
          proxy.requestHandler(req, res);                                                                              // 1065
        }, errorHandler);                                                                                              // 1066
      } else {                                                                                                         // 1067
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1069
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1070
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1072
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1075
            if (dav.length > 0) {                                                                                      // 1076
              res.setHeader("DAV", dav.join(", "));                                                                    // 1077
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1078
            }                                                                                                          // 1079
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1081
            res.end();                                                                                                 // 1082
          } else {                                                                                                     // 1083
            var resources = (apiHost || {}).resources || {};                                                           // 1084
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1085
            if (path in resources) {                                                                                   // 1086
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1088
              console.log(path, resources, resource);                                                                  // 1089
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1090
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1091
              res.writeHead(200, {                                                                                     // 1092
                "Content-Type": resource.type                                                                          // 1093
              });                                                                                                      // 1092
              res.end(resource.body);                                                                                  // 1095
            } else {                                                                                                   // 1096
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1097
                res.writeHead(401, {                                                                                   // 1098
                  "Content-Type": "text/plain",                                                                        // 1099
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1100
                });                                                                                                    // 1098
              } else {                                                                                                 // 1102
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1104
              }                                                                                                        // 1105
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1111
          }                                                                                                            // 1112
        }).then(function () {}, errorHandler);                                                                         // 1113
      }                                                                                                                // 1114
                                                                                                                       //
      return {                                                                                                         // 1116
        v: Promise.resolve(true)                                                                                       // 1116
      };                                                                                                               // 1116
    }();                                                                                                               // 996
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 996
  } else {                                                                                                             // 1117
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1118
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1119
      if (proxy) {                                                                                                     // 1120
        proxy.requestHandler(req, res);                                                                                // 1121
        return true;                                                                                                   // 1122
      } else {                                                                                                         // 1123
        return false;                                                                                                  // 1124
      }                                                                                                                // 1125
    });                                                                                                                // 1126
  }                                                                                                                    // 1127
};                                                                                                                     // 1128
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1137
    var _this3 = this;                                                                                                 // 1137
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1137
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1138
    this.ownerId = ownerId;                                                                                            // 1139
    this.identityId = identityId;                                                                                      // 1140
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1141
    this.sessionId = sessionId;                                                                                        // 1142
    this.tabId = tabId;                                                                                                // 1143
    this.isApi = isApi;                                                                                                // 1144
    this.hasLoaded = false;                                                                                            // 1145
    this.websockets = {};                                                                                              // 1146
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1147
    if (sessionId) {                                                                                                   // 1148
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1149
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1150
      this.hostId = hostId;                                                                                            // 1151
    } else {                                                                                                           // 1152
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1153
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1154
    }                                                                                                                  // 1155
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1157
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1158
      if (!identity) {                                                                                                 // 1159
        throw new Error("identity not found: " + this.identityId);                                                     // 1160
      }                                                                                                                // 1161
                                                                                                                       //
      this.userInfo = {                                                                                                // 1163
        displayName: { defaultText: identity.profile.name },                                                           // 1164
        preferredHandle: identity.profile.handle,                                                                      // 1165
        identityId: new Buffer(identity._id, "hex")                                                                    // 1166
      };                                                                                                               // 1163
      if (identity.profile.pictureUrl) this.userInfo.pictureUrl = identity.profile.pictureUrl;                         // 1168
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1169
    } else {                                                                                                           // 1170
      this.userInfo = {                                                                                                // 1171
        displayName: { defaultText: "Anonymous User" },                                                                // 1172
        preferredHandle: "anonymous"                                                                                   // 1173
      };                                                                                                               // 1171
    }                                                                                                                  // 1175
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1177
      if (_this3.sessionId) {                                                                                          // 1178
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1180
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this3.sessionId) {                         // 1181
          _this3.doSessionInit(request, response, url.query.path);                                                     // 1182
          return;                                                                                                      // 1183
        }                                                                                                              // 1184
      }                                                                                                                // 1185
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1187
        var contentLength = request.headers["content-length"];                                                         // 1188
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this3.handleRequestStreaming(request, response, contentLength, 0);                                   // 1192
        } else {                                                                                                       // 1193
          return readAll(request).then(function (data) {                                                               // 1194
            return _this3.handleRequest(request, data, response, 0);                                                   // 1195
          });                                                                                                          // 1196
        }                                                                                                              // 1197
      })["catch"](function (err) {                                                                                     // 1198
        _this3.setHasLoaded();                                                                                         // 1199
                                                                                                                       //
        var body = err.stack;                                                                                          // 1201
        if (err.cppFile) {                                                                                             // 1202
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1203
        }                                                                                                              // 1204
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1206
          body += "\ntype: " + err.kjType;                                                                             // 1207
        }                                                                                                              // 1208
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1210
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1212
          response.end();                                                                                              // 1213
        } else {                                                                                                       // 1214
          if (err instanceof Meteor.Error) {                                                                           // 1215
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1216
          } else {                                                                                                     // 1217
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1218
          }                                                                                                            // 1219
                                                                                                                       //
          response.end(body);                                                                                          // 1221
        }                                                                                                              // 1222
      });                                                                                                              // 1223
    };                                                                                                                 // 1224
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1226
      _this3.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1227
        console.error("WebSocket setup failed:", err.stack);                                                           // 1228
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1230
      });                                                                                                              // 1231
    };                                                                                                                 // 1232
  }                                                                                                                    // 1233
                                                                                                                       //
  Proxy.prototype.close = function close() {                                                                           //
    for (var socketIdx in this.websockets) {                                                                           // 1236
      this.websockets[socketIdx].destroy();                                                                            // 1237
    };                                                                                                                 // 1238
                                                                                                                       //
    this.websockets = {};                                                                                              // 1240
                                                                                                                       //
    if (this.session) {                                                                                                // 1242
      this.session.close();                                                                                            // 1243
      delete this.session;                                                                                             // 1244
    }                                                                                                                  // 1245
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1247
      this.uiView.close();                                                                                             // 1248
      delete this.uiView;                                                                                              // 1249
    }                                                                                                                  // 1250
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1252
      this.supervisor.close();                                                                                         // 1253
      delete this.supervisor;                                                                                          // 1254
    }                                                                                                                  // 1255
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1257
      this.permissionsObserver.stop();                                                                                 // 1258
      delete this.permissionsObserver;                                                                                 // 1259
    }                                                                                                                  // 1260
  };                                                                                                                   // 1261
                                                                                                                       //
  Proxy.prototype.getConnection = function getConnection() {                                                           //
    if (!this.supervisor) {                                                                                            // 1264
      this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                           // 1265
      this.uiView = null;                                                                                              // 1266
    }                                                                                                                  // 1267
                                                                                                                       //
    if (!this.uiView) {                                                                                                // 1269
      this.uiView = this.supervisor.getMainView().view;                                                                // 1270
    }                                                                                                                  // 1271
  };                                                                                                                   // 1272
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function _callNewWebSession(request, userInfo) {                                //
    var params = Capnp.serialize(WebSession.Params, {                                                                  // 1275
      basePath: PROTOCOL + "//" + request.headers.host,                                                                // 1276
      userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",                 // 1277
      acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
        return s.trim();                                                                                               // 1281
      }) : ["en-US", "en"]                                                                                             // 1281
    });                                                                                                                // 1275
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
  };                                                                                                                   // 1287
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function _callNewApiSession(request, userInfo) {                                //
    var _this4 = this;                                                                                                 // 1289
                                                                                                                       //
    var serializedParams = this.apiSessionParams;                                                                      // 1290
    if (!serializedParams) {                                                                                           // 1291
      throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                   // 1292
    }                                                                                                                  // 1293
                                                                                                                       //
    // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                     //
    // calling newSession with an ApiSession._id.                                                                      //
    // Eventually we'll remove this logic once we're sure apps have updated.                                           //
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
      return session.session;                                                                                          // 1302
    }, function (err) {                                                                                                // 1303
      return _this4._callNewWebSession(request, userInfo);                                                             // 1304
    });                                                                                                                // 1305
  };                                                                                                                   // 1306
                                                                                                                       //
  Proxy.prototype._callNewSession = function _callNewSession(request, viewInfo) {                                      //
    var _this5 = this;                                                                                                 // 1308
                                                                                                                       //
    var userInfo = _.clone(this.userInfo);                                                                             // 1309
    var promise = inMeteor(function () {                                                                               // 1310
      var vertex = void 0;                                                                                             // 1311
      if (_this5.apiToken) {                                                                                           // 1312
        vertex = { token: _this5.apiToken };                                                                           // 1313
      } else {                                                                                                         // 1314
        // (this.identityId might be null; this is fine)                                                               //
        vertex = { grain: { _id: _this5.grainId, identityId: _this5.identityId } };                                    // 1316
      }                                                                                                                // 1317
                                                                                                                       //
      var onInvalidated = function onInvalidated() {                                                                   // 1319
        Sessions.remove({ _id: _this5.sessionId });                                                                    // 1320
      };                                                                                                               // 1321
                                                                                                                       //
      if (!_this5.sessionId) {                                                                                         // 1323
        onInvalidated = function onInvalidated() {                                                                     // 1324
          apiSessionProxies.removeProxiesOfToken(_this5.apiToken._id);                                                 // 1325
        };                                                                                                             // 1326
      }                                                                                                                // 1327
                                                                                                                       //
      var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);              // 1329
                                                                                                                       //
      if (_this5.permissionsObserver) _this5.permissionsObserver.stop();                                               // 1332
      _this5.permissionsObserver = permissions.observeHandle;                                                          // 1333
                                                                                                                       //
      if (!permissions.permissions) {                                                                                  // 1335
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 1336
      }                                                                                                                // 1337
                                                                                                                       //
      Sessions.update({                                                                                                // 1339
        _id: _this5.sessionId                                                                                          // 1340
      }, {                                                                                                             // 1339
        $set: {                                                                                                        // 1342
          viewInfo: viewInfo,                                                                                          // 1343
          permissions: permissions.permissions                                                                         // 1344
        }                                                                                                              // 1342
      });                                                                                                              // 1341
                                                                                                                       //
      return permissions.permissions;                                                                                  // 1348
    });                                                                                                                // 1349
                                                                                                                       //
    return promise.then(function (permissions) {                                                                       // 1351
      userInfo.permissions = permissions;                                                                              // 1352
                                                                                                                       //
      var numBytes = Math.ceil(permissions.length / 8);                                                                // 1354
      var buf = new Buffer(numBytes);                                                                                  // 1355
      for (var ii = 0; ii < numBytes; ++ii) {                                                                          // 1356
        buf[ii] = 0;                                                                                                   // 1357
      }                                                                                                                // 1358
                                                                                                                       //
      for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                             // 1360
        var byteNum = Math.floor(_ii / 8);                                                                             // 1361
        var bitNum = _ii % 8;                                                                                          // 1362
        if (permissions[_ii]) {                                                                                        // 1363
          buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                   // 1364
        }                                                                                                              // 1365
      }                                                                                                                // 1366
                                                                                                                       //
      userInfo.deprecatedPermissionsBlob = buf;                                                                        // 1368
                                                                                                                       //
      if (_this5.isApi) {                                                                                              // 1370
        return _this5._callNewApiSession(request, userInfo);                                                           // 1371
      } else {                                                                                                         // 1372
        return _this5._callNewWebSession(request, userInfo);                                                           // 1373
      }                                                                                                                // 1374
    });                                                                                                                // 1375
  };                                                                                                                   // 1376
                                                                                                                       //
  Proxy.prototype.getSession = function getSession(request) {                                                          //
    var _this6 = this;                                                                                                 // 1378
                                                                                                                       //
    if (!this.session) {                                                                                               // 1379
      this.getConnection(); // make sure we're connected                                                               // 1380
      var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                               // 1381
        return inMeteor(function () {                                                                                  // 1382
          Grains.update(_this6.grainId, { $set: { cachedViewInfo: viewInfo } });                                       // 1383
        }).then(function () {                                                                                          // 1384
          return _this6._callNewSession(request, viewInfo);                                                            // 1385
        });                                                                                                            // 1386
      }, function (error) {                                                                                            // 1387
        if (error.kjType === "failed" || error.kjType === "unimplemented") {                                           // 1388
          // Method not implemented.                                                                                   //
          // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                     //
          //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                     //
          //   to accept 'failed' here at least until the next API bump.                                               //
          return _this6._callNewSession(request, {});                                                                  // 1393
        } else {                                                                                                       // 1394
          return Promise.reject(error);                                                                                // 1395
        }                                                                                                              // 1396
      });                                                                                                              // 1397
      this.session = new Capnp.Capability(promise, WebSession);                                                        // 1398
    }                                                                                                                  // 1399
                                                                                                                       //
    return this.session;                                                                                               // 1401
  };                                                                                                                   // 1402
                                                                                                                       //
  Proxy.prototype.keepAlive = function keepAlive() {                                                                   //
    this.getConnection();                                                                                              // 1405
    return this.supervisor.keepAlive();                                                                                // 1406
  };                                                                                                                   // 1407
                                                                                                                       //
  Proxy.prototype.resetConnection = function resetConnection() {                                                       //
    if (this.session) {                                                                                                // 1410
      this.session.close();                                                                                            // 1411
      delete this.session;                                                                                             // 1412
    }                                                                                                                  // 1413
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1415
      this.uiView.close();                                                                                             // 1416
      delete this.uiView;                                                                                              // 1417
    }                                                                                                                  // 1418
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1420
      this.supervisor.close();                                                                                         // 1421
      delete this.supervisor;                                                                                          // 1422
    }                                                                                                                  // 1423
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1425
      this.permissionsObserver.stop();                                                                                 // 1426
      delete this.permissionsObserver;                                                                                 // 1427
    }                                                                                                                  // 1428
  };                                                                                                                   // 1429
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function maybeRetryAfterError(error, retryCount) {                            //
    var _this7 = this;                                                                                                 // 1431
                                                                                                                       //
    // If the error may be caused by the grain dying or a network failure, try to restart it,                          //
    // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                            //
    // `retryCount` should be incremented for every successful retry as part of the same request;                      //
    // we only want to retry once.                                                                                     //
    if (SandstormBackend.shouldRestartGrain(error, retryCount)) {                                                      // 1436
      this.resetConnection();                                                                                          // 1437
      return inMeteor(function () {                                                                                    // 1438
        _this7.supervisor = globalBackend.continueGrain(_this7.grainId).supervisor;                                    // 1439
      });                                                                                                              // 1440
    } else {                                                                                                           // 1441
      throw error;                                                                                                     // 1442
    }                                                                                                                  // 1443
  };                                                                                                                   // 1444
                                                                                                                       //
  Proxy.prototype.doSessionInit = function doSessionInit(request, response, requestPath) {                             //
    // jscs:disable disallowQuotedKeysInObjects                                                                        //
    var path = requestPath || "/";                                                                                     // 1448
                                                                                                                       //
    // Check that the path is relative (ie. starts with a /).                                                          //
    // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                         //
    if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                           // 1452
      response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                              // 1453
      response.end("Invalid path supplied.");                                                                          // 1454
      return;                                                                                                          // 1455
    }                                                                                                                  // 1456
                                                                                                                       //
    // Set the session ID.                                                                                             //
    response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));     // 1459
                                                                                                                       //
    response.setHeader("Cache-Control", "no-cache, private");                                                          // 1461
                                                                                                                       //
    // Redirect to the app's root URL.                                                                                 //
    // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                  //
    //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                       //
    response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                             // 1466
    response.end();                                                                                                    // 1467
  };                                                                                                                   // 1468
                                                                                                                       //
  Proxy.prototype.makeContext = function makeContext(request, response, callback) {                                    //
    // Parses the cookies from the request, checks that the session ID is present and valid, then                      //
    // synchronously calls callback() passing it the request context object which contains the                         //
    // other cookies. Throws an exception if the session ID is missing or invalid. The callback                        //
    // must immediately use the context in an RPC. Once the callback returns, the context object                       //
    // will be torn down.                                                                                              //
    //                                                                                                                 //
    // `makeContext()` returns the result of `callback()`.                                                             //
                                                                                                                       //
    var context = {};                                                                                                  // 1479
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1481
      var parseResult = parseCookies(request);                                                                         // 1482
      if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                        // 1483
        throw new Meteor.Error(403, "Unauthorized");                                                                   // 1484
      }                                                                                                                // 1485
                                                                                                                       //
      if (parseResult.cookies.length > 0) {                                                                            // 1487
        context.cookies = parseResult.cookies;                                                                         // 1488
      }                                                                                                                // 1489
    } else {                                                                                                           // 1490
      // jscs:disable disallowEmptyBlocks                                                                              //
      // This is an API request. Cookies are not supported.                                                            //
    }                                                                                                                  // 1493
                                                                                                                       //
    context.accept = parseAcceptHeader(request);                                                                       // 1495
                                                                                                                       //
    context.eTagPrecondition = parsePreconditionHeader(request);                                                       // 1497
                                                                                                                       //
    context.additionalHeaders = [];                                                                                    // 1499
    WebSession.Context.headerWhitelist.forEach(function (headerName) {                                                 // 1500
      if (headerName.endsWith("*")) {                                                                                  // 1501
        var prefix = headerName.substr(0, headerName.length - 1);                                                      // 1502
        for (var h in request.headers) {                                                                               // 1503
          if (!h.startsWith(prefix)) {                                                                                 // 1504
            continue;                                                                                                  // 1505
          }                                                                                                            // 1506
                                                                                                                       //
          context.additionalHeaders.push({                                                                             // 1508
            name: h,                                                                                                   // 1509
            value: request.headers[h]                                                                                  // 1510
          });                                                                                                          // 1508
        }                                                                                                              // 1512
      } else if (request.headers[headerName]) {                                                                        // 1513
        context.additionalHeaders.push({                                                                               // 1514
          name: headerName,                                                                                            // 1515
          value: request.headers[headerName]                                                                           // 1516
        });                                                                                                            // 1514
      };                                                                                                               // 1518
    });                                                                                                                // 1519
                                                                                                                       //
    if (response) {                                                                                                    // 1521
      var promise = new Promise(function (resolve, reject) {                                                           // 1522
        response.resolveResponseStream = resolve;                                                                      // 1523
        response.rejectResponseStream = reject;                                                                        // 1524
      });                                                                                                              // 1525
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1527
                                                                                                                       //
      try {                                                                                                            // 1529
        return callback(context);                                                                                      // 1530
      } finally {                                                                                                      // 1531
        context.responseStream.close();                                                                                // 1532
      }                                                                                                                // 1533
    } else {                                                                                                           // 1534
      // WebSocket -- no response object.                                                                              //
      return callback(context);                                                                                        // 1536
    }                                                                                                                  // 1537
  };                                                                                                                   // 1538
                                                                                                                       //
  Proxy.prototype.translateResponse = function translateResponse(rpcResponse, response, request) {                     //
    if (this.hostId) {                                                                                                 // 1541
      if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                               // 1542
        response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                             // 1543
      }                                                                                                                // 1544
                                                                                                                       //
      // TODO(security): Add a Content-Security-Policy header which:                                                   //
      // (1) Prevents the app from initiating HTTP requests to third parties.                                          //
      // (2) Prevents the app from navigating the parent frame.                                                        //
      // (3) Prevents the app from opening popups.                                                                     //
      // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                         //
      //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                        //
    } else {                                                                                                           // 1552
        // jscs:disable validateQuoteMarks                                                                             //
        // This is an API request. Cookies are not supported.                                                          //
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                //
        response.setHeader('Vary', 'Authorization');                                                                   // 1557
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                //
        response.setHeader('Access-Control-Allow-Origin', '*');                                                        // 1560
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 //
        // in a browser context. This policy should thoroughly neuter it.                                              //
        response.setHeader('Content-Security-Policy', "default-src 'none'; sandbox");                                  // 1564
      }                                                                                                                // 1565
                                                                                                                       //
    // On first response, update the session to have hasLoaded=true                                                    //
    this.setHasLoaded();                                                                                               // 1568
                                                                                                                       //
    // TODO(security): Set X-Content-Type-Options: nosniff?                                                            //
                                                                                                                       //
    if ('content' in rpcResponse) {                                                                                    // 1572
      var content = rpcResponse.content;                                                                               // 1573
      var code = successCodes[content.statusCode];                                                                     // 1574
      if (!code) {                                                                                                     // 1575
        throw new Error('Unknown status code: ', content.statusCode);                                                  // 1576
      }                                                                                                                // 1577
                                                                                                                       //
      if (content.mimeType) {                                                                                          // 1579
        response.setHeader('Content-Type', content.mimeType);                                                          // 1580
      }                                                                                                                // 1581
                                                                                                                       //
      if (content.encoding) {                                                                                          // 1583
        response.setHeader('Content-Encoding', content.encoding);                                                      // 1584
      }                                                                                                                // 1585
                                                                                                                       //
      if (content.language) {                                                                                          // 1587
        response.setHeader('Content-Language', content.language);                                                      // 1588
      }                                                                                                                // 1589
                                                                                                                       //
      if (content.eTag) {                                                                                              // 1591
        response.setHeader('ETag', composeETag(content.eTag));                                                         // 1592
      }                                                                                                                // 1593
                                                                                                                       //
      if ('disposition' in content && 'download' in content.disposition) {                                             // 1595
        response.setHeader('Content-Disposition', 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
      }                                                                                                                // 1598
                                                                                                                       //
      if ('stream' in content.body) {                                                                                  // 1600
        if (request.method === 'HEAD') {                                                                               // 1601
          content.body.stream.close();                                                                                 // 1602
          response.rejectResponseStream(new Error('HEAD request; content doesn\'t matter.'));                          // 1603
        } else {                                                                                                       // 1604
          var streamHandle = content.body.stream;                                                                      // 1605
          var responseStream = new Capnp.Capability(new ResponseStream(response, code.id, code.title, streamHandle), ByteStream);
          response.resolveResponseStream(responseStream);                                                              // 1609
          return { streamHandle: responseStream };                                                                     // 1610
        }                                                                                                              // 1611
      } else {                                                                                                         // 1612
        response.rejectResponseStream(new Error('Response content body was not a stream.'));                           // 1613
                                                                                                                       //
        if ('bytes' in content.body) {                                                                                 // 1616
          response.setHeader('Content-Length', content.body.bytes.length);                                             // 1617
        } else {                                                                                                       // 1618
          throw new Error('Unknown content body type.');                                                               // 1619
        }                                                                                                              // 1620
      }                                                                                                                // 1621
                                                                                                                       //
      response.writeHead(code.id, code.title);                                                                         // 1623
                                                                                                                       //
      if ('bytes' in content.body && request.method !== 'HEAD') {                                                      // 1625
        response.write(content.body.bytes);                                                                            // 1626
      }                                                                                                                // 1627
                                                                                                                       //
      response.end();                                                                                                  // 1629
    } else if ('noContent' in rpcResponse) {                                                                           // 1630
      var noContent = rpcResponse.noContent;                                                                           // 1631
      var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                        // 1632
      response.writeHead(noContentCode.id, noContentCode.title);                                                       // 1633
      response.end();                                                                                                  // 1634
    } else if ('preconditionFailed' in rpcResponse) {                                                                  // 1635
      var preconditionFailed = rpcResponse.preconditionFailed;                                                         // 1636
      if (request.method === 'GET' && 'if-none-match' in request.headers) {                                            // 1637
        if (preconditionFailed.matchingETag) {                                                                         // 1638
          response.setHeader('ETag', composeETag(preconditionFailed.matchingETag));                                    // 1639
        }                                                                                                              // 1640
                                                                                                                       //
        response.writeHead(304, 'Not Modified');                                                                       // 1642
      } else {                                                                                                         // 1643
        response.writeHead(412, 'Precondition Failed');                                                                // 1644
      }                                                                                                                // 1645
                                                                                                                       //
      response.end();                                                                                                  // 1647
    } else if ('redirect' in rpcResponse) {                                                                            // 1648
      var redirect = rpcResponse.redirect;                                                                             // 1649
      var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                               // 1650
      response.writeHead(redirectCode.id, redirectCode.title, {                                                        // 1651
        'Location': redirect.location                                                                                  // 1652
      });                                                                                                              // 1651
      response.end();                                                                                                  // 1654
    } else if ('clientError' in rpcResponse) {                                                                         // 1655
      var clientError = rpcResponse.clientError;                                                                       // 1656
      var errorCode = errorCodes[clientError.statusCode];                                                              // 1657
      if (!errorCode) {                                                                                                // 1658
        throw new Error('Unknown status code: ', clientError.statusCode);                                              // 1659
      }                                                                                                                // 1660
                                                                                                                       //
      response.writeHead(errorCode.id, errorCode.title, {                                                              // 1662
        'Content-Type': 'text/html'                                                                                    // 1663
      });                                                                                                              // 1662
                                                                                                                       //
      if (request.method !== 'HEAD') {                                                                                 // 1666
        if (clientError.descriptionHtml) {                                                                             // 1667
          response.write(clientError.descriptionHtml);                                                                 // 1668
        } else {                                                                                                       // 1669
          // TODO(someday):  Better default error page.                                                                //
          response.write('<html><body><h1>' + errorCode.id + ': ' + errorCode.title + '</h1></body></html>');          // 1671
        }                                                                                                              // 1673
      }                                                                                                                // 1674
                                                                                                                       //
      response.end();                                                                                                  // 1676
    } else if ('serverError' in rpcResponse) {                                                                         // 1677
      response.writeHead(500, 'Internal Server Error', {                                                               // 1678
        'Content-Type': 'text/html'                                                                                    // 1679
      });                                                                                                              // 1678
                                                                                                                       //
      if (request.method !== 'HEAD') {                                                                                 // 1682
        if (rpcResponse.serverError.descriptionHtml) {                                                                 // 1683
          response.write(rpcResponse.serverError.descriptionHtml);                                                     // 1684
        } else {                                                                                                       // 1685
          // TODO(someday):  Better default error page.                                                                //
          response.write('<html><body><h1>500: Internal Server Error</h1></body></html>');                             // 1687
        }                                                                                                              // 1688
      }                                                                                                                // 1689
                                                                                                                       //
      response.end();                                                                                                  // 1691
    } else {                                                                                                           // 1692
      throw new Error('Unknown HTTP response type:\n' + JSON.stringify(rpcResponse));                                  // 1693
    }                                                                                                                  // 1694
                                                                                                                       //
    return {};                                                                                                         // 1696
  };                                                                                                                   // 1697
                                                                                                                       //
  Proxy.prototype.handleRequest = function handleRequest(request, data, response, retryCount) {                        //
    var _this8 = this;                                                                                                 // 1699
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1700
      return _this8.makeContext(request, response, function (context) {                                                // 1701
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1704
        var session = _this8.getSession(request);                                                                      // 1705
                                                                                                                       //
        var requestContent = function requestContent() {                                                               // 1707
          return {                                                                                                     // 1708
            content: data,                                                                                             // 1709
            encoding: request.headers['content-encoding'],                                                             // 1710
            mimeType: request.headers['content-type']                                                                  // 1711
          };                                                                                                           // 1708
        };                                                                                                             // 1713
                                                                                                                       //
        var xmlContent = function xmlContent() {                                                                       // 1715
          var type = request.headers['content-type'] || 'application/xml;charset=utf-8';                               // 1716
          var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                              // 1717
          if (!match) {                                                                                                // 1718
            response.writeHead(415, 'Unsupported media type.', {                                                       // 1719
              'Content-Type': 'text/plain'                                                                             // 1720
            });                                                                                                        // 1719
            response.end('expected XML request body');                                                                 // 1722
            throw new Error('expected XML request body');                                                              // 1723
          }                                                                                                            // 1724
                                                                                                                       //
          var charset = match[2] || 'ISO-8859-1';                                                                      // 1726
                                                                                                                       //
          var encoding = request.headers['content-encoding'];                                                          // 1728
          if (encoding && encoding !== 'identity') {                                                                   // 1729
            if (encoding !== 'gzip') throw new Error('unknown Content-Encoding: ' + encoding);                         // 1730
            data = gunzipSync(data);                                                                                   // 1731
          }                                                                                                            // 1732
                                                                                                                       //
          return data.toString(charset.toLowerCase() === 'utf-8' ? 'utf8' : 'binary');                                 // 1734
        };                                                                                                             // 1735
                                                                                                                       //
        var propfindDepth = function propfindDepth() {                                                                 // 1737
          var depth = request.headers['depth'];                                                                        // 1738
          return depth === '0' ? 'zero' : depth === '1' ? 'one' : 'infinity';                                          // 1739
        };                                                                                                             // 1742
                                                                                                                       //
        var shallow = function shallow() {                                                                             // 1744
          return request.headers['depth'] === '0';                                                                     // 1745
        };                                                                                                             // 1746
                                                                                                                       //
        var noOverwrite = function noOverwrite() {                                                                     // 1748
          return (request.headers['overwrite'] || '').toLowerCase() === 'f';                                           // 1749
        };                                                                                                             // 1750
                                                                                                                       //
        var destination = function destination() {                                                                     // 1752
          var result = request.headers['destination'];                                                                 // 1753
          if (!result) throw new Error('missing destination');                                                         // 1754
          return Url.parse(result).path.slice(1); // remove leading '/'                                                // 1755
        };                                                                                                             // 1756
                                                                                                                       //
        if (request.method === 'GET' || request.method === 'HEAD') {                                                   // 1758
          return session.get(path, context, request.method === 'HEAD');                                                // 1759
        } else if (request.method === 'POST') {                                                                        // 1760
          return session.post(path, requestContent(), context);                                                        // 1761
        } else if (request.method === 'PUT') {                                                                         // 1762
          return session.put(path, requestContent(), context);                                                         // 1763
        } else if (request.method === 'PATCH') {                                                                       // 1764
          return session.patch(path, requestContent(), context);                                                       // 1765
        } else if (request.method === 'DELETE') {                                                                      // 1766
          return session["delete"](path, context);                                                                     // 1767
        } else if (request.method === 'PROPFIND') {                                                                    // 1768
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1769
        } else if (request.method === 'PROPPATCH') {                                                                   // 1770
          return session.proppatch(path, xmlContent(), context);                                                       // 1771
        } else if (request.method === 'MKCOL') {                                                                       // 1772
          return session.mkcol(path, requestContent(), context);                                                       // 1773
        } else if (request.method === 'COPY') {                                                                        // 1774
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1775
        } else if (request.method === 'MOVE') {                                                                        // 1776
          return session.move(path, destination(), noOverwrite(), context);                                            // 1777
        } else if (request.method === 'LOCK') {                                                                        // 1778
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1779
        } else if (request.method === 'UNLOCK') {                                                                      // 1780
          return session.unlock(path, request.headers['lock-token'], context);                                         // 1781
        } else if (request.method === 'ACL') {                                                                         // 1782
          return session.acl(path, xmlContent(), context);                                                             // 1783
        } else if (request.method === 'REPORT') {                                                                      // 1784
          return session.report(path, requestContent(), context);                                                      // 1785
        } else if (request.method === 'OPTIONS') {                                                                     // 1786
          return session.options(path, context).then(function (options) {                                              // 1787
            var dav = [];                                                                                              // 1788
            if (options.davClass1) dav.push('1');                                                                      // 1789
            if (options.davClass2) dav.push('2');                                                                      // 1790
            if (options.davClass3) dav.push('3');                                                                      // 1791
            if (options.davExtensions) {                                                                               // 1792
              options.davExtensions.forEach(function (token) {                                                         // 1793
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1794
                  dav.push(token);                                                                                     // 1795
                }                                                                                                      // 1796
              });                                                                                                      // 1797
            }                                                                                                          // 1798
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1800
              response.setHeader("DAV", dav.join(", "));                                                               // 1801
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1802
            }                                                                                                          // 1803
                                                                                                                       //
            response.end();                                                                                            // 1805
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1807
            if (err.kjType !== 'unimplemented') throw err;                                                             // 1808
            response.end();                                                                                            // 1809
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1811
        } else {                                                                                                       // 1812
            throw new Error('Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.');
          }                                                                                                            // 1814
      });                                                                                                              // 1815
    }).then(function (rpcResponse) {                                                                                   // 1816
      if (rpcResponse !== undefined) {                                                                                 // 1817
        // Will be undefined for OPTIONS request.                                                                      //
        return _this8.translateResponse(rpcResponse, response, request);                                               // 1818
      }                                                                                                                // 1819
    })["catch"](function (error) {                                                                                     // 1820
      return _this8.maybeRetryAfterError(error, retryCount).then(function () {                                         // 1821
        return _this8.handleRequest(request, data, response, retryCount + 1);                                          // 1822
      });                                                                                                              // 1823
    });                                                                                                                // 1824
  };                                                                                                                   // 1825
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function handleRequestStreaming(request, response, contentLength, retryCount) {
    var _this9 = this;                                                                                                 // 1827
                                                                                                                       //
    return this.makeContext(request, response, function (context) {                                                    // 1828
      var path = request.url.slice(1); // remove leading '/'                                                           // 1829
      var session = _this9.getSession(request);                                                                        // 1830
                                                                                                                       //
      var mimeType = request.headers['content-type'] || 'application/octet-stream';                                    // 1832
      var encoding = request.headers['content-encoding'];                                                              // 1833
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1835
      if (request.method === 'POST') {                                                                                 // 1836
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1837
      } else if (request.method === 'PUT') {                                                                           // 1838
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1839
      } else {                                                                                                         // 1840
        throw new Error('Sandstorm only supports streaming POST and PUT requests.');                                   // 1841
      }                                                                                                                // 1842
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1848
        var requestStream = requestStreamResult.stream;                                                                // 1849
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1852
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1855
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even                      //
        // while data is still being streamed up. This theoretically allows apps to perform                            //
        // bidirectional streaming, though probably very few actually do that.                                         //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that                      //
        // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                           //
        // variable.                                                                                                   //
        var responsePromise = requestStream.getResponse();                                                             // 1864
                                                                                                                       //
        var reportUploadStreamError = function reportUploadStreamError(err) {                                          // 1866
          // Called when an upload-stream method throws.                                                               //
                                                                                                                       //
          if (!uploadStreamError) {                                                                                    // 1869
            uploadStreamError = err;                                                                                   // 1870
                                                                                                                       //
            // If we're still waiting on any response stuff, cancel it.                                                //
            responsePromise.cancel();                                                                                  // 1873
            requestStream.close();                                                                                     // 1874
            if (downloadStreamHandle) {                                                                                // 1875
              downloadStreamHandle.close();                                                                            // 1876
            }                                                                                                          // 1877
          }                                                                                                            // 1878
        };                                                                                                             // 1879
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1882
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1883
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== 'unimplemented') {                                                                      // 1885
              reportUploadStreamError(err);                                                                            // 1886
            }                                                                                                          // 1887
          });                                                                                                          // 1888
        }                                                                                                              // 1889
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        var writesInFlight = 0;                                                                                        // 1892
        var readingPaused = false;                                                                                     // 1893
        request.on('data', function (buf) {                                                                            // 1894
          // TODO(someday): Coalesce small writes.                                                                     //
          if (!uploadStreamError) {                                                                                    // 1896
            requestStream.write(buf).then(function () {                                                                // 1897
              writesInFlight--;                                                                                        // 1898
              if (readingPaused) {                                                                                     // 1899
                request.resume();                                                                                      // 1900
                readingPaused = false;                                                                                 // 1901
              }                                                                                                        // 1902
            })["catch"](reportUploadStreamError);                                                                      // 1903
                                                                                                                       //
            if (writesInFlight++ > 16) {                                                                               // 1905
              request.pause();                                                                                         // 1906
              readingPaused = true;                                                                                    // 1907
            }                                                                                                          // 1908
          }                                                                                                            // 1909
        });                                                                                                            // 1910
                                                                                                                       //
        request.on('end', function () {                                                                                // 1912
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1913
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1916
        });                                                                                                            // 1917
                                                                                                                       //
        request.on('close', function () {                                                                              // 1919
          reportUploadStreamError(new Error('HTTP connection unexpectedly closed during request.'));                   // 1920
        });                                                                                                            // 1921
                                                                                                                       //
        request.on('error', function (err) {                                                                           // 1923
          reportUploadStreamError(err);                                                                                // 1924
        });                                                                                                            // 1925
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 1927
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 1929
          downloadStreamHandle = _this9.translateResponse(rpcResponse, response, request).streamHandle;                // 1930
        });                                                                                                            // 1931
      }, function (err) {                                                                                              // 1932
        if (err.kjType === 'failed' && err.message.indexOf('not implemented') !== -1) {                                // 1933
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = 'unimplemented';                                                                                // 1938
        }                                                                                                              // 1939
                                                                                                                       //
        if (SandstormBackend.shouldRestartGrain(err, 0)) {                                                             // 1941
          // This is the kind of error that indicates we should retry. Note that we passed 0 for                       //
          // the retry count above because we were just checking if this is a retriable error (vs.                     //
          // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                    //
          // the proper retry count.                                                                                   //
          return _this9.maybeRetryAfterError(err, retryCount).then(function () {                                       // 1946
            return _this9.handleRequestStreaming(request, response, contentLength, retryCount + 1);                    // 1947
          });                                                                                                          // 1948
        } else if (err.kjType === 'unimplemented') {                                                                   // 1949
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 1951
            return _this9.handleRequest(request, data, response, 0);                                                   // 1952
          });                                                                                                          // 1953
        } else {                                                                                                       // 1954
          throw err;                                                                                                   // 1955
        }                                                                                                              // 1956
      });                                                                                                              // 1957
    });                                                                                                                // 1958
  };                                                                                                                   // 1959
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function handleWebSocket(request, socket, head, retryCount) {                      //
    var _this10 = this;                                                                                                // 1961
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1962
      return _this10.makeContext(request, undefined, function (context) {                                              // 1963
        var path = request.url.slice(1); // remove leading '/'                                                         // 1964
        var session = _this10.getSession(request);                                                                     // 1965
                                                                                                                       //
        if (!('sec-websocket-key' in request.headers)) {                                                               // 1967
          throw new Error('Missing Sec-WebSocket-Accept header.');                                                     // 1968
        }                                                                                                              // 1969
                                                                                                                       //
        var magic = request.headers['sec-websocket-key'] + '258EAFA5-E914-47DA-95CA-C5AB0DC85B11';                     // 1971
        var acceptKey = Crypto.createHash('sha1').update(magic).digest('base64');                                      // 1972
                                                                                                                       //
        var protocols = [];                                                                                            // 1974
        if ('sec-websocket-protocol' in request.headers) {                                                             // 1975
          protocols = request.headers['sec-websocket-protocol'].split(',').map(function (s) {                          // 1976
            return s.trim();                                                                                           // 1977
          });                                                                                                          // 1977
        }                                                                                                              // 1978
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 1980
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 1982
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 1984
          promise.serverStream.sendBytes(head);                                                                        // 1985
        }                                                                                                              // 1986
                                                                                                                       //
        var socketIdx = _this10.websocketCounter.toString();                                                           // 1988
        _this10.websockets[socketIdx] = socket;                                                                        // 1989
        _this10.websocketCounter += 1;                                                                                 // 1990
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 1991
          delete _this10.websockets[socketIdx];                                                                        // 1991
        });                                                                                                            // 1991
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 1993
          var headers = ['HTTP/1.1 101 Switching Protocols', 'Upgrade: websocket', 'Connection: Upgrade', 'Sec-WebSocket-Accept: ' + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2000
            headers.push('Sec-WebSocket-Protocol: ' + response.protocol.join(', '));                                   // 2001
          }                                                                                                            // 2002
                                                                                                                       //
          headers.push('');                                                                                            // 2004
          headers.push('');                                                                                            // 2005
                                                                                                                       //
          socket.write(headers.join('\r\n'));                                                                          // 2007
          receiver.go();                                                                                               // 2008
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 2011
      });                                                                                                              // 2012
    })["catch"](function (error) {                                                                                     // 2013
      return _this10.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2014
        return _this10.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2015
      });                                                                                                              // 2016
    });                                                                                                                // 2017
  };                                                                                                                   // 2018
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function setHasLoaded() {                                                             //
    var _this11 = this;                                                                                                // 2020
                                                                                                                       //
    if (!this.hasLoaded) {                                                                                             // 2021
      (function () {                                                                                                   // 2021
        _this11.hasLoaded = true;                                                                                      // 2022
        var sessionId = _this11.sessionId;                                                                             // 2023
        inMeteor(function () {                                                                                         // 2024
          Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                          // 2025
        });                                                                                                            // 2026
      })();                                                                                                            // 2021
    }                                                                                                                  // 2027
  };                                                                                                                   // 2028
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2031
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2033
  if (Net.isIPv4(address)) {                                                                                           // 2034
    quad = address.split('.').map(function (x) {                                                                       // 2035
      return parseInt(x, 10);                                                                                          // 2035
    });                                                                                                                // 2035
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2039
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === '::1' || address.lastIndexOf('fd', 0) === 0;                                                    // 2041
  } else {                                                                                                             // 2042
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2044
  }                                                                                                                    // 2045
};                                                                                                                     // 2046
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2048
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2049
  return num.toString();                                                                                               // 2053
};                                                                                                                     // 2054
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2059
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers['cookie'];                                                                              // 2061
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2063
  if (header) {                                                                                                        // 2064
    var reqCookies = header.split(';');                                                                                // 2065
    for (var i in reqCookies) {                                                                                        // 2066
      var reqCookie = reqCookies[i];                                                                                   // 2067
      var equalsPos = reqCookie.indexOf('=');                                                                          // 2068
      var cookie = void 0;                                                                                             // 2069
      if (equalsPos === -1) {                                                                                          // 2070
        cookie = { key: reqCookie.trim(), value: '' };                                                                 // 2071
      } else {                                                                                                         // 2072
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2073
      }                                                                                                                // 2074
                                                                                                                       //
      if (cookie.key === 'sandstorm-sid') {                                                                            // 2076
        if (result.sessionId) {                                                                                        // 2077
          throw new Error('Multiple sandstorm session IDs?');                                                          // 2078
        }                                                                                                              // 2079
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2081
      } else {                                                                                                         // 2082
        result.cookies.push(cookie);                                                                                   // 2083
      }                                                                                                                // 2084
    }                                                                                                                  // 2085
  }                                                                                                                    // 2086
                                                                                                                       //
  return result;                                                                                                       // 2088
};                                                                                                                     // 2089
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2091
  if (request.headers['if-match']) {                                                                                   // 2092
    if (request.headers['if-match'].trim() === '*') {                                                                  // 2093
      return { exists: null };                                                                                         // 2094
    }                                                                                                                  // 2095
                                                                                                                       //
    var matches = parseETagList(request.headers['if-match']);                                                          // 2097
    if (matches.length > 0) {                                                                                          // 2098
      return { matchesOneOf: matches };                                                                                // 2099
    }                                                                                                                  // 2100
  }                                                                                                                    // 2101
                                                                                                                       //
  if (request.headers['if-none-match']) {                                                                              // 2103
    if (request.headers['if-none-match'].trim() === '*') {                                                             // 2104
      return { doesntExist: null };                                                                                    // 2105
    }                                                                                                                  // 2106
                                                                                                                       //
    var noneMatches = parseETagList(request.headers['if-none-match']);                                                 // 2108
    if (noneMatches.length > 0) {                                                                                      // 2109
      return { matchesNoneOf: noneMatches };                                                                           // 2110
    }                                                                                                                  // 2111
  }                                                                                                                    // 2112
                                                                                                                       //
  return { none: null };                                                                                               // 2114
};                                                                                                                     // 2115
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2117
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2121
  var results = [];                                                                                                    // 2122
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2124
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2125
    if (!match) throw new Meteor.Error(400, 'invalid etag');                                                           // 2126
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2128
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, '$1') });                                       // 2129
  }                                                                                                                    // 2130
                                                                                                                       //
  return results;                                                                                                      // 2132
};                                                                                                                     // 2133
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2135
  var result = '"' + (tag.value || '').replace(/([\\"])/g, '\\$1') + '"';                                              // 2136
  if (tag.weak) result = 'W/' + result;                                                                                // 2137
  return result;                                                                                                       // 2138
};                                                                                                                     // 2139
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2141
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers['accept'];                                                                              // 2143
                                                                                                                       //
  var result = [];                                                                                                     // 2145
  if (header) {                                                                                                        // 2146
    var acceptList = header.split(',');                                                                                // 2147
    for (var i in acceptList) {                                                                                        // 2148
      var acceptStr = acceptList[i];                                                                                   // 2149
      var tokensList = acceptStr.split(';');                                                                           // 2150
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2152
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2154
      for (var j in tokensListRest) {                                                                                  // 2155
        var token = tokensListRest[j];                                                                                 // 2156
        var equalsPos = token.indexOf('=');                                                                            // 2157
        if (equalsPos) {                                                                                               // 2158
          var key = token.slice(0, equalsPos).trim();                                                                  // 2159
          var value = token.slice(equalsPos + 1).trim();                                                               // 2160
                                                                                                                       //
          if (key === 'q') {                                                                                           // 2162
            temp.qValue = +value;                                                                                      // 2163
          }                                                                                                            // 2164
        }                                                                                                              // 2165
      }                                                                                                                // 2166
                                                                                                                       //
      result.push(temp);                                                                                               // 2168
    }                                                                                                                  // 2169
  }                                                                                                                    // 2170
                                                                                                                       //
  return result;                                                                                                       // 2172
};                                                                                                                     // 2173
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2178
  return new Promise(function (resolve, reject) {                                                                      // 2179
    var buffers = [];                                                                                                  // 2180
    stream.on('data', function (buf) {                                                                                 // 2181
      buffers.push(buf);                                                                                               // 2182
    });                                                                                                                // 2183
                                                                                                                       //
    stream.on('end', function () {                                                                                     // 2185
      resolve(Buffer.concat(buffers));                                                                                 // 2186
    });                                                                                                                // 2187
                                                                                                                       //
    stream.on('error', reject);                                                                                        // 2189
  });                                                                                                                  // 2190
};                                                                                                                     // 2191
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2193
  var result = [cookie.name, '=', cookie.value];                                                                       // 2194
                                                                                                                       //
  if ('absolute' in cookie.expires) {                                                                                  // 2196
    result.push('; Expires=');                                                                                         // 2197
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2198
  } else if ('relative' in cookie.expires) {                                                                           // 2199
    result.push('; Max-Age=' + cookie.expires.relative);                                                               // 2200
  }                                                                                                                    // 2201
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2203
    result.push('; Path=' + cookie.path);                                                                              // 2204
  }                                                                                                                    // 2205
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2207
    result.push('; HttpOnly');                                                                                         // 2208
  }                                                                                                                    // 2209
                                                                                                                       //
  return result.join('');                                                                                              // 2211
};                                                                                                                     // 2212
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2215
  ok: { id: 200, title: 'OK' },                                                                                        // 2216
  created: { id: 201, title: 'Created' },                                                                              // 2217
  accepted: { id: 202, title: 'Accepted' },                                                                            // 2218
  multiStatus: { id: 207, title: 'Multi-Status' }                                                                      // 2219
};                                                                                                                     // 2215
var noContentSuccessCodes = [                                                                                          // 2221
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: 'No Content' }, { id: 205, title: 'Reset Content' }];                                                // 2223
var redirectCodes = [                                                                                                  // 2226
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: 'Temporary Redirect' }, { id: 308, title: 'Permanent Redirect' }, { id: 303, title: 'See Other' }, { id: 301, title: 'Moved Permanently' }];
var errorCodes = {                                                                                                     // 2233
  badRequest: { id: 400, title: 'Bad Request' },                                                                       // 2234
  forbidden: { id: 403, title: 'Forbidden' },                                                                          // 2235
  notFound: { id: 404, title: 'Not Found' },                                                                           // 2236
  methodNotAllowed: { id: 405, title: 'Method Not Allowed' },                                                          // 2237
  notAcceptable: { id: 406, title: 'Not Acceptable' },                                                                 // 2238
  conflict: { id: 409, title: 'Conflict' },                                                                            // 2239
  gone: { id: 410, title: 'Gone' },                                                                                    // 2240
  requestEntityTooLarge: { id: 413, title: 'Request Entity Too Large' },                                               // 2241
  requestUriTooLong: { id: 414, title: 'Request-URI Too Long' },                                                       // 2242
  unsupportedMediaType: { id: 415, title: 'Unsupported Media Type' },                                                  // 2243
  imATeapot: { id: 418, title: 'I\'m a teapot' },                                                                      // 2244
  unprocessableEntity: { id: 422, title: 'Unprocessable Entity' }                                                      // 2245
};                                                                                                                     // 2233
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2248
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle) {                                            // 2251
    var _this12 = this;                                                                                                // 2251
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2251
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2269
    this.httpCode = httpCode;                                                                                          // 2270
    this.httpStatus = httpStatus;                                                                                      // 2271
    this.upstreamHandle = upstreamHandle;                                                                              // 2272
                                                                                                                       //
    this.started = false;                                                                                              // 2274
    this.ended = false;                                                                                                // 2275
    this.waiting = [];                                                                                                 // 2276
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2278
      _this12.waiting.forEach(function (f) {                                                                           // 2279
        return f();                                                                                                    // 2279
      });                                                                                                              // 2279
      _this12.waiting = [];                                                                                            // 2280
    });                                                                                                                // 2281
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2283
      _this12.aborted = true;                                                                                          // 2284
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    //
      // an incomplete download is the client's problem, not the server's. The important thing is                      //
      // to cancel the stream if it is still being generated; to that end, the next new write()                        //
      // call after this point will throw.                                                                             //
      _this12.waiting.forEach(function (f) {                                                                           // 2290
        return f();                                                                                                    // 2290
      });                                                                                                              // 2290
      _this12.waiting = [];                                                                                            // 2291
                                                                                                                       //
      _this12.close();                                                                                                 // 2293
    });                                                                                                                // 2294
  }                                                                                                                    // 2295
                                                                                                                       //
  ResponseStream.prototype.expectSize = function expectSize(size) {                                                    // 2248
    if (!this.started) {                                                                                               // 2298
      this.started = true;                                                                                             // 2299
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                             // 2300
    }                                                                                                                  // 2301
  };                                                                                                                   // 2302
                                                                                                                       //
  ResponseStream.prototype.write = function write(data) {                                                              // 2248
    var _this13 = this;                                                                                                // 2304
                                                                                                                       //
    if (!this.started) {                                                                                               // 2305
      this.started = true;                                                                                             // 2306
      this.response.writeHead(this.httpCode, this.httpStatus);                                                         // 2307
    }                                                                                                                  // 2308
                                                                                                                       //
    if (this.aborted) {                                                                                                // 2310
      // Connection has been aborted.                                                                                  //
      if (this.alreadyThrew) {                                                                                         // 2312
        // We already threw an error from a previous write(). Do not throw more errors, because                        //
        // older versions of sandstorm-http-bridge do not stop on the first error and will print                       //
        // every error to the log, wasting space. Newer versions stop on the first failure.                            //
        return;                                                                                                        // 2316
      } else {                                                                                                         // 2317
        this.alreadyThrew = true;                                                                                      // 2318
        throw new Error("client disconnected");                                                                        // 2319
      }                                                                                                                // 2320
    } else {                                                                                                           // 2321
      if (this.response.write(data)) {                                                                                 // 2322
        // All written.                                                                                                //
        return;                                                                                                        // 2324
      } else {                                                                                                         // 2325
        // Write buffer is full. Don't complete until it has more space.                                               //
        return new Promise(function (resolve, reject) {                                                                // 2327
          _this13.waiting.push(resolve);                                                                               // 2328
        });                                                                                                            // 2329
      }                                                                                                                // 2330
    }                                                                                                                  // 2331
  };                                                                                                                   // 2332
                                                                                                                       //
  ResponseStream.prototype.done = function done() {                                                                    // 2248
    if (!this.started) {                                                                                               // 2335
      this.started = true;                                                                                             // 2336
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                                // 2337
    }                                                                                                                  // 2338
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2340
      this.ended = true;                                                                                               // 2341
      this.response.end();                                                                                             // 2342
    }                                                                                                                  // 2343
                                                                                                                       //
    this.close();                                                                                                      // 2345
  };                                                                                                                   // 2346
                                                                                                                       //
  ResponseStream.prototype.close = function close() {                                                                  // 2248
    if (this.upstreamHandle) {                                                                                         // 2349
      this.upstreamHandle.close();                                                                                     // 2350
    }                                                                                                                  // 2351
                                                                                                                       //
    // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                   //
    // the only case in which we can actually report the error is when we haven't done any writes                      //
    // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                           //
    // implies `!this.ended`.                                                                                          //
    if (!this.started) {                                                                                               // 2357
      this.started = true;                                                                                             // 2358
      this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });        // 2359
    }                                                                                                                  // 2361
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2363
      this.ended = true;                                                                                               // 2364
      this.response.end();                                                                                             // 2365
    }                                                                                                                  // 2366
  };                                                                                                                   // 2367
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function sendingDirectResponse() {                                  // 2248
    // For internal front-end use: Indicates that the caller is going to fill in the response                          //
    // instead. If a response has already been started, this throws an exception.                                      //
    //                                                                                                                 //
    // This is used in particular in pre-meteor.js, when dealing with static web publishing.                           //
                                                                                                                       //
    if (this.started) {                                                                                                // 2375
      throw new Error("can't sendDirectResponse() because response already started");                                  // 2376
      this.response.end();                                                                                             // 2377
    } else if (this.ended) {                                                                                           // 2378
      throw new Error("can't sendDirectResponse() because response already sent");                                     // 2379
    } else {                                                                                                           // 2380
      this.started = true;                                                                                             // 2381
      this.ended = true;                                                                                               // 2382
    }                                                                                                                  // 2383
  };                                                                                                                   // 2384
                                                                                                                       //
  return ResponseStream;                                                                                               // 2248
}();                                                                                                                   // 2248
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require('zlib');                                                                                        // 2388
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2389
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2394
  function WebSocketReceiver(socket) {                                                                                 // 2395
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2395
                                                                                                                       //
    this.socket = socket;                                                                                              // 2396
    this.queue = [];                                                                                                   // 2397
  }                                                                                                                    // 2398
                                                                                                                       //
  WebSocketReceiver.prototype.go = function go() {                                                                     // 2394
    for (var i in this.queue) {                                                                                        // 2401
      this.socket.write(this.queue[i]);                                                                                // 2402
    }                                                                                                                  // 2403
                                                                                                                       //
    this.queue = null;                                                                                                 // 2405
  };                                                                                                                   // 2406
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function sendBytes(message) {                                                // 2394
    // TODO(someday):  Flow control of some sort?                                                                      //
    if (this.queue === null) {                                                                                         // 2410
      this.socket.write(message);                                                                                      // 2411
    } else {                                                                                                           // 2412
      this.queue.push(message);                                                                                        // 2413
    }                                                                                                                  // 2414
  };                                                                                                                   // 2415
                                                                                                                       //
  WebSocketReceiver.prototype.close = function close() {                                                               // 2394
    this.socket.end();                                                                                                 // 2418
  };                                                                                                                   // 2419
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2394
}();                                                                                                                   // 2394
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2422
  var writesInFlight = 0;                                                                                              // 2423
  var readingPaused = false;                                                                                           // 2424
  socket.on('data', function (chunk) {                                                                                 // 2425
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2426
      writesInFlight--;                                                                                                // 2427
      if (readingPaused) {                                                                                             // 2428
        socket.resume();                                                                                               // 2429
        readingPaused = false;                                                                                         // 2430
      }                                                                                                                // 2431
    })["catch"](function (err) {                                                                                       // 2432
      if (err.kjType !== 'disconnected') {                                                                             // 2433
        console.error('WebSocket sendBytes failed: ' + err.stack);                                                     // 2434
      }                                                                                                                // 2435
                                                                                                                       //
      socket.destroy();                                                                                                // 2437
    });                                                                                                                // 2438
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2440
      socket.pause();                                                                                                  // 2441
      readingPaused = true;                                                                                            // 2442
    }                                                                                                                  // 2443
  });                                                                                                                  // 2444
                                                                                                                       //
  socket.on('end', function (chunk) {                                                                                  // 2446
    rpcStream.close();                                                                                                 // 2447
  });                                                                                                                  // 2448
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2450
    destructor();                                                                                                      // 2451
  });                                                                                                                  // 2452
};                                                                                                                     // 2453
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish('grainLog', function (grainId) {                                                                        // 2458
  var _this14 = this;                                                                                                  // 2458
                                                                                                                       //
  check(grainId, String);                                                                                              // 2459
  var id = 0;                                                                                                          // 2460
  var grain = Grains.findOne(grainId);                                                                                 // 2461
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2462
    this.added('grainLog', id++, { text: 'Only the grain owner can view the debug log.' });                            // 2463
    this.ready();                                                                                                      // 2464
    return;                                                                                                            // 2465
  }                                                                                                                    // 2466
                                                                                                                       //
  var connected = false;                                                                                               // 2468
  var _this = this;                                                                                                    // 2469
                                                                                                                       //
  var receiver = {                                                                                                     // 2471
    write: function write(data) {                                                                                      // 2472
      connected = true;                                                                                                // 2473
      _this.added('grainLog', id++, { text: data.toString('utf8') });                                                  // 2474
    },                                                                                                                 // 2475
    close: function close() {                                                                                          // 2477
      if (connected) {                                                                                                 // 2478
        _this.added('grainLog', id++, {                                                                                // 2479
          text: '*** lost connection to grain (probably because it shut down) ***'                                     // 2480
        });                                                                                                            // 2479
      }                                                                                                                // 2482
    }                                                                                                                  // 2483
  };                                                                                                                   // 2471
                                                                                                                       //
  try {                                                                                                                // 2486
    (function () {                                                                                                     // 2486
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2487
        return supervisor.watchLog(8192, receiver);                                                                    // 2488
      })).handle;                                                                                                      // 2489
      connected = true;                                                                                                // 2490
      _this14.onStop(function () {                                                                                     // 2491
        handle.close();                                                                                                // 2492
      });                                                                                                              // 2493
    })();                                                                                                              // 2486
  } catch (err) {                                                                                                      // 2494
    if (!connected) {                                                                                                  // 2495
      this.added('grainLog', id++, {                                                                                   // 2496
        text: '*** couldn\'t connect to grain (' + err + ') ***'                                                       // 2497
      });                                                                                                              // 2496
    }                                                                                                                  // 2499
  }                                                                                                                    // 2500
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2503
});                                                                                                                    // 2504
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 26
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 28
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 30
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 31
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 32
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 34
  var responseCallback = function responseCallback(res) {                                                              // 35
    if (res.statusCode === 200) {                                                                                      // 36
      console.log("Successfully updated sandcats IP");                                                                 // 37
    } else {                                                                                                           // 38
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 39
    }                                                                                                                  // 40
  };                                                                                                                   // 41
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 43
    console.error("Couldn't send update sandcats hostname", err);                                                      // 44
  };                                                                                                                   // 45
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 49
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 51
  var socket = dgram.createSocket("udp4");                                                                             // 52
  var secret = Random.secret(16);                                                                                      // 53
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 55
  socket.on("message", function (buf) {                                                                                // 56
    if (buf.toString() === secret) {                                                                                   // 57
      updateSandcatsIp();                                                                                              // 58
    } else {                                                                                                           // 59
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 60
    }                                                                                                                  // 61
  });                                                                                                                  // 62
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 64
    if (err) {                                                                                                         // 65
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 68
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 70
    socket.close();                                                                                                    // 71
  }, 10 * 1000);                                                                                                       // 72
};                                                                                                                     // 73
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 76
    hostname: hostname,                                                                                                // 77
    path: path,                                                                                                        // 78
    method: "POST",                                                                                                    // 79
    agent: false,                                                                                                      // 80
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 81
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 82
    headers: {                                                                                                         // 83
      "X-Sand": "cats",                                                                                                // 84
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 85
    }                                                                                                                  // 83
  };                                                                                                                   // 76
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 89
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 93
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 95
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 96
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 101
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 103
  req.write(newPostData);                                                                                              // 104
  req.end();                                                                                                           // 105
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 107
    req.on("error", errorCallback);                                                                                    // 108
  }                                                                                                                    // 109
                                                                                                                       //
  return req;                                                                                                          // 111
};                                                                                                                     // 112
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 114
  check(commonName, String);                                                                                           // 115
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 120
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 124
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = pki.createCertificationRequest();                                                                          // 127
  csr.publicKey = keys.publicKey;                                                                                      // 128
  csr.setSubject([{                                                                                                    // 129
    name: "commonName",                                                                                                // 131
    value: commonName,                                                                                                 // 132
    valueTagClass: asn1.Type.UTF8                                                                                      // 133
  }]);                                                                                                                 // 130
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 139
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 140
  return {                                                                                                             // 141
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 142
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 143
  };                                                                                                                   // 141
};                                                                                                                     // 145
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 147
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 154
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 155
  var csrFilename = keyFilename + ".csr";                                                                              // 156
  var responseFilename = keyFilename + ".response-json";                                                               // 157
  var withWildcard = "*." + hostname;                                                                                  // 158
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 159
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 160
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 162
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 167
    csrFilename: csrFilename,                                                                                          // 168
    keyFilename: keyFilename,                                                                                          // 169
    responseFilename: responseFilename                                                                                 // 170
  };                                                                                                                   // 167
};                                                                                                                     // 172
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 174
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 175
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 176
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 177
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 178
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 180
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 181
    };                                                                                                                 // 182
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 184
      if (res.statusCode == 200) {                                                                                     // 185
        (function () {                                                                                                 // 185
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 188
          res.on("data", function (chunk) {                                                                            // 189
            responseBody += chunk;                                                                                     // 190
          });                                                                                                          // 191
                                                                                                                       //
          res.on("end", function () {                                                                                  // 193
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 196
              JSON.parse(responseBody);                                                                                // 197
            } catch (e) {                                                                                              // 198
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 205
            }                                                                                                          // 206
                                                                                                                       //
            try {                                                                                                      // 208
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 209
            } catch (err) {                                                                                            // 210
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 215
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 219
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 221
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 223
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 225
            }                                                                                                          // 227
          });                                                                                                          // 228
        })();                                                                                                          // 185
      } else {                                                                                                         // 229
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 230
        res.on("data", function (chunk) {                                                                              // 232
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 233
        });                                                                                                            // 234
      }                                                                                                                // 235
    };                                                                                                                 // 236
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 238
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 240
      rawHostname: SANDCATS_NAME,                                                                                      // 241
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 242
    }, errorCallback, responseCallback);                                                                               // 240
  };                                                                                                                   // 244
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 246
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 247
    return renewHttpsCertificate();                                                                                    // 248
  }                                                                                                                    // 249
};                                                                                                                     // 250
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 252
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 253
  if (i < 0) {                                                                                                         // 254
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 257
    var oneMinute = 60 * 1000;                                                                                         // 258
    var oneHour = 60 * oneMinute;                                                                                      // 259
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 260
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 262
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 263
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 265
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 267
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 271
    }                                                                                                                  // 273
  }                                                                                                                    // 274
};                                                                                                                     // 275
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 277
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 278
};                                                                                                                     // 279
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 36
BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                           // 37
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
var Url = Npm.require("url");                                                                                          // 40
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + globalDb.makeWildcardHost("static");           // 41
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 43
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 44
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 45
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 46
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 48
  var _this = this;                                                                                                    // 48
                                                                                                                       //
  if (this.userId) {                                                                                                   // 49
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 50
      (function () {                                                                                                   // 50
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 55
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 56
          inMeteor(function () {                                                                                       // 57
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 58
          });                                                                                                          // 59
        })["catch"](function (err) {                                                                                   // 60
          if (err.kjType !== "unimplemented") {                                                                        // 61
            console.error(err.stack);                                                                                  // 62
          }                                                                                                            // 63
        });                                                                                                            // 64
      })();                                                                                                            // 50
    }                                                                                                                  // 65
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 67
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 73
    return [];                                                                                                         // 74
  }                                                                                                                    // 75
});                                                                                                                    // 76
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 78
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 82
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 83
});                                                                                                                    // 84
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 86
  return DevPackages.find();                                                                                           // 87
});                                                                                                                    // 88
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 90
  return Notifications.find({ userId: this.userId }, { fields: { timestamp: 1, text: 1, grainId: 1, userId: 1, isUnread: 1, appUpdates: 1,
      admin: 1, referral: 1, mailingListBonus: 1 } });                                                                 // 93
});                                                                                                                    // 94
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 96
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 99
  var notifications = Notifications.find({                                                                             // 100
    _id: { $in: notificationIds },                                                                                     // 101
    userId: this.userId                                                                                                // 102
  }, {                                                                                                                 // 100
    fields: { grainId: 1 }                                                                                             // 104
  });                                                                                                                  // 103
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 107
    return row.grainId;                                                                                                // 108
  });                                                                                                                  // 109
                                                                                                                       //
  return Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } });                                            // 111
});                                                                                                                    // 112
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 114
  var _this2 = this;                                                                                                   // 114
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 118
  if (cursor.count() > 0) {                                                                                            // 119
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 120
  } else {                                                                                                             // 121
    (function () {                                                                                                     // 121
      var handle = cursor.observeChanges({                                                                             // 122
        added: function added(id) {                                                                                    // 123
          _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                    // 124
          handle.stop();                                                                                               // 125
          handle = null;                                                                                               // 126
        }                                                                                                              // 127
      });                                                                                                              // 122
      _this2.onStop(function () {                                                                                      // 129
        if (handle) handle.stop();                                                                                     // 130
      });                                                                                                              // 131
    })();                                                                                                              // 121
  }                                                                                                                    // 132
                                                                                                                       //
  this.ready();                                                                                                        // 134
});                                                                                                                    // 135
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 137
  var _this3 = this;                                                                                                   // 137
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 146
    return [];                                                                                                         // 147
  }                                                                                                                    // 148
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 156
    referredBy: this.userId,                                                                                           // 157
    "profile.name": { $exists: true }                                                                                  // 158
  }, {                                                                                                                 // 156
    fields: {                                                                                                          // 160
      _id: 1,                                                                                                          // 161
      referredBy: 1,                                                                                                   // 162
      "profile.name": 1                                                                                                // 163
    }                                                                                                                  // 160
  });                                                                                                                  // 159
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 166
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function added(id, fields) {                                                                                // 168
      _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                               // 169
    },                                                                                                                 // 170
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function removed(id) {                                                                                    // 173
      _this3.removed("referralInfo", id);                                                                              // 174
    },                                                                                                                 // 175
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function modified(id, fields) {                                                                          // 177
      _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                            // 178
    }                                                                                                                  // 179
  });                                                                                                                  // 166
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 190
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 191
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 192
      stopWatchingIdentity(identityId);                                                                                // 193
    });                                                                                                                // 194
  };                                                                                                                   // 195
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 197
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 198
    if (handleForProfileName) {                                                                                        // 199
      _this3.removed("referralInfo", identityId);                                                                      // 200
      handleForProfileName.stop();                                                                                     // 201
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 203
    }                                                                                                                  // 204
  };                                                                                                                   // 205
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 207
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 208
    if (handleForProfileName) {                                                                                        // 209
      return;                                                                                                          // 210
    }                                                                                                                  // 211
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 213
      _id: identityId                                                                                                  // 214
    }, {                                                                                                               // 213
      fields: {                                                                                                        // 216
        "profile.name": 1                                                                                              // 217
      }                                                                                                                // 216
    }).observeChanges({                                                                                                // 215
      added: function added(id, fields) {                                                                              // 220
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                              // 221
      },                                                                                                               // 222
                                                                                                                       //
      changed: function changed(id, fields) {                                                                          // 224
        _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                            // 225
      },                                                                                                               // 226
                                                                                                                       //
      removed: function removed(id) {                                                                                  // 228
        stopWatchingIdentity(id);                                                                                      // 229
      }                                                                                                                // 230
    });                                                                                                                // 219
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 233
  };                                                                                                                   // 234
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 236
    _id: this.userId,                                                                                                  // 237
    referredIdentityIds: { $exists: true }                                                                             // 238
  }, {                                                                                                                 // 236
    fields: {                                                                                                          // 240
      referredIdentityIds: true                                                                                        // 241
    }                                                                                                                  // 240
  }).observeChanges({                                                                                                  // 239
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function added(id, fields) {                                                                                // 245
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 246
        // Unconditionally mark these as successful referrals and start watching.                                      //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 248
      }                                                                                                                // 250
    },                                                                                                                 // 251
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function changed(id, fields) {                                                                            // 254
      // Two major tasks.                                                                                              //
      //                                                                                                               //
      // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                             //
      //                                                                                                               //
      // 2. Look for identityIds to subscribe to.                                                                      //
                                                                                                                       //
      // Task 1. Unsubscribe where needed.                                                                             //
      var referredIdentityIdsAsObject = {};                                                                            // 262
      fields.referredIdentityIds.forEach(function (i) {                                                                // 263
        referredIdentityIdsAsObject[i] = true;                                                                         // 263
      });                                                                                                              // 263
                                                                                                                       //
      Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                    // 265
        // If the handle doesn't show up in the new list of referredIdentityIds, then remove                           //
        // info from the client & stop it on the server & make it null.                                                //
        var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                       // 268
        if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                  // 269
          stopWatchingIdentity(identityId);                                                                            // 270
        }                                                                                                              // 271
      });                                                                                                              // 272
                                                                                                                       //
      // Task 2. Subscribe where needed.                                                                               //
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 275
        // The watch... function will avoid double-creating subscriptions, so this is safe.                            //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 277
      }                                                                                                                // 278
    },                                                                                                                 // 279
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function removed() {                                                                                      // 281
      // Remove all data from client; stop all handles.                                                                //
      stopWatchingAllIdentities();                                                                                     // 283
    }                                                                                                                  // 284
  });                                                                                                                  // 243
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 288
    stopWatchingAllIdentities();                                                                                       // 289
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 290
    completedIdentityIdsHandle.stop();                                                                                 // 291
  });                                                                                                                  // 292
                                                                                                                       //
  this.ready();                                                                                                        // 294
});                                                                                                                    // 295
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 297
  var _this4 = this;                                                                                                   // 297
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 298
  var anonCount = 0;                                                                                                   // 299
  var counter = 0;                                                                                                     // 300
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 302
    name = name.trim();                                                                                                // 303
    if (name === "") {                                                                                                 // 304
      ++anonCount;                                                                                                     // 305
    } else {                                                                                                           // 306
      _this4.added("backers", counter++, { name: name });                                                              // 307
    }                                                                                                                  // 308
  });                                                                                                                  // 309
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 312
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 314
                                                                                                                       //
  this.ready();                                                                                                        // 316
});                                                                                                                    // 317
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function useSignupKey(key) {                                                                           // 26
    check(key, String);                                                                                                // 27
                                                                                                                       //
    if (!this.userId) {                                                                                                // 29
      throw new Meteor.Error(403, "Must be signed in.");                                                               // 30
    }                                                                                                                  // 31
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 33
    if (user.signupKey) {                                                                                              // 34
      // Don't waste it.                                                                                               //
      return;                                                                                                          // 36
    }                                                                                                                  // 37
                                                                                                                       //
    if (isDemoUser()) {                                                                                                // 39
      throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");             // 40
    }                                                                                                                  // 42
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 44
      // Don't consume signup key as identity user.                                                                    //
      return;                                                                                                          // 46
    }                                                                                                                  // 47
                                                                                                                       //
    var keyInfo = SignupKeys.findOne(key);                                                                             // 49
    if (!keyInfo || keyInfo.used) {                                                                                    // 50
      throw new Meteor.Error(403, "Invalid key or already used.");                                                     // 51
    }                                                                                                                  // 52
                                                                                                                       //
    if (isSignedUp() && user.payments && user.payments.id) {                                                           // 54
      // This user is already signed up with a payment account. Possibly, they signed up before                        //
      // using their invite, and then went back and clicked on the invite. As a result they                            //
      // probably now have two payment accounts. Mark this invite as used but also add a special                       //
      // flag so we can find it later and cancel the dupe payment account. Record who tried to                         //
      // use it so that we can transfer credits over if needed.                                                        //
      SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                       // 60
      return;                                                                                                          // 61
    }                                                                                                                  // 62
                                                                                                                       //
    var userFields = {                                                                                                 // 64
      signupKey: key,                                                                                                  // 65
      signupNote: keyInfo.note                                                                                         // 66
    };                                                                                                                 // 64
    if (keyInfo.email) {                                                                                               // 68
      userFields.signupEmail = keyInfo.email;                                                                          // 69
    }                                                                                                                  // 70
                                                                                                                       //
    if ("quota" in keyInfo) {                                                                                          // 72
      userFields.quota = keyInfo.quota;                                                                                // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (keyInfo.plan) {                                                                                                // 76
      userFields.plan = keyInfo.plan;                                                                                  // 77
    }                                                                                                                  // 78
                                                                                                                       //
    if (keyInfo.payments) {                                                                                            // 80
      userFields["payments.id"] = keyInfo.payments.id;                                                                 // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Meteor.users.update(this.userId, { $set: userFields });                                                            // 84
    SignupKeys.update(key, { $set: { used: true } });                                                                  // 85
  }                                                                                                                    // 86
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    console.log("resetting oauth");                                                                                    // 29
    Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                                 // 30
      if (!!setting.value) {                                                                                           // 31
        Settings.update({ _id: setting._id }, { $set: { value: false,                                                  // 32
            automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                         // 34
      }                                                                                                                // 35
    });                                                                                                                // 36
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 37
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 38
  }                                                                                                                    // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 17
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 19
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 22
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 24
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 26
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 27
};                                                                                                                     // 28
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 30
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 32
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 36
    expires: { $exists: false },                                                                                       // 37
    loginIdentities: { $exists: true },                                                                                // 38
    lastActive: timeConstraint                                                                                         // 39
  }).count();                                                                                                          // 36
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 44
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 50
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 52
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 57
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 60
    $group: {                                                                                                          // 63
      _id: "$appId",                                                                                                   // 64
      grains: { $sum: 1 },                                                                                             // 65
      userIds: { $addToSet: "$userId" }                                                                                // 66
    }                                                                                                                  // 63
  }, {                                                                                                                 // 62
    $project: {                                                                                                        // 70
      grains: 1,                                                                                                       // 71
      owners: { $size: "$userIds" }                                                                                    // 72
    }                                                                                                                  // 70
  }]);                                                                                                                 // 69
  apps = _.indexBy(apps, "_id");                                                                                       // 76
                                                                                                                       //
  for (var appId in apps) {                                                                                            // 78
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 88
    delete app._id;                                                                                                    // 89
    var grains = Grains.find({                                                                                         // 90
      lastUsed: timeConstraint,                                                                                        // 91
      appId: appId                                                                                                     // 92
    }, {                                                                                                               // 90
      fields: { _id: 1 }                                                                                               // 94
    }).fetch();                                                                                                        // 93
    var grainIds = _.pluck(grains, "_id");                                                                             // 96
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 98
      $match: {                                                                                                        // 100
        "owner.user": { $exists: true },                                                                               // 101
        lastUsed: timeConstraint,                                                                                      // 102
        grainId: { $in: grainIds }                                                                                     // 103
      }                                                                                                                // 100
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 99
      $group: {                                                                                                        // 108
        _id: "count",                                                                                                  // 109
        count: { $sum: 1 }                                                                                             // 110
      }                                                                                                                // 108
    }]);                                                                                                               // 107
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 115
      if (counts.length !== 1) {                                                                                       // 116
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 117
      }                                                                                                                // 118
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 120
    }                                                                                                                  // 121
  }                                                                                                                    // 122
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 125
    $match: {                                                                                                          // 127
      lastActive: timeConstraint,                                                                                      // 128
      appId: { $exists: true }                                                                                         // 129
    }                                                                                                                  // 127
  }, {                                                                                                                 // 126
    $group: {                                                                                                          // 133
      _id: {                                                                                                           // 134
        appId: "$appId",                                                                                               // 135
        type: "$type"                                                                                                  // 136
      },                                                                                                               // 134
      count: { $sum: 1 }                                                                                               // 138
    }                                                                                                                  // 133
  }]).forEach(function (deletion) {                                                                                    // 132
    var app = apps[deletion._id.appId];                                                                                // 142
    if (!app) {                                                                                                        // 143
      app = apps[deletion.appId] = {};                                                                                 // 144
    }                                                                                                                  // 145
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 147
      app.appDemoUsers = deletion.count;                                                                               // 148
    } else if (deletion._id.type === "grain") {                                                                        // 149
      app.deleted = deletion.count;                                                                                    // 150
    } else if (deletion._id.type === "demoGrain") {                                                                    // 151
      app.demoed = deletion.count;                                                                                     // 152
    }                                                                                                                  // 153
  });                                                                                                                  // 154
                                                                                                                       //
  return {                                                                                                             // 156
    activeUsers: currentlyActiveUsersCount,                                                                            // 157
    demoUsers: deletedDemoUsersCount,                                                                                  // 158
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 159
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 160
    apps: apps                                                                                                         // 161
  };                                                                                                                   // 156
};                                                                                                                     // 163
                                                                                                                       //
function recordStats() {                                                                                               // 165
  var now = new Date();                                                                                                // 166
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 174
    timestamp: now,                                                                                                    // 175
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 176
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 177
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 178
    forever: computeStats(new Date(0)),                                                                                // 179
    plans: planStats                                                                                                   // 180
  };                                                                                                                   // 174
  record.computeTime = Date.now() - now;                                                                               // 182
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 184
  var age = ActivityStats.find().count();                                                                              // 185
  if (age > 3) {                                                                                                       // 186
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 187
    if (!reportSetting) {                                                                                              // 188
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info.", "/admin/stats");
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 192
    } else if (reportSetting.value === true) {                                                                         // 193
      // The stats page which the user agreed we can send actually displays the whole history                          //
      // of the server, but we're only sending stats from the last day. Let's also throw in the                        //
      // length of said history. This is still strictly less information than what the user said                       //
      // we're allowed to send.                                                                                        //
      record.serverAge = age;                                                                                          // 198
                                                                                                                       //
      HTTP.post("https://alpha-api.sandstorm.io/data", {                                                               // 200
        data: record,                                                                                                  // 201
        headers: {                                                                                                     // 202
          Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                         // 203
          "Content-Type": "application/json"                                                                           // 204
        }                                                                                                              // 202
      });                                                                                                              // 200
    }                                                                                                                  // 207
  }                                                                                                                    // 208
}                                                                                                                      // 209
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 211
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 214
    Meteor.setInterval(function () {                                                                                   // 215
      recordStats();                                                                                                   // 216
    }, DAY_MS);                                                                                                        // 217
                                                                                                                       //
    recordStats();                                                                                                     // 219
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 220
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 222
    if (StatsTokens.find().count() === 0) {                                                                            // 223
      StatsTokens.remove({});                                                                                          // 224
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 225
    }                                                                                                                  // 226
  });                                                                                                                  // 227
}                                                                                                                      // 228
                                                                                                                       //
Meteor.methods({                                                                                                       // 230
  regenerateStatsToken: function regenerateStatsToken() {                                                              // 231
    if (!isAdmin()) {                                                                                                  // 232
      throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                               // 233
    }                                                                                                                  // 234
                                                                                                                       //
    StatsTokens.remove({});                                                                                            // 236
    var token = StatsTokens.insert({ _id: Random.id(22) });                                                            // 237
    return token._id;                                                                                                  // 238
  }                                                                                                                    // 239
});                                                                                                                    // 230
                                                                                                                       //
Router.map(function () {                                                                                               // 242
  this.route("fetchStats", {                                                                                           // 243
    where: "server",                                                                                                   // 244
    path: "/fetchStats/:tokenId",                                                                                      // 245
    action: function action() {                                                                                        // 246
      var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                   // 247
                                                                                                                       //
      if (!token) {                                                                                                    // 249
        this.response.writeHead(404, {                                                                                 // 250
          "Content-Type": "text/plain"                                                                                 // 251
        });                                                                                                            // 250
        this.response.write("Token not found");                                                                        // 253
        return this.response.end();                                                                                    // 254
      }                                                                                                                // 255
                                                                                                                       //
      try {                                                                                                            // 257
        var stats = ActivityStats.find().fetch();                                                                      // 258
        var statsString = JSON.stringify(stats);                                                                       // 259
                                                                                                                       //
        this.response.writeHead(200, {                                                                                 // 261
          "Content-Type": "application/json"                                                                           // 262
        });                                                                                                            // 261
        this.response.write(statsString);                                                                              // 264
      } catch (error) {                                                                                                // 265
        console.error(error.stack);                                                                                    // 266
        this.response.writeHead(500, {                                                                                 // 267
          "Content-Type": "text/plain"                                                                                 // 268
        });                                                                                                            // 267
        this.response.write(error.stack);                                                                              // 270
      }                                                                                                                // 271
                                                                                                                       //
      return this.response.end();                                                                                      // 273
    }                                                                                                                  // 274
  });                                                                                                                  // 243
});                                                                                                                    // 276
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"lib":{"db-deprecated.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// lib/db-deprecated.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
globalDb = new SandstormDb();                                                                                          // 26
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 28
DevPackages = globalDb.collections.devPackages;                                                                        // 29
UserActions = globalDb.collections.userActions;                                                                        // 30
Grains = globalDb.collections.grains;                                                                                  // 31
Contacts = globalDb.collections.contacts;                                                                              // 32
Sessions = globalDb.collections.sessions;                                                                              // 33
SignupKeys = globalDb.collections.signupKeys;                                                                          // 34
ActivityStats = globalDb.collections.activityStats;                                                                    // 35
DeleteStats = globalDb.collections.deleteStats;                                                                        // 36
FileTokens = globalDb.collections.fileTokens;                                                                          // 37
ApiTokens = globalDb.collections.apiTokens;                                                                            // 38
Notifications = globalDb.collections.notifications;                                                                    // 39
StatsTokens = globalDb.collections.statsTokens;                                                                        // 40
Misc = globalDb.collections.misc;                                                                                      // 41
Settings = globalDb.collections.settings;                                                                              // 42
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 44
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 45
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 46
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 47
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 48
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 49
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 50
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 51
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 52
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 53
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 54
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 55
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 56
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 58
  getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                       // 59
                                                                                                                       //
  Meteor.onConnection(function (connection) {                                                                          // 61
    // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                         //
    //   packages to actually use the DB, but it's pretty sad.                                                         //
    connection.sandstormDb = globalDb;                                                                                 // 64
  });                                                                                                                  // 65
  SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                   // 66
  SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                       // 67
    SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                  // 68
  });                                                                                                                  // 69
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 71
    globalDb.migrateToLatest();                                                                                        // 71
  });                                                                                                                  // 71
  LDAP_DEFAULTS.url = globalDb.getLdapUrl();                                                                           // 72
  LDAP_DEFAULTS.base = globalDb.getLdapBase();                                                                         // 73
}                                                                                                                      // 74
                                                                                                                       //
if (Meteor.isClient) {                                                                                                 // 76
  Session.setDefault("shrink-navbar", false);                                                                          // 77
  globalGrains = new GrainViewList(globalDb);                                                                          // 78
                                                                                                                       //
  // If Meteor._localStorage disappears, we'll have to write our own localStorage wrapper, I guess.                    //
  // Using window.localStorage is dangerous because it throws an exception if cookies are disabled.                    //
  Session.set("shrink-navbar", Meteor._localStorage.getItem("shrink-navbar") === "true");                              // 82
  globalTopbar = new SandstormTopbar(globalDb, {                                                                       // 83
    get: function get() {                                                                                              // 85
      return Session.get("topbar-expanded");                                                                           // 86
    },                                                                                                                 // 87
    set: function set(value) {                                                                                         // 89
      Session.set("topbar-expanded", value);                                                                           // 90
    }                                                                                                                  // 91
  }, globalGrains, {                                                                                                   // 84
    get: function get() {                                                                                              // 95
      return Session.get("shrink-navbar");                                                                             // 96
    },                                                                                                                 // 97
    set: function set(value) {                                                                                         // 99
      Meteor._localStorage.setItem("shrink-navbar", value);                                                            // 100
      Session.set("shrink-navbar", value);                                                                             // 101
    }                                                                                                                  // 102
  });                                                                                                                  // 94
                                                                                                                       //
  globalAccountsUi = new AccountsUi(globalDb);                                                                         // 105
                                                                                                                       //
  Template.registerHelper("globalTopbar", function () {                                                                // 107
    return globalTopbar;                                                                                               // 107
  });                                                                                                                  // 107
  Template.registerHelper("globalAccountsUi", function () {                                                            // 108
    return globalAccountsUi;                                                                                           // 108
  });                                                                                                                  // 108
} else {                                                                                                               // 109
  // TODO(cleanup): Refactor accounts registration stuff so that this doesn't need to be defined                       //
  //   at all on the server.                                                                                           //
  globalAccountsUi = null;                                                                                             // 112
}                                                                                                                      // 113
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"demo.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// lib/demo.js                                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Used in both client/demo.js and server/demo.js, as well as install.js                                               //
allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;               // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"imports":{"server":{"auth.js":["meteor/meteor","meteor/check","crypto","fs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 7
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 8
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 10
  if (tokenIsSetupSession(token)) {                                                                                    // 11
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 12
    globalDb.collections.setupSession.remove({                                                                         // 13
      _id: "current-session",                                                                                          // 14
      hashedSessionId: hash                                                                                            // 15
    });                                                                                                                // 13
  }                                                                                                                    // 17
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 19
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 20
    console.log("Admin token deleted.");                                                                               // 21
  }                                                                                                                    // 22
}                                                                                                                      // 23
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 25
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 26
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 27
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 28
    if (stats.mtime < expireTime) {                                                                                    // 29
      return false;                                                                                                    // 30
    } else {                                                                                                           // 31
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 32
    }                                                                                                                  // 33
  } else {                                                                                                             // 34
    return false;                                                                                                      // 35
  }                                                                                                                    // 36
}                                                                                                                      // 37
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 39
  if (token) {                                                                                                         // 40
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 41
    if (setupSession) {                                                                                                // 42
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 43
      var now = new Date();                                                                                            // 44
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 45
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 46
        return true;                                                                                                   // 47
      }                                                                                                                // 48
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  return false;                                                                                                        // 52
}                                                                                                                      // 53
                                                                                                                       //
function checkAuth(token) {                                                                                            // 55
  check(token, Match.OneOf(undefined, null, String));                                                                  // 56
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 57
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 58
  }                                                                                                                    // 59
}                                                                                                                      // 60
                                                                                                                       //
                                                                                                                       // 62
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 17
  var setting = Settings.findOne({ _id: name });                                                                       // 18
  return setting && !!setting.value;                                                                                   // 19
}                                                                                                                      // 20
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 22
  isEnabled: function isEnabled() {                                                                                    // 23
    return serviceEnabled("github");                                                                                   // 24
  },                                                                                                                   // 25
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 27
    return identity.services.github.username;                                                                          // 28
  },                                                                                                                   // 29
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 31
    Meteor.loginWithGithub();                                                                                          // 32
    return { oneClick: true };                                                                                         // 33
  },                                                                                                                   // 34
                                                                                                                       //
  loginTemplate: {                                                                                                     // 36
    name: "oauthLoginButton",                                                                                          // 37
    priority: 1,                                                                                                       // 38
    data: {                                                                                                            // 39
      method: "loginWithGithub",                                                                                       // 40
      name: "github",                                                                                                  // 41
      displayName: "GitHub",                                                                                           // 42
      linkingNewIdentity: false                                                                                        // 43
    }                                                                                                                  // 39
  }                                                                                                                    // 36
};                                                                                                                     // 22
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 48
  isEnabled: function isEnabled() {                                                                                    // 49
    return serviceEnabled("google");                                                                                   // 50
  },                                                                                                                   // 51
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 53
    return identity.services.google.email;                                                                             // 54
  },                                                                                                                   // 55
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 57
    Meteor.loginWithGoogle({ loginHint: loginId });                                                                    // 58
    return { oneClick: true };                                                                                         // 59
  },                                                                                                                   // 60
                                                                                                                       //
  loginTemplate: {                                                                                                     // 62
    name: "oauthLoginButton",                                                                                          // 63
    priority: 2,                                                                                                       // 64
    data: {                                                                                                            // 65
      method: "loginWithGoogle",                                                                                       // 66
      name: "google",                                                                                                  // 67
      displayName: "Google",                                                                                           // 68
      linkingNewIdentity: false                                                                                        // 69
    }                                                                                                                  // 65
  }                                                                                                                    // 62
};                                                                                                                     // 48
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 74
  isEnabled: function isEnabled() {                                                                                    // 75
    return serviceEnabled("emailToken");                                                                               // 76
  },                                                                                                                   // 77
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 79
    return identity.services.email.email;                                                                              // 80
  },                                                                                                                   // 81
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 83
    return { form: true };                                                                                             // 84
  },                                                                                                                   // 85
                                                                                                                       //
  loginTemplate: {                                                                                                     // 87
    name: "emailLoginForm",                                                                                            // 88
    priority: 10                                                                                                       // 89
  }                                                                                                                    // 87
};                                                                                                                     // 74
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 93
  isEnabled: function isEnabled() {                                                                                    // 94
    return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                     // 95
  },                                                                                                                   // 96
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 98
    return identity.services.ldap.username;                                                                            // 99
  },                                                                                                                   // 100
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 102
    return { form: true };                                                                                             // 103
  },                                                                                                                   // 104
                                                                                                                       //
  loginTemplate: {                                                                                                     // 106
    name: "ldapLoginForm",                                                                                             // 107
    priority: 21 }                                                                                                     // 108
};                                                                                                                     // 93
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 112
  isEnabled: function isEnabled() {                                                                                    // 113
    return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                     // 114
  },                                                                                                                   // 115
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 117
    return identity.services.saml.id;                                                                                  // 118
  },                                                                                                                   // 119
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 121
    Meteor.loginWithSaml();                                                                                            // 122
    return { oneClick: true };                                                                                         // 123
  },                                                                                                                   // 124
                                                                                                                       //
  loginTemplate: {                                                                                                     // 126
    name: "samlLoginForm",                                                                                             // 127
    priority: 20 }                                                                                                     // 128
};                                                                                                                     // 112
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 132
  isEnabled: function isEnabled() {                                                                                    // 133
    return false; // You can never authenticate as a demo user.                                                        // 134
  },                                                                                                                   // 135
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 137
    return identity._id;                                                                                               // 138
  },                                                                                                                   // 139
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 141
    return { demoCannotLogin: true };                                                                                  // 142
  },                                                                                                                   // 143
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 145
};                                                                                                                     // 132
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function isEnabled() {                                                                                    // 18
    return globalDb.allowDevAccounts();                                                                                // 19
  },                                                                                                                   // 20
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 22
    return identity.services.dev.name;                                                                                 // 23
  },                                                                                                                   // 24
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 26
    loginDevAccount(loginId);                                                                                          // 27
    return { oneClick: true };                                                                                         // 28
  },                                                                                                                   // 29
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function isSafeDemoAppUrl(url) {                                                                    // 17
    // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)                   //
    // and we allow specifying a sandstorm.io URL.                                                                     //
    return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
};                                                                                                                     // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function createMockGithubUser() {                                                        // 35
          Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 39
                                                                                                                       //
        clearMockGithubUser: function clearMockGithubUser() {                                                          // 41
          clearUser("Py8fwsaryQNGBuiXb");                                                                              // 42
        },                                                                                                             // 43
                                                                                                                       //
        createMockGoogleUser: function createMockGoogleUser() {                                                        // 45
          Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 49
                                                                                                                       //
        clearMockGoogleUser: function clearMockGoogleUser() {                                                          // 51
          clearUser("6WJcRo2gg2Ysuxsok");                                                                              // 52
        }                                                                                                              // 53
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 55
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 57
    Meteor.call("createMockGithubUser", function (err) {                                                               // 58
      if (err) {                                                                                                       // 59
        console.log(err);                                                                                              // 60
      }                                                                                                                // 61
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 63
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 64
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 65
      window.location.reload();                                                                                        // 66
    });                                                                                                                // 67
  };                                                                                                                   // 68
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 70
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 71
      if (err) {                                                                                                       // 72
        console.log(err);                                                                                              // 73
      }                                                                                                                // 74
    });                                                                                                                // 75
  };                                                                                                                   // 76
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 78
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 79
      if (err) {                                                                                                       // 80
        console.log(err);                                                                                              // 81
      }                                                                                                                // 82
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 84
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 85
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 86
      window.location.reload();                                                                                        // 87
    });                                                                                                                // 88
  };                                                                                                                   // 89
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 91
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 92
      if (err) {                                                                                                       // 93
        console.log(err);                                                                                              // 94
      }                                                                                                                // 95
    });                                                                                                                // 96
  };                                                                                                                   // 97
}                                                                                                                      // 98
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/lib/constants.js");
require("./lib/db-deprecated.js");
require("./lib/demo.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
